// ************************************************************************ //
//                                                                          //
// GKit Image Edit Control Borland Edition                                  //
//                                                                          //
// GKitImageEdit.h Copyright (c) FUJITSU SHIZUOKA ENGINEERING LIMITED 1999  //
//                                                                          //
// ************************************************************************ //

// C++ TLBWRTR : $Revision:   1.96.1.27  $
// File generated on 99/03/04 14:25:36 from Type Library described below.

// ************************************************************************ //
// Type Lib: C:\FFC\GKITOCX.BE\MEDIATOOLS\GKMBIEDT.OCX
// IID\LCID: {AD8272C5-BB9E-11D2-AE18-00000E4E0F41}\0
// Helpfile: C:\FFC\GKITOCX.BE\MEDIATOOLS\GKMBIEDT.hlp
// DepndLst: 
//   (1) v2.0 stdole, (C:\WINDOWS\SYSTEM\STDOLE2.TLB)
//   (2) v4.0 StdVCL, (C:\WINDOWS\SYSTEM\STDVCL40.DLL)
//   (3) v2.0 StdType, (C:\WINDOWS\SYSTEM\OLEPRO32.DLL)
// ************************************************************************ //
#ifndef   __GKMBIEDTLib_OCX_h__
#define   __GKMBIEDTLib_OCX_h__

#pragma option push -b -w-inl

#include <vcl/utilcls.h>
#if !defined(__UTILCLS_H_VERSION) || (__UTILCLS_H_VERSION < 0x0101)
#error "This file requires an newer version of the header file UTILCLS.H"
#endif

#include <olectl.h>
#include <ocidl.h>
#if !defined(_NO_VCL)   // For Console applications that don't use VCL
#include <vcl/stdvcl.hpp>
#endif  //   _NO_VCL
#include <vcl/ocxproxy.h>

//#include "GKMBIEDTLib_TLB.h"

// C++ TLBWRTR : $Revision:   1.96.1.27  $
// File generated on 99/03/04 14:25:36 from Type Library described below.

// ************************************************************************ //
// Type Lib: C:\FFC\GKITOCX.BE\MEDIATOOLS\GKMBIEDT.OCX
// IID\LCID: {AD8272C5-BB9E-11D2-AE18-00000E4E0F41}\0
// Helpfile: C:\FFC\GKITOCX.BE\MEDIATOOLS\GKMBIEDT.hlp
// DepndLst: 
//   (1) v2.0 stdole, (C:\WINDOWS\SYSTEM\STDOLE2.TLB)
//   (2) v4.0 StdVCL, (C:\WINDOWS\SYSTEM\STDVCL40.DLL)
//   (3) v2.0 StdType, (C:\WINDOWS\SYSTEM\OLEPRO32.DLL)
// ************************************************************************ //
//#ifndef   __GKMBIEDTLib_TLB_h__
//#define   __GKMBIEDTLib_TLB_h__

#pragma option push -b -w-inl

#include <vcl/utilcls.h>
#if !defined(__UTILCLS_H_VERSION) || (__UTILCLS_H_VERSION < 0x0101)
#error "This file requires an newer version of the header file UTILCLS.H"
#endif

#include <olectl.h>
#include <ocidl.h>
#if defined(USING_ATLVCL) || defined(USING_ATL)
#if !defined(__TLB_NO_EVENT_WRAPPERS)
#include <atl/atlmod.h>
#endif
#endif


// *********************************************************************//
// Forward reference of some VCL types (to avoid including STDVCL.HPP)  //
// *********************************************************************//
namespace Stdvcl {class IStrings; class IStringsDisp;}
using namespace Stdvcl;

namespace Gkmbiedtlib_tlb
{

// *********************************************************************//
// HelpString: GKit Image Edit Control Borland Edition
// Version:    2.0
// *********************************************************************//


// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:      //
//   Type Libraries     : LIBID_xxxx                                    //
//   CoClasses          : CLSID_xxxx                                    //
//   DISPInterfaces     : DIID_xxxx                                     //
//   Non-DISP interfaces: IID_xxxx                                      //
// *********************************************************************//
DEFINE_GUID(LIBID_GKMBIEDTLib, 0xAD8272C5, 0xBB9E, 0x11D2, 0xAE, 0x18, 0x00, 0x00, 0x0E, 0x4E, 0x0F, 0x41);
DEFINE_GUID(DIID__DImageEdit, 0xAD8272C6, 0xBB9E, 0x11D2, 0xAE, 0x18, 0x00, 0x00, 0x0E, 0x4E, 0x0F, 0x41);
DEFINE_GUID(DIID__DImageEditEvents, 0xAD8272C7, 0xBB9E, 0x11D2, 0xAE, 0x18, 0x00, 0x00, 0x0E, 0x4E, 0x0F, 0x41);
DEFINE_GUID(CLSID_ImageEdit, 0xAD8272C8, 0xBB9E, 0x11D2, 0xAE, 0x18, 0x00, 0x00, 0x0E, 0x4E, 0x0F, 0x41);

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                  //
// *********************************************************************//
enum      CommonConstants;
enum      MediaFormatConstants;
enum      CompressionConstants;
enum      ImageColorConstants;
enum      InterlaceConstants;
enum      RotateConstants;
enum      DirectionConstants;
enum      VertPosConstants;
enum      HorzPosConstants;
enum      MorphologyConstants;
enum      InterpolationConstants;
enum      ReductionConstants;
enum      CalculateConstants;
enum      InputSourceConstants;
enum      InputUnitConstants;
enum      TwainPaperSizeConstants;
enum      PcdDataSizeConstants;
enum      ErrorConstants;
interface DECLSPEC_UUID("{AD8272C6-BB9E-11D2-AE18-00000E4E0F41}") _DImageEdit;
interface DECLSPEC_UUID("{AD8272C7-BB9E-11D2-AE18-00000E4E0F41}") _DImageEditEvents;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                     //
// (NOTE: Here we map each CoClass to its Default Interface)            //
//                                                                      //
// The LIBID_OF_ macro(s) map a LIBID_OF_CoClassName to the GUID of this//
// TypeLibrary. It simplifies the updating of macros when CoClass name  //
// change.                                                              //
// *********************************************************************//
typedef _DImageEdit ImageEdit;

#define LIBID_OF_ImageEdit (&LIBID_GKMBIEDTLib)

// *********************************************************************//
// Declaration of Enumerations defined in Type Library                  //
// *********************************************************************//
typedef enum CommonConstants
{
  cwmUnknown = 0xFFFFFFFF
} CommonConstants;

typedef enum MediaFormatConstants
{
  cwmFileBMP = 101, 
  cwmFileTIFF = 102, 
  cwmFileJPEG = 103, 
  cwmFilePCX = 104, 
  cwmFilePNG = 106, 
  cwmFileSIA = 107
} MediaFormatConstants;

typedef enum CompressionConstants
{
  cwmCompNone = 1, 
  cwmCompRLE = 101, 
  cwmCompPackbits = 202, 
  cwmCompHuffman = 203, 
  cwmCompMH = 204, 
  cwmCompMR = 205, 
  cwmCompMMR = 206
} CompressionConstants;

typedef enum ImageColorConstants
{
  cwmColorBitmap = 1, 
  cwmColor4 = 2, 
  cwmColor8 = 3, 
  cwmColor16 = 4, 
  cwmColor32 = 5, 
  cwmColor64 = 6, 
  cwmColor128 = 7, 
  cwmColor256 = 8, 
  cwmColorGrayscale = 9, 
  cwmColor32K = 10, 
  cwmColor64K = 11, 
  cwmColorRGB = 12
} ImageColorConstants;

typedef enum InterlaceConstants
{
  cwmInterlaceNone = 1, 
  cwmInterlaced = 2
} InterlaceConstants;

typedef enum RotateConstants
{
  cwmRotate0 = 0, 
  cwmRotate90 = 1, 
  cwmRotate180 = 2, 
  cwmRotate270 = 3
} RotateConstants;

typedef enum DirectionConstants
{
  cwmDirectionBoth = 1, 
  cwmDirectionHorz = 2, 
  cwmDirectionVert = 3
} DirectionConstants;

typedef enum VertPosConstants
{
  cwmVertPosTop = 2, 
  cwmVertPosCenter = 1, 
  cwmVertPosBottom = 3
} VertPosConstants;

typedef enum HorzPosConstants
{
  cwmHorzPosLeft = 4, 
  cwmHorzPosCenter = 1, 
  cwmHorzPosRight = 5
} HorzPosConstants;

typedef enum MorphologyConstants
{
  cwmMorphologyNone = 1, 
  cwmMorphologyOn = 2, 
  cwmMorphologyOff = 3
} MorphologyConstants;

typedef enum InterpolationConstants
{
  cwmInterNearest = 1, 
  cwmInterBilinear = 2, 
  cwmInterBSpline = 3, 
  cwmInterConvolution = 4
} InterpolationConstants;

typedef enum ReductionConstants
{
  cwmReductionDiffusion = 1, 
  cwmReductionPattern = 2, 
  cwmReductionNone = 3, 
  cwmReductionThreshold = 4
} ReductionConstants;

typedef enum CalculateConstants
{
  cwmCalcAdd = 1, 
  cwmCalcSubtract = 2, 
  cwmCalcMultiply = 3, 
  cwmCalcDivide = 4, 
  cwmCalcOr = 5, 
  cwmCalcAnd = 6, 
  cwmCalcNor = 7, 
  cwmCalcNand = 8, 
  cwmCalcXor = 9, 
  cwmCalcDarker = 10, 
  cwmCalcLighter = 11, 
  cwmCalcDifference = 12
} CalculateConstants;

typedef enum InputSourceConstants
{
  cwmSrcFile = 1, 
  cwmSrcTwain = 2, 
  cwmSrcPhotoCD = 3
} InputSourceConstants;

typedef enum InputUnitConstants
{
  cwmUnitPixel = 1, 
  cwmUnitInch = 2, 
  cwmUnitCentimeter = 3
} InputUnitConstants;

typedef enum TwainPaperSizeConstants
{
  cwmSizeDefault = 0, 
  cwmSizeMaximum = 1, 
  cwmSizeUserDefined = 2, 
  cwmSizePortA3 = 3, 
  cwmSizePortA4 = 4, 
  cwmSizePortA5 = 5, 
  cwmSizePortB4 = 6, 
  cwmSizePortB5 = 7, 
  cwmSizeLandA3 = 8, 
  cwmSizeLandA4 = 9, 
  cwmSizeLandA5 = 10, 
  cwmSizeLandB4 = 11, 
  cwmSizeLandB5 = 12, 
  cwmSizeLetter = 13, 
  cwmSizeLegal = 14, 
  cwmSizePortPostcard = 15, 
  cwmSizeLandPostcard = 16
} TwainPaperSizeConstants;

typedef enum PcdDataSizeConstants
{
  cwmPcdResBaseOver64 = 1, 
  cwmPcdResBaseOver16 = 2, 
  cwmPcdResBaseOver4 = 3, 
  cwmPcdResBase = 4, 
  cwmPcdRes4Base = 5, 
  cwmPcdRes16Base = 6, 
  cwmPcdRes64Base = 7
} PcdDataSizeConstants;

typedef enum ErrorConstants
{
  cwmSuccess = 0, 
  cwmErrInvalidParam = 1001, 
  cwmErrInvalidRectValue = 1002, 
  cwmErrInvalidIndex = 1003, 
  cwmErrInvalidCompression = 1010, 
  cwmErrInvalidColorDepth = 1011, 
  cwmErrInvalidSaveFormat = 1012, 
  cwmErrSequenceError = 1100, 
  cwmErrUnsetMediaData = 1101, 
  cwmErrUserAbort = 1110, 
  cwmErrAcquireNotComplete = 1111, 
  cwmErrNotSupportFileFormat = 2000, 
  cwmErrInvalidFileFormat = 2001, 
  cwmErrFileNotFound = 2110, 
  cwmErrFileAlreadyExists = 2111, 
  cwmErrPathNotFound = 2112, 
  cwmErrFileLoadIncomplete = 2113, 
  cwmErrFileIOError = 2120, 
  cwmErrDiskFull = 2130, 
  cwmErrClipboardError = 2200, 
  cwmErrClipboardInvalidFormat = 2201, 
  cwmErrPrtError = 7000, 
  cwmErrPrtAppAbort = 7001, 
  cwmErrPrtUserAbort = 7002, 
  cwmErrDeviceError = 8000, 
  cwmErrDeviceNotFound = 8001, 
  cwmErrDeviceNotInstall = 8002, 
  cwmErrCDDriveNotFound = 8003, 
  cwmErrDeviceBusy = 8010, 
  cwmErrOutofMemory = 9000, 
  cwmErrSystemError = 9900, 
  cwmErrSystemNotFound = 9910, 
  cwmErrTwainDllNotFound = 9911, 
  cwmErrPcdLibNotFound = 9912
} ErrorConstants;

// *********************************************************************//
// Interface: _DImageEdit
// Flags:     (4112) Hidden Dispatchable
// GUID:      {AD8272C6-BB9E-11D2-AE18-00000E4E0F41}
// *********************************************************************//
interface _DImageEdit : public IDispatch
{
// DispInterfaces have no methods. Their methods and properties are
// accessed via IDispatch::Invoke. See the class _DImageEditDisp provided
// below for an easy way to access the methods/properties of this
// interface.
};

// *********************************************************************//
// Interface: _DImageEditEvents
// Flags:     (4096) Dispatchable
// GUID:      {AD8272C7-BB9E-11D2-AE18-00000E4E0F41}
// *********************************************************************//
interface _DImageEditEvents : public IDispatch
{
// DispInterfaces have no methods. Their methods and properties are
// accessed via IDispatch::Invoke. See the class _DImageEditEventsDisp provided
// below for an easy way to access the methods/properties of this
// interface.
};

#if !defined(__TLB_NO_INTERFACE_WRAPPERS)
// *********************************************************************//
// DispIntf:  _DImageEdit
// Flags:     (4112) Hidden Dispatchable
// GUID:      {AD8272C6-BB9E-11D2-AE18-00000E4E0F41}
// *********************************************************************//
template<class T>
class _DImageEditDispT : public TAutoDriver<_DImageEdit>
{
public:
  _DImageEditDispT(){}

  _DImageEditDispT(_DImageEdit *pintf)
  {
    TAutoDriver<_DImageEdit>::Bind(pintf);
  }

  _DImageEditDispT& operator=(_DImageEdit *pintf)
  {
    TAutoDriver<_DImageEdit>::Bind(pintf);
    return *this;
  }

  HRESULT BindDefault(/*Binds to new instance of CoClass ImageEdit*/)
  {
    return OLECHECK(Bind(CLSID_ImageEdit));
  }

  HRESULT BindRunning(/*Binds to a running instance of CoClass ImageEdit*/)
  {
    return BindToActive(CLSID_ImageEdit);
  }

  void            __fastcall set_ShowUI(TOLEBOOL Value);
  TOLEBOOL        __fastcall get_ShowUI();
  void            __fastcall set_TwainAutoFeeder(TOLEBOOL Value);
  TOLEBOOL        __fastcall get_TwainAutoFeeder();
  void            __fastcall set_TwainSelectSourceName(BSTR Value);
  BSTR            __fastcall get_TwainSelectSourceName();
  void            __fastcall set_PcdPath(BSTR Value);
  BSTR            __fastcall get_PcdPath();
  void            __fastcall set_FillingColor(::OLE_COLOR Value);
  ::OLE_COLOR     __fastcall get_FillingColor();
  void            __fastcall set_InputFileName(BSTR Value);
  BSTR            __fastcall get_InputFileName();
  void            __fastcall set_Appearance(short Value);
  short           __fastcall get_Appearance();
  void            __fastcall set_BorderStyle(short Value);
  short           __fastcall get_BorderStyle();
  void            __fastcall set_ImageTotalPage(short Value);
  short           __fastcall get_ImageTotalPage();
  void            __fastcall set_TwainSourceCount(short Value);
  short           __fastcall get_TwainSourceCount();
  void            __fastcall set_PcdImageCount(short Value);
  short           __fastcall get_PcdImageCount();
  void            __fastcall set_PcdColorDepthCount(short Value);
  short           __fastcall get_PcdColorDepthCount();
  void            __fastcall set_PcdDataSizeCount(short Value);
  short           __fastcall get_PcdDataSizeCount();
  void            __fastcall set_HorzPos(Gkmbiedtlib_tlb::HorzPosConstants Value);
  Gkmbiedtlib_tlb::HorzPosConstants __fastcall get_HorzPos();
  void            __fastcall set_ImageSelectPage(short Value);
  short           __fastcall get_ImageSelectPage();
  void            __fastcall set_AspectRatio(TOLEBOOL Value);
  TOLEBOOL        __fastcall get_AspectRatio();
  void            __fastcall set_AutoColorDecrease(TOLEBOOL Value);
  TOLEBOOL        __fastcall get_AutoColorDecrease();
  void            __fastcall set_InputSrcHeight(float Value);
  float           __fastcall get_InputSrcHeight();
  void            __fastcall set_InputSrcLeft(float Value);
  float           __fastcall get_InputSrcLeft();
  void            __fastcall set_InputSrcTop(float Value);
  float           __fastcall get_InputSrcTop();
  void            __fastcall set_InputSrcUnit(Gkmbiedtlib_tlb::InputUnitConstants Value);
  Gkmbiedtlib_tlb::InputUnitConstants __fastcall get_InputSrcUnit();
  void            __fastcall set_InputSrcWidth(float Value);
  float           __fastcall get_InputSrcWidth();
  void            __fastcall set_Interpolation(Gkmbiedtlib_tlb::InterpolationConstants Value);
  Gkmbiedtlib_tlb::InterpolationConstants __fastcall get_Interpolation();
  void            __fastcall set_Morphology(Gkmbiedtlib_tlb::MorphologyConstants Value);
  Gkmbiedtlib_tlb::MorphologyConstants __fastcall get_Morphology();
  void            __fastcall set_PcdSelectColorDepth(Gkmbiedtlib_tlb::ImageColorConstants Value);
  Gkmbiedtlib_tlb::ImageColorConstants __fastcall get_PcdSelectColorDepth();
  void            __fastcall set_PcdSelectDataSize(Gkmbiedtlib_tlb::PcdDataSizeConstants Value);
  Gkmbiedtlib_tlb::PcdDataSizeConstants __fastcall get_PcdSelectDataSize();
  void            __fastcall set_PcdSelectImageNo(short Value);
  short           __fastcall get_PcdSelectImageNo();
  void            __fastcall set_SaveCompression(Gkmbiedtlib_tlb::CompressionConstants Value);
  Gkmbiedtlib_tlb::CompressionConstants __fastcall get_SaveCompression();
  void            __fastcall set_SaveInterlacedImage(Gkmbiedtlib_tlb::InterlaceConstants Value);
  Gkmbiedtlib_tlb::InterlaceConstants __fastcall get_SaveInterlacedImage();
  void            __fastcall set_SaveMediaFormat(Gkmbiedtlib_tlb::MediaFormatConstants Value);
  Gkmbiedtlib_tlb::MediaFormatConstants __fastcall get_SaveMediaFormat();
  void            __fastcall set_SaveQuality(short Value);
  short           __fastcall get_SaveQuality();
  void            __fastcall set_Threshold(short Value);
  short           __fastcall get_Threshold();
  void            __fastcall set_TwainColorDepth(Gkmbiedtlib_tlb::ImageColorConstants Value);
  Gkmbiedtlib_tlb::ImageColorConstants __fastcall get_TwainColorDepth();
  void            __fastcall set_TwainPaperSize(Gkmbiedtlib_tlb::TwainPaperSizeConstants Value);
  Gkmbiedtlib_tlb::TwainPaperSizeConstants __fastcall get_TwainPaperSize();
  void            __fastcall set_TwainResolution(short Value);
  short           __fastcall get_TwainResolution();
  void            __fastcall set_Zoom(short Value);
  short           __fastcall get_Zoom();
  void            __fastcall set_VertPos(Gkmbiedtlib_tlb::VertPosConstants Value);
  Gkmbiedtlib_tlb::VertPosConstants __fastcall get_VertPos();
  void            __fastcall set_InputSource(Gkmbiedtlib_tlb::InputSourceConstants Value);
  Gkmbiedtlib_tlb::InputSourceConstants __fastcall get_InputSource();
  void            __fastcall set_BackColor(::OLE_COLOR Value);
  ::OLE_COLOR     __fastcall get_BackColor();
  void            __fastcall set_ImageWidth(long Value);
  long            __fastcall get_ImageWidth();
  void            __fastcall set_ImageHeight(long Value);
  long            __fastcall get_ImageHeight();
  void            __fastcall set_ColorDepth(Gkmbiedtlib_tlb::ImageColorConstants Value);
  Gkmbiedtlib_tlb::ImageColorConstants __fastcall get_ColorDepth();
  void            __fastcall set_Compression(Gkmbiedtlib_tlb::CompressionConstants Value);
  Gkmbiedtlib_tlb::CompressionConstants __fastcall get_Compression();
  void            __fastcall set_MediaFormat(Gkmbiedtlib_tlb::MediaFormatConstants Value);
  Gkmbiedtlib_tlb::MediaFormatConstants __fastcall get_MediaFormat();
  void            __fastcall set_InterlacedImage(Gkmbiedtlib_tlb::InterlaceConstants Value);
  Gkmbiedtlib_tlb::InterlaceConstants __fastcall get_InterlacedImage();
  void            __fastcall set_ColorReduction(Gkmbiedtlib_tlb::ReductionConstants Value);
  Gkmbiedtlib_tlb::ReductionConstants __fastcall get_ColorReduction();
  void            __fastcall set_ImageSelectedPage(short Value);
  short           __fastcall get_ImageSelectedPage();
  void            __fastcall set_XResolution(short Value);
  short           __fastcall get_XResolution();
  void            __fastcall set_YResolution(short Value);
  short           __fastcall get_YResolution();
  void            __fastcall set_SaveXResolution(short Value);
  short           __fastcall get_SaveXResolution();
  void            __fastcall set_SaveYResolution(short Value);
  short           __fastcall get_SaveYResolution();
  TOLEBOOL        __fastcall Load();
  TOLEBOOL        __fastcall Save(BSTR lpFileName);
  TOLEBOOL        __fastcall Delete();
  TOLEBOOL        __fastcall ResizeImage(long Width, long Height);
  TOLEBOOL        __fastcall RotateArbitrary(short Angle);
  TOLEBOOL        __fastcall Rotate(short Angle);
  TOLEBOOL        __fastcall Flip(short Direction);
  TOLEBOOL        __fastcall DistortSkew(short Axis, short Angle);
  TOLEBOOL        __fastcall DistortPinch(short Ratio);
  TOLEBOOL        __fastcall DistortSphere(short Direction, short Ratio);
  TOLEBOOL        __fastcall ClipRect(long Left, long Top, long Width, long Height);
  TOLEBOOL        __fastcall FillRect(long Left, long Top, long Width, long Height);
  TOLEBOOL        __fastcall ChangeColorDepth(short ColorDepth);
  TOLEBOOL        __fastcall Invert();
  TOLEBOOL        __fastcall AdjustBrightness(short Brightness, short Contrast);
  TOLEBOOL        __fastcall AdjustColorBalance(short Red, short Green, short Blue);
  TOLEBOOL        __fastcall AdjustHue(short Hue, short Saturation, short Lightness);
  TOLEBOOL        __fastcall AdjustGamma(short Gamma);
  TOLEBOOL        __fastcall Solarize();
  TOLEBOOL        __fastcall Equalize();
  TOLEBOOL        __fastcall Blur();
  TOLEBOOL        __fastcall Sharpen();
  TOLEBOOL        __fastcall Median();
  TOLEBOOL        __fastcall Emboss();
  TOLEBOOL        __fastcall SelectTwainSource();
  BSTR            __fastcall get_TwainSourceName(short Index);
  short           __fastcall get_PcdColorDepth(short Index);
  Gkmbiedtlib_tlb::PcdDataSizeConstants __fastcall get_PcdDataSize(short Index);
  TOLEBOOL        __fastcall Undo();
  TOLEBOOL        __fastcall Reset();
  void            __fastcall ClearRubberBand();
  TOLEBOOL        __fastcall SetRubberBand(long Left, long Top, long Right, long Bottom);
  short           __fastcall GetErrorCode();
  TOLEBOOL        __fastcall Blend(short Ratio, long DstLeft, long DstTop, long DstWidth, 
                                   long DstHeight, BSTR SrcFileName, long SrcLeft, long SrcTop);
  TOLEBOOL        __fastcall Calculate(short CalcOption, long DstLeft, long DstTop, long DstWidth, 
                                       long DstHeight, BSTR SrcFileName, long SrcLeft, long SrcTop);
  TOLEBOOL        __fastcall FindEdges();
  TOLEBOOL        __fastcall EnhanceEdges();
  TOLEBOOL        __fastcall SetMemHandle(OLE_HANDLE MemHandle, long MemSize);
  TOLEBOOL        __fastcall GetMemHandle(OLE_HANDLE* MemHandle, long* MemSize);
  void            __fastcall Refresh();
  TOLEBOOL        __fastcall DeletePage(BSTR FileName, short Page);
  TOLEBOOL        __fastcall ReplacePage(BSTR FileName, short Page);
  TOLEBOOL        __fastcall InsertPage(BSTR FileName, short Page);
  TOLEBOOL        __fastcall AddPage(BSTR FileName);
  short           __fastcall GetPageCount(BSTR FileName);
  TOLEBOOL        __fastcall CopyToClipboard(long Left, long Top, long Width, long Height);
  TOLEBOOL        __fastcall PasteFromClipboard(long Left, long Top);
  TOLEBOOL        __fastcall CreateFromClipboard();
  OLE_HANDLE      __fastcall GetDIB();
  TOLEBOOL        __fastcall SetDIB(OLE_HANDLE hDIB, TOLEBOOL bOwner);
  void            __fastcall AboutBox();

  __property   TOLEBOOL        ShowUI = {read = get_ShowUI, write = set_ShowUI};
  __property   TOLEBOOL        TwainAutoFeeder = {read = get_TwainAutoFeeder, write = set_TwainAutoFeeder};
  __property   BSTR            TwainSelectSourceName = {read = get_TwainSelectSourceName, write = set_TwainSelectSourceName};
  __property   BSTR            PcdPath = {read = get_PcdPath, write = set_PcdPath};
  __property   ::OLE_COLOR     FillingColor = {read = get_FillingColor, write = set_FillingColor};
  __property   BSTR            InputFileName = {read = get_InputFileName, write = set_InputFileName};
  __property   short           Appearance = {read = get_Appearance, write = set_Appearance};
  __property   short           BorderStyle = {read = get_BorderStyle, write = set_BorderStyle};
  __property   short           ImageTotalPage = {read = get_ImageTotalPage, write = set_ImageTotalPage};
  __property   short           TwainSourceCount = {read = get_TwainSourceCount, write = set_TwainSourceCount};
  __property   short           PcdImageCount = {read = get_PcdImageCount, write = set_PcdImageCount};
  __property   short           PcdColorDepthCount = {read = get_PcdColorDepthCount, write = set_PcdColorDepthCount};
  __property   short           PcdDataSizeCount = {read = get_PcdDataSizeCount, write = set_PcdDataSizeCount};
  __property   Gkmbiedtlib_tlb::HorzPosConstants HorzPos = {read = get_HorzPos, write = set_HorzPos};
  __property   short           ImageSelectPage = {read = get_ImageSelectPage, write = set_ImageSelectPage};
  __property   TOLEBOOL        AspectRatio = {read = get_AspectRatio, write = set_AspectRatio};
  __property   TOLEBOOL        AutoColorDecrease = {read = get_AutoColorDecrease, write = set_AutoColorDecrease};
  __property   float           InputSrcHeight = {read = get_InputSrcHeight, write = set_InputSrcHeight};
  __property   float           InputSrcLeft = {read = get_InputSrcLeft, write = set_InputSrcLeft};
  __property   float           InputSrcTop = {read = get_InputSrcTop, write = set_InputSrcTop};
  __property   Gkmbiedtlib_tlb::InputUnitConstants InputSrcUnit = {read = get_InputSrcUnit, write = set_InputSrcUnit};
  __property   float           InputSrcWidth = {read = get_InputSrcWidth, write = set_InputSrcWidth};
  __property   Gkmbiedtlib_tlb::InterpolationConstants Interpolation = {read = get_Interpolation, write = set_Interpolation};
  __property   Gkmbiedtlib_tlb::MorphologyConstants Morphology = {read = get_Morphology, write = set_Morphology};
  __property   Gkmbiedtlib_tlb::ImageColorConstants PcdSelectColorDepth = {read = get_PcdSelectColorDepth, write = set_PcdSelectColorDepth};
  __property   Gkmbiedtlib_tlb::PcdDataSizeConstants PcdSelectDataSize = {read = get_PcdSelectDataSize, write = set_PcdSelectDataSize};
  __property   short           PcdSelectImageNo = {read = get_PcdSelectImageNo, write = set_PcdSelectImageNo};
  __property   Gkmbiedtlib_tlb::CompressionConstants SaveCompression = {read = get_SaveCompression, write = set_SaveCompression};
  __property   Gkmbiedtlib_tlb::InterlaceConstants SaveInterlacedImage = {read = get_SaveInterlacedImage, write = set_SaveInterlacedImage};
  __property   Gkmbiedtlib_tlb::MediaFormatConstants SaveMediaFormat = {read = get_SaveMediaFormat, write = set_SaveMediaFormat};
  __property   short           SaveQuality = {read = get_SaveQuality, write = set_SaveQuality};
  __property   short           Threshold = {read = get_Threshold, write = set_Threshold};
  __property   Gkmbiedtlib_tlb::ImageColorConstants TwainColorDepth = {read = get_TwainColorDepth, write = set_TwainColorDepth};
  __property   Gkmbiedtlib_tlb::TwainPaperSizeConstants TwainPaperSize = {read = get_TwainPaperSize, write = set_TwainPaperSize};
  __property   short           TwainResolution = {read = get_TwainResolution, write = set_TwainResolution};
  __property   short           Zoom = {read = get_Zoom, write = set_Zoom};
  __property   Gkmbiedtlib_tlb::VertPosConstants VertPos = {read = get_VertPos, write = set_VertPos};
  __property   Gkmbiedtlib_tlb::InputSourceConstants InputSource = {read = get_InputSource, write = set_InputSource};
  __property   ::OLE_COLOR     BackColor = {read = get_BackColor, write = set_BackColor};
  __property   long            ImageWidth = {read = get_ImageWidth, write = set_ImageWidth};
  __property   long            ImageHeight = {read = get_ImageHeight, write = set_ImageHeight};
  __property   Gkmbiedtlib_tlb::ImageColorConstants ColorDepth = {read = get_ColorDepth, write = set_ColorDepth};
  __property   Gkmbiedtlib_tlb::CompressionConstants Compression = {read = get_Compression, write = set_Compression};
  __property   Gkmbiedtlib_tlb::MediaFormatConstants MediaFormat = {read = get_MediaFormat, write = set_MediaFormat};
  __property   Gkmbiedtlib_tlb::InterlaceConstants InterlacedImage = {read = get_InterlacedImage, write = set_InterlacedImage};
  __property   Gkmbiedtlib_tlb::ReductionConstants ColorReduction = {read = get_ColorReduction, write = set_ColorReduction};
  __property   short           ImageSelectedPage = {read = get_ImageSelectedPage, write = set_ImageSelectedPage};
  __property   short           XResolution = {read = get_XResolution, write = set_XResolution};
  __property   short           YResolution = {read = get_YResolution, write = set_YResolution};
  __property   short           SaveXResolution = {read = get_SaveXResolution, write = set_SaveXResolution};
  __property   short           SaveYResolution = {read = get_SaveYResolution, write = set_SaveYResolution};
};
typedef _DImageEditDispT<_DImageEdit> _DImageEditDisp;

// *********************************************************************//
// DispIntf:  _DImageEditEvents
// Flags:     (4096) Dispatchable
// GUID:      {AD8272C7-BB9E-11D2-AE18-00000E4E0F41}
// *********************************************************************//
template <class T>
class _DImageEditEventsDispT : public TAutoDriver<_DImageEditEvents>
{
public:
  _DImageEditEventsDispT(){}

  void Attach(LPUNKNOWN punk)
  { m_Dispatch = static_cast<T*>(punk); }

  void            __fastcall Click();
  void            __fastcall DblClick();
  void            __fastcall KeyDown(short* KeyCode, short Shift);
  void            __fastcall KeyUp(short* KeyCode, short Shift);
  void            __fastcall MouseDown(short Button, short Shift, OLE_XPOS_PIXELS x, 
                                       OLE_YPOS_PIXELS y);
  void            __fastcall MouseMove(short Button, short Shift, OLE_XPOS_PIXELS x, 
                                       OLE_YPOS_PIXELS y);
  void            __fastcall MouseUp(short Button, short Shift, OLE_XPOS_PIXELS x, OLE_YPOS_PIXELS y);
  void            __fastcall NotifyDraggedRect(long Left, long Top, long Right, long Bottom);
  void            __fastcall NotifyDraggingRect(long Left, long Top, long Right, long Bottom);
  void            __fastcall NotifyCancelDrag();

};
typedef _DImageEditEventsDispT<_DImageEditEvents> _DImageEditEventsDisp;

// *********************************************************************//
// DispIntf:  _DImageEdit
// Flags:     (4112) Hidden Dispatchable
// GUID:      {AD8272C6-BB9E-11D2-AE18-00000E4E0F41}
// *********************************************************************//
template <class T> void __fastcall
_DImageEditDispT<T>::set_ShowUI(TOLEBOOL /*[VT_BOOL:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("ShowUI"), DISPID(1));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> TOLEBOOL /*[VT_BOOL:0]*/ __fastcall
_DImageEditDispT<T>::get_ShowUI()
{
  static _TDispID _dispid(*this, OLETEXT("ShowUI"), DISPID(1));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_TwainAutoFeeder(TOLEBOOL /*[VT_BOOL:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("TwainAutoFeeder"), DISPID(2));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> TOLEBOOL /*[VT_BOOL:0]*/ __fastcall
_DImageEditDispT<T>::get_TwainAutoFeeder()
{
  static _TDispID _dispid(*this, OLETEXT("TwainAutoFeeder"), DISPID(2));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_TwainSelectSourceName(BSTR /*[VT_BSTR:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("TwainSelectSourceName"), DISPID(3));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> BSTR /*[VT_BSTR:0]*/ __fastcall
_DImageEditDispT<T>::get_TwainSelectSourceName()
{
  static _TDispID _dispid(*this, OLETEXT("TwainSelectSourceName"), DISPID(3));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_PcdPath(BSTR /*[VT_BSTR:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("PcdPath"), DISPID(4));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> BSTR /*[VT_BSTR:0]*/ __fastcall
_DImageEditDispT<T>::get_PcdPath()
{
  static _TDispID _dispid(*this, OLETEXT("PcdPath"), DISPID(4));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_FillingColor(::OLE_COLOR /*[VT_UI4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("FillingColor"), DISPID(5));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> ::OLE_COLOR /*[VT_UI4:0]*/ __fastcall
_DImageEditDispT<T>::get_FillingColor()
{
  static _TDispID _dispid(*this, OLETEXT("FillingColor"), DISPID(5));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_InputFileName(BSTR /*[VT_BSTR:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("InputFileName"), DISPID(7));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> BSTR /*[VT_BSTR:0]*/ __fastcall
_DImageEditDispT<T>::get_InputFileName()
{
  static _TDispID _dispid(*this, OLETEXT("InputFileName"), DISPID(7));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_Appearance(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("Appearance"), DISPID(-520));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DImageEditDispT<T>::get_Appearance()
{
  static _TDispID _dispid(*this, OLETEXT("Appearance"), DISPID(-520));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_BorderStyle(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("BorderStyle"), DISPID(-504));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DImageEditDispT<T>::get_BorderStyle()
{
  static _TDispID _dispid(*this, OLETEXT("BorderStyle"), DISPID(-504));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_ImageTotalPage(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("ImageTotalPage"), DISPID(9));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DImageEditDispT<T>::get_ImageTotalPage()
{
  static _TDispID _dispid(*this, OLETEXT("ImageTotalPage"), DISPID(9));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_TwainSourceCount(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("TwainSourceCount"), DISPID(10));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DImageEditDispT<T>::get_TwainSourceCount()
{
  static _TDispID _dispid(*this, OLETEXT("TwainSourceCount"), DISPID(10));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_PcdImageCount(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("PcdImageCount"), DISPID(11));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DImageEditDispT<T>::get_PcdImageCount()
{
  static _TDispID _dispid(*this, OLETEXT("PcdImageCount"), DISPID(11));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_PcdColorDepthCount(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("PcdColorDepthCount"), DISPID(12));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DImageEditDispT<T>::get_PcdColorDepthCount()
{
  static _TDispID _dispid(*this, OLETEXT("PcdColorDepthCount"), DISPID(12));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_PcdDataSizeCount(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("PcdDataSizeCount"), DISPID(13));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DImageEditDispT<T>::get_PcdDataSizeCount()
{
  static _TDispID _dispid(*this, OLETEXT("PcdDataSizeCount"), DISPID(13));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_HorzPos(Gkmbiedtlib_tlb::HorzPosConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("HorzPos"), DISPID(14));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbiedtlib_tlb::HorzPosConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbiedtlib_tlb::HorzPosConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImageEditDispT<T>::get_HorzPos()
{
  static _TDispID _dispid(*this, OLETEXT("HorzPos"), DISPID(14));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbiedtlib_tlb::HorzPosConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_ImageSelectPage(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("ImageSelectPage"), DISPID(15));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DImageEditDispT<T>::get_ImageSelectPage()
{
  static _TDispID _dispid(*this, OLETEXT("ImageSelectPage"), DISPID(15));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_AspectRatio(TOLEBOOL /*[VT_BOOL:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("AspectRatio"), DISPID(6));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> TOLEBOOL /*[VT_BOOL:0]*/ __fastcall
_DImageEditDispT<T>::get_AspectRatio()
{
  static _TDispID _dispid(*this, OLETEXT("AspectRatio"), DISPID(6));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_AutoColorDecrease(TOLEBOOL /*[VT_BOOL:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("AutoColorDecrease"), DISPID(8));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> TOLEBOOL /*[VT_BOOL:0]*/ __fastcall
_DImageEditDispT<T>::get_AutoColorDecrease()
{
  static _TDispID _dispid(*this, OLETEXT("AutoColorDecrease"), DISPID(8));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_InputSrcHeight(float /*[VT_R4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("InputSrcHeight"), DISPID(16));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> float /*[VT_R4:0]*/ __fastcall
_DImageEditDispT<T>::get_InputSrcHeight()
{
  static _TDispID _dispid(*this, OLETEXT("InputSrcHeight"), DISPID(16));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_InputSrcLeft(float /*[VT_R4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("InputSrcLeft"), DISPID(17));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> float /*[VT_R4:0]*/ __fastcall
_DImageEditDispT<T>::get_InputSrcLeft()
{
  static _TDispID _dispid(*this, OLETEXT("InputSrcLeft"), DISPID(17));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_InputSrcTop(float /*[VT_R4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("InputSrcTop"), DISPID(18));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> float /*[VT_R4:0]*/ __fastcall
_DImageEditDispT<T>::get_InputSrcTop()
{
  static _TDispID _dispid(*this, OLETEXT("InputSrcTop"), DISPID(18));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_InputSrcUnit(Gkmbiedtlib_tlb::InputUnitConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("InputSrcUnit"), DISPID(19));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbiedtlib_tlb::InputUnitConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbiedtlib_tlb::InputUnitConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImageEditDispT<T>::get_InputSrcUnit()
{
  static _TDispID _dispid(*this, OLETEXT("InputSrcUnit"), DISPID(19));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbiedtlib_tlb::InputUnitConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_InputSrcWidth(float /*[VT_R4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("InputSrcWidth"), DISPID(20));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> float /*[VT_R4:0]*/ __fastcall
_DImageEditDispT<T>::get_InputSrcWidth()
{
  static _TDispID _dispid(*this, OLETEXT("InputSrcWidth"), DISPID(20));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_Interpolation(Gkmbiedtlib_tlb::InterpolationConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("Interpolation"), DISPID(21));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbiedtlib_tlb::InterpolationConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbiedtlib_tlb::InterpolationConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImageEditDispT<T>::get_Interpolation()
{
  static _TDispID _dispid(*this, OLETEXT("Interpolation"), DISPID(21));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbiedtlib_tlb::InterpolationConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_Morphology(Gkmbiedtlib_tlb::MorphologyConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("Morphology"), DISPID(22));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbiedtlib_tlb::MorphologyConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbiedtlib_tlb::MorphologyConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImageEditDispT<T>::get_Morphology()
{
  static _TDispID _dispid(*this, OLETEXT("Morphology"), DISPID(22));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbiedtlib_tlb::MorphologyConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_PcdSelectColorDepth(Gkmbiedtlib_tlb::ImageColorConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("PcdSelectColorDepth"), DISPID(23));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbiedtlib_tlb::ImageColorConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbiedtlib_tlb::ImageColorConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImageEditDispT<T>::get_PcdSelectColorDepth()
{
  static _TDispID _dispid(*this, OLETEXT("PcdSelectColorDepth"), DISPID(23));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbiedtlib_tlb::ImageColorConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_PcdSelectDataSize(Gkmbiedtlib_tlb::PcdDataSizeConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("PcdSelectDataSize"), DISPID(24));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbiedtlib_tlb::PcdDataSizeConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbiedtlib_tlb::PcdDataSizeConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImageEditDispT<T>::get_PcdSelectDataSize()
{
  static _TDispID _dispid(*this, OLETEXT("PcdSelectDataSize"), DISPID(24));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbiedtlib_tlb::PcdDataSizeConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_PcdSelectImageNo(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("PcdSelectImageNo"), DISPID(25));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DImageEditDispT<T>::get_PcdSelectImageNo()
{
  static _TDispID _dispid(*this, OLETEXT("PcdSelectImageNo"), DISPID(25));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_SaveCompression(Gkmbiedtlib_tlb::CompressionConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("SaveCompression"), DISPID(26));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbiedtlib_tlb::CompressionConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbiedtlib_tlb::CompressionConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImageEditDispT<T>::get_SaveCompression()
{
  static _TDispID _dispid(*this, OLETEXT("SaveCompression"), DISPID(26));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbiedtlib_tlb::CompressionConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_SaveInterlacedImage(Gkmbiedtlib_tlb::InterlaceConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("SaveInterlacedImage"), DISPID(27));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbiedtlib_tlb::InterlaceConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbiedtlib_tlb::InterlaceConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImageEditDispT<T>::get_SaveInterlacedImage()
{
  static _TDispID _dispid(*this, OLETEXT("SaveInterlacedImage"), DISPID(27));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbiedtlib_tlb::InterlaceConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_SaveMediaFormat(Gkmbiedtlib_tlb::MediaFormatConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("SaveMediaFormat"), DISPID(28));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbiedtlib_tlb::MediaFormatConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbiedtlib_tlb::MediaFormatConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImageEditDispT<T>::get_SaveMediaFormat()
{
  static _TDispID _dispid(*this, OLETEXT("SaveMediaFormat"), DISPID(28));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbiedtlib_tlb::MediaFormatConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_SaveQuality(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("SaveQuality"), DISPID(29));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DImageEditDispT<T>::get_SaveQuality()
{
  static _TDispID _dispid(*this, OLETEXT("SaveQuality"), DISPID(29));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_Threshold(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("Threshold"), DISPID(30));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DImageEditDispT<T>::get_Threshold()
{
  static _TDispID _dispid(*this, OLETEXT("Threshold"), DISPID(30));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_TwainColorDepth(Gkmbiedtlib_tlb::ImageColorConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("TwainColorDepth"), DISPID(31));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbiedtlib_tlb::ImageColorConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbiedtlib_tlb::ImageColorConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImageEditDispT<T>::get_TwainColorDepth()
{
  static _TDispID _dispid(*this, OLETEXT("TwainColorDepth"), DISPID(31));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbiedtlib_tlb::ImageColorConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_TwainPaperSize(Gkmbiedtlib_tlb::TwainPaperSizeConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("TwainPaperSize"), DISPID(32));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbiedtlib_tlb::TwainPaperSizeConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbiedtlib_tlb::TwainPaperSizeConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImageEditDispT<T>::get_TwainPaperSize()
{
  static _TDispID _dispid(*this, OLETEXT("TwainPaperSize"), DISPID(32));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbiedtlib_tlb::TwainPaperSizeConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_TwainResolution(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("TwainResolution"), DISPID(33));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DImageEditDispT<T>::get_TwainResolution()
{
  static _TDispID _dispid(*this, OLETEXT("TwainResolution"), DISPID(33));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_Zoom(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("Zoom"), DISPID(34));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DImageEditDispT<T>::get_Zoom()
{
  static _TDispID _dispid(*this, OLETEXT("Zoom"), DISPID(34));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_VertPos(Gkmbiedtlib_tlb::VertPosConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("VertPos"), DISPID(35));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbiedtlib_tlb::VertPosConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbiedtlib_tlb::VertPosConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImageEditDispT<T>::get_VertPos()
{
  static _TDispID _dispid(*this, OLETEXT("VertPos"), DISPID(35));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbiedtlib_tlb::VertPosConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_InputSource(Gkmbiedtlib_tlb::InputSourceConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("InputSource"), DISPID(36));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbiedtlib_tlb::InputSourceConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbiedtlib_tlb::InputSourceConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImageEditDispT<T>::get_InputSource()
{
  static _TDispID _dispid(*this, OLETEXT("InputSource"), DISPID(36));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbiedtlib_tlb::InputSourceConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_BackColor(::OLE_COLOR /*[VT_UI4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("BackColor"), DISPID(-501));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> ::OLE_COLOR /*[VT_UI4:0]*/ __fastcall
_DImageEditDispT<T>::get_BackColor()
{
  static _TDispID _dispid(*this, OLETEXT("BackColor"), DISPID(-501));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_ImageWidth(long /*[VT_I4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("ImageWidth"), DISPID(37));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> long /*[VT_I4:0]*/ __fastcall
_DImageEditDispT<T>::get_ImageWidth()
{
  static _TDispID _dispid(*this, OLETEXT("ImageWidth"), DISPID(37));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_ImageHeight(long /*[VT_I4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("ImageHeight"), DISPID(38));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> long /*[VT_I4:0]*/ __fastcall
_DImageEditDispT<T>::get_ImageHeight()
{
  static _TDispID _dispid(*this, OLETEXT("ImageHeight"), DISPID(38));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_ColorDepth(Gkmbiedtlib_tlb::ImageColorConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("ColorDepth"), DISPID(39));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbiedtlib_tlb::ImageColorConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbiedtlib_tlb::ImageColorConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImageEditDispT<T>::get_ColorDepth()
{
  static _TDispID _dispid(*this, OLETEXT("ColorDepth"), DISPID(39));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbiedtlib_tlb::ImageColorConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_Compression(Gkmbiedtlib_tlb::CompressionConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("Compression"), DISPID(40));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbiedtlib_tlb::CompressionConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbiedtlib_tlb::CompressionConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImageEditDispT<T>::get_Compression()
{
  static _TDispID _dispid(*this, OLETEXT("Compression"), DISPID(40));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbiedtlib_tlb::CompressionConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_MediaFormat(Gkmbiedtlib_tlb::MediaFormatConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("MediaFormat"), DISPID(41));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbiedtlib_tlb::MediaFormatConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbiedtlib_tlb::MediaFormatConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImageEditDispT<T>::get_MediaFormat()
{
  static _TDispID _dispid(*this, OLETEXT("MediaFormat"), DISPID(41));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbiedtlib_tlb::MediaFormatConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_InterlacedImage(Gkmbiedtlib_tlb::InterlaceConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("InterlacedImage"), DISPID(42));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbiedtlib_tlb::InterlaceConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbiedtlib_tlb::InterlaceConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImageEditDispT<T>::get_InterlacedImage()
{
  static _TDispID _dispid(*this, OLETEXT("InterlacedImage"), DISPID(42));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbiedtlib_tlb::InterlaceConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_ColorReduction(Gkmbiedtlib_tlb::ReductionConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("ColorReduction"), DISPID(43));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbiedtlib_tlb::ReductionConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbiedtlib_tlb::ReductionConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImageEditDispT<T>::get_ColorReduction()
{
  static _TDispID _dispid(*this, OLETEXT("ColorReduction"), DISPID(43));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbiedtlib_tlb::ReductionConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_ImageSelectedPage(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("ImageSelectedPage"), DISPID(83));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DImageEditDispT<T>::get_ImageSelectedPage()
{
  static _TDispID _dispid(*this, OLETEXT("ImageSelectedPage"), DISPID(83));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_XResolution(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("XResolution"), DISPID(89));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DImageEditDispT<T>::get_XResolution()
{
  static _TDispID _dispid(*this, OLETEXT("XResolution"), DISPID(89));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_YResolution(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("YResolution"), DISPID(90));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DImageEditDispT<T>::get_YResolution()
{
  static _TDispID _dispid(*this, OLETEXT("YResolution"), DISPID(90));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_SaveXResolution(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("SaveXResolution"), DISPID(91));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DImageEditDispT<T>::get_SaveXResolution()
{
  static _TDispID _dispid(*this, OLETEXT("SaveXResolution"), DISPID(91));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::set_SaveYResolution(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("SaveYResolution"), DISPID(92));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DImageEditDispT<T>::get_SaveYResolution()
{
  static _TDispID _dispid(*this, OLETEXT("SaveYResolution"), DISPID(92));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::Load()
{
  static _TDispID _dispid(*this, OLETEXT("Load"), DISPID(44));
  TAutoArgs<0> _args;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::Save(BSTR lpFileName)
{
  static _TDispID _dispid(*this, OLETEXT("Save"), DISPID(45));
  TAutoArgs<1> _args;
  _args[1] = lpFileName /*[VT_BSTR:0]*/;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::Delete()
{
  static _TDispID _dispid(*this, OLETEXT("Delete"), DISPID(46));
  TAutoArgs<0> _args;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::ResizeImage(long Width, long Height)
{
  static _TDispID _dispid(*this, OLETEXT("ResizeImage"), DISPID(47));
  TAutoArgs<2> _args;
  _args[1] = Width /*[VT_I4:0]*/;
  _args[2] = Height /*[VT_I4:0]*/;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::RotateArbitrary(short Angle)
{
  static _TDispID _dispid(*this, OLETEXT("RotateArbitrary"), DISPID(48));
  TAutoArgs<1> _args;
  _args[1] = Angle /*[VT_I2:0]*/;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::Rotate(short Angle)
{
  static _TDispID _dispid(*this, OLETEXT("Rotate"), DISPID(49));
  TAutoArgs<1> _args;
  _args[1] = Angle /*[VT_I2:0]*/;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::Flip(short Direction)
{
  static _TDispID _dispid(*this, OLETEXT("Flip"), DISPID(50));
  TAutoArgs<1> _args;
  _args[1] = Direction /*[VT_I2:0]*/;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::DistortSkew(short Axis, short Angle)
{
  static _TDispID _dispid(*this, OLETEXT("DistortSkew"), DISPID(51));
  TAutoArgs<2> _args;
  _args[1] = Axis /*[VT_I2:0]*/;
  _args[2] = Angle /*[VT_I2:0]*/;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::DistortPinch(short Ratio)
{
  static _TDispID _dispid(*this, OLETEXT("DistortPinch"), DISPID(52));
  TAutoArgs<1> _args;
  _args[1] = Ratio /*[VT_I2:0]*/;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::DistortSphere(short Direction, short Ratio)
{
  static _TDispID _dispid(*this, OLETEXT("DistortSphere"), DISPID(53));
  TAutoArgs<2> _args;
  _args[1] = Direction /*[VT_I2:0]*/;
  _args[2] = Ratio /*[VT_I2:0]*/;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::ClipRect(long Left, long Top, long Width, long Height)
{
  static _TDispID _dispid(*this, OLETEXT("ClipRect"), DISPID(54));
  TAutoArgs<4> _args;
  _args[1] = Left /*[VT_I4:0]*/;
  _args[2] = Top /*[VT_I4:0]*/;
  _args[3] = Width /*[VT_I4:0]*/;
  _args[4] = Height /*[VT_I4:0]*/;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::FillRect(long Left, long Top, long Width, long Height)
{
  static _TDispID _dispid(*this, OLETEXT("FillRect"), DISPID(55));
  TAutoArgs<4> _args;
  _args[1] = Left /*[VT_I4:0]*/;
  _args[2] = Top /*[VT_I4:0]*/;
  _args[3] = Width /*[VT_I4:0]*/;
  _args[4] = Height /*[VT_I4:0]*/;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::ChangeColorDepth(short ColorDepth)
{
  static _TDispID _dispid(*this, OLETEXT("ChangeColorDepth"), DISPID(56));
  TAutoArgs<1> _args;
  _args[1] = ColorDepth /*[VT_I2:0]*/;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::Invert()
{
  static _TDispID _dispid(*this, OLETEXT("Invert"), DISPID(57));
  TAutoArgs<0> _args;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::AdjustBrightness(short Brightness, short Contrast)
{
  static _TDispID _dispid(*this, OLETEXT("AdjustBrightness"), DISPID(58));
  TAutoArgs<2> _args;
  _args[1] = Brightness /*[VT_I2:0]*/;
  _args[2] = Contrast /*[VT_I2:0]*/;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::AdjustColorBalance(short Red, short Green, short Blue)
{
  static _TDispID _dispid(*this, OLETEXT("AdjustColorBalance"), DISPID(59));
  TAutoArgs<3> _args;
  _args[1] = Red /*[VT_I2:0]*/;
  _args[2] = Green /*[VT_I2:0]*/;
  _args[3] = Blue /*[VT_I2:0]*/;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::AdjustHue(short Hue, short Saturation, short Lightness)
{
  static _TDispID _dispid(*this, OLETEXT("AdjustHue"), DISPID(60));
  TAutoArgs<3> _args;
  _args[1] = Hue /*[VT_I2:0]*/;
  _args[2] = Saturation /*[VT_I2:0]*/;
  _args[3] = Lightness /*[VT_I2:0]*/;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::AdjustGamma(short Gamma)
{
  static _TDispID _dispid(*this, OLETEXT("AdjustGamma"), DISPID(61));
  TAutoArgs<1> _args;
  _args[1] = Gamma /*[VT_I2:0]*/;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::Solarize()
{
  static _TDispID _dispid(*this, OLETEXT("Solarize"), DISPID(62));
  TAutoArgs<0> _args;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::Equalize()
{
  static _TDispID _dispid(*this, OLETEXT("Equalize"), DISPID(63));
  TAutoArgs<0> _args;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::Blur()
{
  static _TDispID _dispid(*this, OLETEXT("Blur"), DISPID(64));
  TAutoArgs<0> _args;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::Sharpen()
{
  static _TDispID _dispid(*this, OLETEXT("Sharpen"), DISPID(65));
  TAutoArgs<0> _args;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::Median()
{
  static _TDispID _dispid(*this, OLETEXT("Median"), DISPID(66));
  TAutoArgs<0> _args;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::Emboss()
{
  static _TDispID _dispid(*this, OLETEXT("Emboss"), DISPID(67));
  TAutoArgs<0> _args;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::SelectTwainSource()
{
  static _TDispID _dispid(*this, OLETEXT("SelectTwainSource"), DISPID(68));
  TAutoArgs<0> _args;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> BSTR __fastcall
_DImageEditDispT<T>::get_TwainSourceName(short Index)
{
  static _TDispID _dispid(*this, OLETEXT("TwainSourceName"), DISPID(80));
  TAutoArgs<1> _args;
  _args[1] = Index /*[VT_I2:0]*/;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> short __fastcall
_DImageEditDispT<T>::get_PcdColorDepth(short Index)
{
  static _TDispID _dispid(*this, OLETEXT("PcdColorDepth"), DISPID(81));
  TAutoArgs<1> _args;
  _args[1] = Index /*[VT_I2:0]*/;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> Gkmbiedtlib_tlb::PcdDataSizeConstants __fastcall
_DImageEditDispT<T>::get_PcdDataSize(short Index)
{
  static _TDispID _dispid(*this, OLETEXT("PcdDataSize"), DISPID(82));
  TAutoArgs<1> _args;
  _args[1] = Index /*[VT_I2:0]*/;
  OlePropertyGet(_dispid, _args);
  return (Gkmbiedtlib_tlb::PcdDataSizeConstants)(int) /*[VT_I4:0]*/_args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::Undo()
{
  static _TDispID _dispid(*this, OLETEXT("Undo"), DISPID(69));
  TAutoArgs<0> _args;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::Reset()
{
  static _TDispID _dispid(*this, OLETEXT("Reset"), DISPID(70));
  TAutoArgs<0> _args;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::ClearRubberBand()
{
  static _TDispID _dispid(*this, OLETEXT("ClearRubberBand"), DISPID(71));
  OleProcedure(_dispid);
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::SetRubberBand(long Left, long Top, long Right, long Bottom)
{
  static _TDispID _dispid(*this, OLETEXT("SetRubberBand"), DISPID(72));
  TAutoArgs<4> _args;
  _args[1] = Left /*[VT_I4:0]*/;
  _args[2] = Top /*[VT_I4:0]*/;
  _args[3] = Right /*[VT_I4:0]*/;
  _args[4] = Bottom /*[VT_I4:0]*/;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> short __fastcall
_DImageEditDispT<T>::GetErrorCode()
{
  static _TDispID _dispid(*this, OLETEXT("GetErrorCode"), DISPID(73));
  TAutoArgs<0> _args;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::Blend(short Ratio, long DstLeft, long DstTop, long DstWidth, long DstHeight, 
                           BSTR SrcFileName, long SrcLeft, long SrcTop)
{
  static _TDispID _dispid(*this, OLETEXT("Blend"), DISPID(74));
  TAutoArgs<8> _args;
  _args[1] = Ratio /*[VT_I2:0]*/;
  _args[2] = DstLeft /*[VT_I4:0]*/;
  _args[3] = DstTop /*[VT_I4:0]*/;
  _args[4] = DstWidth /*[VT_I4:0]*/;
  _args[5] = DstHeight /*[VT_I4:0]*/;
  _args[6] = SrcFileName /*[VT_BSTR:0]*/;
  _args[7] = SrcLeft /*[VT_I4:0]*/;
  _args[8] = SrcTop /*[VT_I4:0]*/;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::Calculate(short CalcOption, long DstLeft, long DstTop, long DstWidth, 
                               long DstHeight, BSTR SrcFileName, long SrcLeft, long SrcTop)
{
  static _TDispID _dispid(*this, OLETEXT("Calculate"), DISPID(75));
  TAutoArgs<8> _args;
  _args[1] = CalcOption /*[VT_I2:0]*/;
  _args[2] = DstLeft /*[VT_I4:0]*/;
  _args[3] = DstTop /*[VT_I4:0]*/;
  _args[4] = DstWidth /*[VT_I4:0]*/;
  _args[5] = DstHeight /*[VT_I4:0]*/;
  _args[6] = SrcFileName /*[VT_BSTR:0]*/;
  _args[7] = SrcLeft /*[VT_I4:0]*/;
  _args[8] = SrcTop /*[VT_I4:0]*/;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::FindEdges()
{
  static _TDispID _dispid(*this, OLETEXT("FindEdges"), DISPID(76));
  TAutoArgs<0> _args;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::EnhanceEdges()
{
  static _TDispID _dispid(*this, OLETEXT("EnhanceEdges"), DISPID(77));
  TAutoArgs<0> _args;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::SetMemHandle(OLE_HANDLE MemHandle, long MemSize)
{
  static _TDispID _dispid(*this, OLETEXT("SetMemHandle"), DISPID(78));
  TAutoArgs<2> _args;
  _args[1] = MemHandle /*[VT_INT:0]*/;
  _args[2] = MemSize /*[VT_I4:0]*/;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::GetMemHandle(OLE_HANDLE* MemHandle, long* MemSize)
{
  static _TDispID _dispid(*this, OLETEXT("GetMemHandle"), DISPID(79));
  TAutoArgs<2> _args;
  _args[1] = MemHandle /*[VT_INT:1]*/;
  _args[2] = MemSize /*[VT_I4:1]*/;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::Refresh()
{
  static _TDispID _dispid(*this, OLETEXT("Refresh"), DISPID(-550));
  OleProcedure(_dispid);
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::DeletePage(BSTR FileName, short Page)
{
  static _TDispID _dispid(*this, OLETEXT("DeletePage"), DISPID(84));
  TAutoArgs<2> _args;
  _args[1] = FileName /*[VT_BSTR:0]*/;
  _args[2] = Page /*[VT_I2:0]*/;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::ReplacePage(BSTR FileName, short Page)
{
  static _TDispID _dispid(*this, OLETEXT("ReplacePage"), DISPID(85));
  TAutoArgs<2> _args;
  _args[1] = FileName /*[VT_BSTR:0]*/;
  _args[2] = Page /*[VT_I2:0]*/;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::InsertPage(BSTR FileName, short Page)
{
  static _TDispID _dispid(*this, OLETEXT("InsertPage"), DISPID(86));
  TAutoArgs<2> _args;
  _args[1] = FileName /*[VT_BSTR:0]*/;
  _args[2] = Page /*[VT_I2:0]*/;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::AddPage(BSTR FileName)
{
  static _TDispID _dispid(*this, OLETEXT("AddPage"), DISPID(87));
  TAutoArgs<1> _args;
  _args[1] = FileName /*[VT_BSTR:0]*/;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> short __fastcall
_DImageEditDispT<T>::GetPageCount(BSTR FileName)
{
  static _TDispID _dispid(*this, OLETEXT("GetPageCount"), DISPID(88));
  TAutoArgs<1> _args;
  _args[1] = FileName /*[VT_BSTR:0]*/;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::CopyToClipboard(long Left, long Top, long Width, long Height)
{
  static _TDispID _dispid(*this, OLETEXT("CopyToClipboard"), DISPID(93));
  TAutoArgs<4> _args;
  _args[1] = Left /*[VT_I4:0]*/;
  _args[2] = Top /*[VT_I4:0]*/;
  _args[3] = Width /*[VT_I4:0]*/;
  _args[4] = Height /*[VT_I4:0]*/;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::PasteFromClipboard(long Left, long Top)
{
  static _TDispID _dispid(*this, OLETEXT("PasteFromClipboard"), DISPID(94));
  TAutoArgs<2> _args;
  _args[1] = Left /*[VT_I4:0]*/;
  _args[2] = Top /*[VT_I4:0]*/;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::CreateFromClipboard()
{
  static _TDispID _dispid(*this, OLETEXT("CreateFromClipboard"), DISPID(95));
  TAutoArgs<0> _args;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> OLE_HANDLE __fastcall
_DImageEditDispT<T>::GetDIB()
{
  static _TDispID _dispid(*this, OLETEXT("GetDIB"), DISPID(96));
  TAutoArgs<0> _args;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageEditDispT<T>::SetDIB(OLE_HANDLE hDIB, TOLEBOOL bOwner)
{
  static _TDispID _dispid(*this, OLETEXT("SetDIB"), DISPID(97));
  TAutoArgs<2> _args;
  _args[1] = hDIB /*[VT_INT:0]*/;
  _args[2] = bOwner /*[VT_BOOL:0]*/;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageEditDispT<T>::AboutBox()
{
  static _TDispID _dispid(*this, OLETEXT("AboutBox"), DISPID(-552));
  OleProcedure(_dispid);
}

// *********************************************************************//
// DispIntf:  _DImageEditEvents
// Flags:     (4096) Dispatchable
// GUID:      {AD8272C7-BB9E-11D2-AE18-00000E4E0F41}
// *********************************************************************//
template <class T> void __fastcall
_DImageEditEventsDispT<T>::Click()
{
  static _TDispID _dispid(/* Click */ DISPID(-600));
  OleProcedure(_dispid);
}

template <class T> void __fastcall
_DImageEditEventsDispT<T>::DblClick()
{
  static _TDispID _dispid(/* DblClick */ DISPID(-601));
  OleProcedure(_dispid);
}

template <class T> void __fastcall
_DImageEditEventsDispT<T>::KeyDown(short* KeyCode, short Shift)
{
  static _TDispID _dispid(/* KeyDown */ DISPID(-602));
  TAutoArgs<2> _args;
  _args[1] = KeyCode /*[VT_I2:1]*/;
  _args[2] = Shift /*[VT_I2:0]*/;
  OleProcedure(_dispid, _args);
}

template <class T> void __fastcall
_DImageEditEventsDispT<T>::KeyUp(short* KeyCode, short Shift)
{
  static _TDispID _dispid(/* KeyUp */ DISPID(-604));
  TAutoArgs<2> _args;
  _args[1] = KeyCode /*[VT_I2:1]*/;
  _args[2] = Shift /*[VT_I2:0]*/;
  OleProcedure(_dispid, _args);
}

template <class T> void __fastcall
_DImageEditEventsDispT<T>::MouseDown(short Button, short Shift, OLE_XPOS_PIXELS x, OLE_YPOS_PIXELS y)
{
  static _TDispID _dispid(/* MouseDown */ DISPID(-605));
  TAutoArgs<4> _args;
  _args[1] = Button /*[VT_I2:0]*/;
  _args[2] = Shift /*[VT_I2:0]*/;
  _args[3] = x /*[VT_I4:0]*/;
  _args[4] = y /*[VT_I4:0]*/;
  OleProcedure(_dispid, _args);
}

template <class T> void __fastcall
_DImageEditEventsDispT<T>::MouseMove(short Button, short Shift, OLE_XPOS_PIXELS x, OLE_YPOS_PIXELS y)
{
  static _TDispID _dispid(/* MouseMove */ DISPID(-606));
  TAutoArgs<4> _args;
  _args[1] = Button /*[VT_I2:0]*/;
  _args[2] = Shift /*[VT_I2:0]*/;
  _args[3] = x /*[VT_I4:0]*/;
  _args[4] = y /*[VT_I4:0]*/;
  OleProcedure(_dispid, _args);
}

template <class T> void __fastcall
_DImageEditEventsDispT<T>::MouseUp(short Button, short Shift, OLE_XPOS_PIXELS x, OLE_YPOS_PIXELS y)
{
  static _TDispID _dispid(/* MouseUp */ DISPID(-607));
  TAutoArgs<4> _args;
  _args[1] = Button /*[VT_I2:0]*/;
  _args[2] = Shift /*[VT_I2:0]*/;
  _args[3] = x /*[VT_I4:0]*/;
  _args[4] = y /*[VT_I4:0]*/;
  OleProcedure(_dispid, _args);
}

template <class T> void __fastcall
_DImageEditEventsDispT<T>::NotifyDraggedRect(long Left, long Top, long Right, long Bottom)
{
  static _TDispID _dispid(/* NotifyDraggedRect */ DISPID(1));
  TAutoArgs<4> _args;
  _args[1] = Left /*[VT_I4:0]*/;
  _args[2] = Top /*[VT_I4:0]*/;
  _args[3] = Right /*[VT_I4:0]*/;
  _args[4] = Bottom /*[VT_I4:0]*/;
  OleProcedure(_dispid, _args);
}

template <class T> void __fastcall
_DImageEditEventsDispT<T>::NotifyDraggingRect(long Left, long Top, long Right, long Bottom)
{
  static _TDispID _dispid(/* NotifyDraggingRect */ DISPID(2));
  TAutoArgs<4> _args;
  _args[1] = Left /*[VT_I4:0]*/;
  _args[2] = Top /*[VT_I4:0]*/;
  _args[3] = Right /*[VT_I4:0]*/;
  _args[4] = Bottom /*[VT_I4:0]*/;
  OleProcedure(_dispid, _args);
}

template <class T> void __fastcall
_DImageEditEventsDispT<T>::NotifyCancelDrag()
{
  static _TDispID _dispid(/* NotifyCancelDrag */ DISPID(3));
  OleProcedure(_dispid);
}

#endif  //   __TLB_NO_INTERFACE_WRAPPERS


#if !defined(__TLB_NO_EVENT_WRAPPERS) && defined(USING_ATLVCL)
// *********************************************************************//
// CONNECTIONPOINT/EVENT PROXY
// CoClass         : ImageEdit
// Event Interface : _DImageEditEvents
// *********************************************************************//
template <class T>
class TEvents_ImageEdit : public IConnectionPointImpl<T,
                                                 &DIID__DImageEditEvents,
                                                 CComUnkArray<CONNECTIONPOINT_ARRAY_SIZE> >
{
public:
  void            Fire_Click(void);
  void            Fire_DblClick(void);
  void            Fire_KeyDown(short* KeyCode, short Shift);
  void            Fire_KeyUp(short* KeyCode, short Shift);
  void            Fire_MouseDown(short Button, short Shift, OLE_XPOS_PIXELS x, OLE_YPOS_PIXELS y);
  void            Fire_MouseMove(short Button, short Shift, OLE_XPOS_PIXELS x, OLE_YPOS_PIXELS y);
  void            Fire_MouseUp(short Button, short Shift, OLE_XPOS_PIXELS x, OLE_YPOS_PIXELS y);
  void            Fire_NotifyDraggedRect(long Left, long Top, long Right, long Bottom);
  void            Fire_NotifyDraggingRect(long Left, long Top, long Right, long Bottom);
  void            Fire_NotifyCancelDrag(void);
protected:
  _DImageEditEventsDisp m_EventIntfObj;
};

template <class T> void
TEvents_ImageEdit<T>::Fire_Click(void)
{
  T * pT = (T*)this;
  pT->Lock();
  IUnknown ** pp = m_vec.begin();
  while (pp < m_vec.end())
  {
    if (*pp != NULL)
    {
      m_EventIntfObj.Attach(*pp);
      m_EventIntfObj.Click();
      m_EventIntfObj.Attach(0);
    }
    pp++;
  }
  pT->Unlock();
}

template <class T> void
TEvents_ImageEdit<T>::Fire_DblClick(void)
{
  T * pT = (T*)this;
  pT->Lock();
  IUnknown ** pp = m_vec.begin();
  while (pp < m_vec.end())
  {
    if (*pp != NULL)
    {
      m_EventIntfObj.Attach(*pp);
      m_EventIntfObj.DblClick();
      m_EventIntfObj.Attach(0);
    }
    pp++;
  }
  pT->Unlock();
}

template <class T> void
TEvents_ImageEdit<T>::Fire_KeyDown(short* KeyCode, short Shift)
{
  T * pT = (T*)this;
  pT->Lock();
  IUnknown ** pp = m_vec.begin();
  while (pp < m_vec.end())
  {
    if (*pp != NULL)
    {
      m_EventIntfObj.Attach(*pp);
      m_EventIntfObj.KeyDown(KeyCode, Shift);
      m_EventIntfObj.Attach(0);
    }
    pp++;
  }
  pT->Unlock();
}

template <class T> void
TEvents_ImageEdit<T>::Fire_KeyUp(short* KeyCode, short Shift)
{
  T * pT = (T*)this;
  pT->Lock();
  IUnknown ** pp = m_vec.begin();
  while (pp < m_vec.end())
  {
    if (*pp != NULL)
    {
      m_EventIntfObj.Attach(*pp);
      m_EventIntfObj.KeyUp(KeyCode, Shift);
      m_EventIntfObj.Attach(0);
    }
    pp++;
  }
  pT->Unlock();
}

template <class T> void
TEvents_ImageEdit<T>::Fire_MouseDown(short Button, short Shift, OLE_XPOS_PIXELS x, OLE_YPOS_PIXELS y)
{
  T * pT = (T*)this;
  pT->Lock();
  IUnknown ** pp = m_vec.begin();
  while (pp < m_vec.end())
  {
    if (*pp != NULL)
    {
      m_EventIntfObj.Attach(*pp);
      m_EventIntfObj.MouseDown(Button, Shift, x, y);
      m_EventIntfObj.Attach(0);
    }
    pp++;
  }
  pT->Unlock();
}

template <class T> void
TEvents_ImageEdit<T>::Fire_MouseMove(short Button, short Shift, OLE_XPOS_PIXELS x, OLE_YPOS_PIXELS y)
{
  T * pT = (T*)this;
  pT->Lock();
  IUnknown ** pp = m_vec.begin();
  while (pp < m_vec.end())
  {
    if (*pp != NULL)
    {
      m_EventIntfObj.Attach(*pp);
      m_EventIntfObj.MouseMove(Button, Shift, x, y);
      m_EventIntfObj.Attach(0);
    }
    pp++;
  }
  pT->Unlock();
}

template <class T> void
TEvents_ImageEdit<T>::Fire_MouseUp(short Button, short Shift, OLE_XPOS_PIXELS x, OLE_YPOS_PIXELS y)
{
  T * pT = (T*)this;
  pT->Lock();
  IUnknown ** pp = m_vec.begin();
  while (pp < m_vec.end())
  {
    if (*pp != NULL)
    {
      m_EventIntfObj.Attach(*pp);
      m_EventIntfObj.MouseUp(Button, Shift, x, y);
      m_EventIntfObj.Attach(0);
    }
    pp++;
  }
  pT->Unlock();
}

template <class T> void
TEvents_ImageEdit<T>::Fire_NotifyDraggedRect(long Left, long Top, long Right, long Bottom)
{
  T * pT = (T*)this;
  pT->Lock();
  IUnknown ** pp = m_vec.begin();
  while (pp < m_vec.end())
  {
    if (*pp != NULL)
    {
      m_EventIntfObj.Attach(*pp);
      m_EventIntfObj.NotifyDraggedRect(Left, Top, Right, Bottom);
      m_EventIntfObj.Attach(0);
    }
    pp++;
  }
  pT->Unlock();
}

template <class T> void
TEvents_ImageEdit<T>::Fire_NotifyDraggingRect(long Left, long Top, long Right, long Bottom)
{
  T * pT = (T*)this;
  pT->Lock();
  IUnknown ** pp = m_vec.begin();
  while (pp < m_vec.end())
  {
    if (*pp != NULL)
    {
      m_EventIntfObj.Attach(*pp);
      m_EventIntfObj.NotifyDraggingRect(Left, Top, Right, Bottom);
      m_EventIntfObj.Attach(0);
    }
    pp++;
  }
  pT->Unlock();
}

template <class T> void
TEvents_ImageEdit<T>::Fire_NotifyCancelDrag(void)
{
  T * pT = (T*)this;
  pT->Lock();
  IUnknown ** pp = m_vec.begin();
  while (pp < m_vec.end())
  {
    if (*pp != NULL)
    {
      m_EventIntfObj.Attach(*pp);
      m_EventIntfObj.NotifyCancelDrag();
      m_EventIntfObj.Attach(0);
    }
    pp++;
  }
  pT->Unlock();
}

#endif  //   __TLB_NO_EVENT_WRAPPERS

};     // namespace Gkmbiedtlib_tlb

#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using  namespace Gkmbiedtlib_tlb;
#endif

#pragma option pop

//#endif // __GKMBIEDTLib_TLB_h__

namespace Gkmbiedtlib_tlb
{

// *********************************************************************//
// HelpString: GKit Image Edit Control Borland Edition
// Version:    2.0
// *********************************************************************//


// *********************************************************************//
// OCX PROXY CLASS DECLARATION
// Control Name     : TGKitImageEdit
// Help String      : GKit Image Edit Control Borland Edition
// Default Interface: _DImageEdit
// Def. Intf. Object: _DImageEditDisp
// Def. Intf. DISP? : Yes
// Event   Interface: _DImageEditEvents
// TypeFlags        : (38) CanCreate Licensed Control
// *********************************************************************//

// *********************************************************************//
// Definition of closures to allow VCL handlers to catch OCX events.    //
// *********************************************************************//
typedef void __fastcall (__closure * TGKitImageEditNotifyDraggedRect)(System::TObject * Sender, 
                                                                      long Left, long Top, 
                                                                      long Right, long Bottom);
typedef void __fastcall (__closure * TGKitImageEditNotifyDraggingRect)(System::TObject * Sender, 
                                                                       long Left, long Top, 
                                                                       long Right, long Bottom);
//+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
// Proxy class to host GKit Image Edit Control Borland Edition in CBuilder IDE/Applications.
//-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
class PACKAGE TGKitImageEdit : public TOleControl
{
  OVERLOADED_PROP_METHODS;
  static TNoParam  OptParam;
  static GUID      DEF_CTL_INTF;

  // Instance of Closures to expose OCX Events as VCL ones
  //
  TGKitImageEditNotifyDraggedRect FOnNotifyDraggedRect;
  TGKitImageEditNotifyDraggingRect FOnNotifyDraggingRect;
  TNotifyEvent                   FOnNotifyCancelDrag;

  // Default Interace of OCX
  //
  _DImageEditDisp m_OCXIntf;

  // VCL Property Getters/Setters which delegate to OCX
  //
  BSTR            __fastcall Get_TwainSourceName(short Index);
  short           __fastcall Get_PcdColorDepth(short Index);
  Gkmbiedtlib_tlb::PcdDataSizeConstants __fastcall Get_PcdDataSize(short Index);

  // Static variables used by all instances of OCX proxy
  //
  static int          EventDispIDs[3];
  static WCHAR        wLicenseKey[96];
  static TControlData CControlData;
  static GUID         CTL_DEF_INTF;

  // Method providing access to interface as __property 
  //
  _DImageEditDisp __fastcall GetControlInterface(void);

protected:
  void     __fastcall CreateControl  (void);
  void     __fastcall InitControlData(void);

public:
  virtual  __fastcall TGKitImageEdit(TComponent* AOwner) : TOleControl(AOwner)
  {};
  virtual  __fastcall TGKitImageEdit(HWND        Parent) : TOleControl(Parent)
  {};

  // OCX methods
  //
  TOLEBOOL        __fastcall Load(void);
  TOLEBOOL        __fastcall Save(BSTR lpFileName);
  TOLEBOOL        __fastcall Delete(void);
  TOLEBOOL        __fastcall ResizeImage(long Width, long Height);
  TOLEBOOL        __fastcall RotateArbitrary(short Angle);
  TOLEBOOL        __fastcall Rotate(short Angle);
  TOLEBOOL        __fastcall Flip(short Direction);
  TOLEBOOL        __fastcall DistortSkew(short Axis, short Angle);
  TOLEBOOL        __fastcall DistortPinch(short Ratio);
  TOLEBOOL        __fastcall DistortSphere(short Direction, short Ratio);
  TOLEBOOL        __fastcall ClipRect(long Left, long Top, long Width, long Height);
  TOLEBOOL        __fastcall FillRect(long Left, long Top, long Width, long Height);
  TOLEBOOL        __fastcall ChangeColorDepth(short ColorDepth);
  TOLEBOOL        __fastcall Invert(void);
  TOLEBOOL        __fastcall AdjustBrightness(short Brightness, short Contrast);
  TOLEBOOL        __fastcall AdjustColorBalance(short Red, short Green, short Blue);
  TOLEBOOL        __fastcall AdjustHue(short Hue, short Saturation, short Lightness);
  TOLEBOOL        __fastcall AdjustGamma(short Gamma);
  TOLEBOOL        __fastcall Solarize(void);
  TOLEBOOL        __fastcall Equalize(void);
  TOLEBOOL        __fastcall Blur(void);
  TOLEBOOL        __fastcall Sharpen(void);
  TOLEBOOL        __fastcall Median(void);
  TOLEBOOL        __fastcall Emboss(void);
  TOLEBOOL        __fastcall SelectTwainSource(void);
  TOLEBOOL        __fastcall Undo(void);
  TOLEBOOL        __fastcall Reset(void);
  void            __fastcall ClearRubberBand(void);
  TOLEBOOL        __fastcall SetRubberBand(long Left, long Top, long Right, long Bottom);
  short           __fastcall GetErrorCode(void);
  TOLEBOOL        __fastcall Blend(short Ratio, long DstLeft, long DstTop, long DstWidth, 
                                   long DstHeight, BSTR SrcFileName, long SrcLeft, long SrcTop);
  TOLEBOOL        __fastcall Calculate(short CalcOption, long DstLeft, long DstTop, long DstWidth, 
                                       long DstHeight, BSTR SrcFileName, long SrcLeft, long SrcTop);
  TOLEBOOL        __fastcall FindEdges(void);
  TOLEBOOL        __fastcall EnhanceEdges(void);
  TOLEBOOL        __fastcall SetMemHandle(OLE_HANDLE MemHandle, long MemSize);
  TOLEBOOL        __fastcall GetMemHandle(OLE_HANDLE* MemHandle, long* MemSize);
  void            __fastcall Refresh(void);
  TOLEBOOL        __fastcall DeletePage(BSTR FileName, short Page);
  TOLEBOOL        __fastcall ReplacePage(BSTR FileName, short Page);
  TOLEBOOL        __fastcall InsertPage(BSTR FileName, short Page);
  TOLEBOOL        __fastcall AddPage(BSTR FileName);
  short           __fastcall GetPageCount(BSTR FileName);
  TOLEBOOL        __fastcall CopyToClipboard(long Left, long Top, long Width, long Height);
  TOLEBOOL        __fastcall PasteFromClipboard(long Left, long Top);
  TOLEBOOL        __fastcall CreateFromClipboard(void);
  OLE_HANDLE      __fastcall GetDIB(void);
  TOLEBOOL        __fastcall SetDIB(OLE_HANDLE hDIB, TOLEBOOL bOwner);
  void            __fastcall AboutBox(void);

  // OCX properties
  //
  __property BSTR TwainSourceName[short Index]={ read=Get_TwainSourceName };
  __property short PcdColorDepth[short Index]={ read=Get_PcdColorDepth };
  __property Gkmbiedtlib_tlb::PcdDataSizeConstants PcdDataSize[short Index]={ read=Get_PcdDataSize };
  __property _DImageEditDisp ControlInterface={ read=GetControlInterface };

  // Published properties
  //
__published:

  // Standard/Extended properties
  //
  __property ParentColor;
  __property TabStop;
  __property Align;
  __property DragCursor;
  __property DragMode;
  __property ParentShowHint;
  __property PopupMenu;
  __property ShowHint;
  __property TabOrder;
  __property Visible;
  __property OnDragDrop;
  __property OnDragOver;
  __property OnEndDrag;
  __property OnEnter;
  __property OnExit;
  __property OnStartDrag;
  __property OnMouseUp;
  __property OnMouseMove;
  __property OnMouseDown;
  __property OnKeyUp;
  __property OnKeyDown;
  __property OnDblClick;
  __property OnClick;

  // OCX properties
  //
  __property bool ShowUI={ read=GetWordBoolProp, write=SetWordBoolProp, stored=false, index=1 };
  __property bool TwainAutoFeeder={ read=GetWordBoolProp, write=SetWordBoolProp, stored=false, index=2 };
  __property System::WideString TwainSelectSourceName={ read=GetWideStringProp, write=SetWideStringProp, stored=false, index=3 };
  __property System::WideString PcdPath={ read=GetWideStringProp, write=SetWideStringProp, stored=false, index=4 };
  __property Graphics::TColor FillingColor={ read=GetTColorProp, write=SetTColorProp, stored=false, index=5 };
  __property System::WideString InputFileName={ read=GetWideStringProp, write=SetWideStringProp, stored=false, index=7 };
  __property short Appearance={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=-520 };
  __property short BorderStyle={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=-504 };
  __property short ImageTotalPage={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=9 };
  __property short TwainSourceCount={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=10 };
  __property short PcdImageCount={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=11 };
  __property short PcdColorDepthCount={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=12 };
  __property short PcdDataSizeCount={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=13 };
  __property TOleEnum HorzPos={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=14 };
  __property short ImageSelectPage={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=15 };
  __property bool AspectRatio={ read=GetWordBoolProp, write=SetWordBoolProp, stored=false, index=6 };
  __property bool AutoColorDecrease={ read=GetWordBoolProp, write=SetWordBoolProp, stored=false, index=8 };
  __property float InputSrcHeight={ read=GetSingleProp, write=SetSingleProp, stored=false, index=16 };
  __property float InputSrcLeft={ read=GetSingleProp, write=SetSingleProp, stored=false, index=17 };
  __property float InputSrcTop={ read=GetSingleProp, write=SetSingleProp, stored=false, index=18 };
  __property TOleEnum InputSrcUnit={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=19 };
  __property float InputSrcWidth={ read=GetSingleProp, write=SetSingleProp, stored=false, index=20 };
  __property TOleEnum Interpolation={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=21 };
  __property TOleEnum Morphology={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=22 };
  __property TOleEnum PcdSelectColorDepth={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=23 };
  __property TOleEnum PcdSelectDataSize={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=24 };
  __property short PcdSelectImageNo={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=25 };
  __property TOleEnum SaveCompression={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=26 };
  __property TOleEnum SaveInterlacedImage={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=27 };
  __property TOleEnum SaveMediaFormat={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=28 };
  __property short SaveQuality={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=29 };
  __property short Threshold={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=30 };
  __property TOleEnum TwainColorDepth={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=31 };
  __property TOleEnum TwainPaperSize={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=32 };
  __property short TwainResolution={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=33 };
  __property short Zoom={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=34 };
  __property TOleEnum VertPos={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=35 };
  __property TOleEnum InputSource={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=36 };
  __property Graphics::TColor BackColor={ read=GetTColorProp, write=SetTColorProp, stored=false, index=-501 };
  __property int ImageWidth={ read=GetIntegerProp, write=SetIntegerProp, stored=false, index=37 };
  __property int ImageHeight={ read=GetIntegerProp, write=SetIntegerProp, stored=false, index=38 };
  __property TOleEnum ColorDepth={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=39 };
  __property TOleEnum Compression={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=40 };
  __property TOleEnum MediaFormat={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=41 };
  __property TOleEnum InterlacedImage={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=42 };
  __property TOleEnum ColorReduction={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=43 };
  __property short ImageSelectedPage={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=83 };
  __property short XResolution={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=89 };
  __property short YResolution={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=90 };
  __property short SaveXResolution={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=91 };
  __property short SaveYResolution={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=92 };

  // OCX Events
  //
  __property TGKitImageEditNotifyDraggedRect OnNotifyDraggedRect={ read=FOnNotifyDraggedRect, write=FOnNotifyDraggedRect };
  __property TGKitImageEditNotifyDraggingRect OnNotifyDraggingRect={ read=FOnNotifyDraggingRect, write=FOnNotifyDraggingRect };
  __property TNotifyEvent OnNotifyCancelDrag={ read=FOnNotifyCancelDrag, write=FOnNotifyCancelDrag };
};
typedef TGKitImageEdit  TGKitImageEditProxy;

};     // namespace Gkmbiedtlib_tlb

#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using  namespace Gkmbiedtlib_tlb;
#endif

#pragma option pop

#endif // __GKMBIEDTLib_OCX_h__
