// ************************************************************************ //
//                                                                          //
// GKit Image Print Control Borland Edition                                 //
//                                                                          //
// GKitImagePrint.h Copyright (c) FUJITSU SHIZUOKA ENGINEERING LIMITED 1999 //
//                                                                          //
// ************************************************************************ //

// C++ TLBWRTR : $Revision:   1.96.1.27  $
// File generated on 99/03/04 14:39:29 from Type Library described below.

// ************************************************************************ //
// Type Lib: C:\FFC\GKITOCX.BE\MEDIATOOLS\GKMBIPRT.OCX
// IID\LCID: {242846C7-BC5F-11D2-A590-00A0C92509F5}\0
// Helpfile: C:\FFC\GKITOCX.BE\MEDIATOOLS\GKMBIPRT.hlp
// DepndLst: 
//   (1) v2.0 stdole, (C:\WINDOWS\SYSTEM\STDOLE2.TLB)
//   (2) v4.0 StdVCL, (C:\WINDOWS\SYSTEM\STDVCL40.DLL)
//   (3) v2.0 StdType, (C:\WINDOWS\SYSTEM\OLEPRO32.DLL)
// ************************************************************************ //
#ifndef   __GKMBIPRTLib_OCX_h__
#define   __GKMBIPRTLib_OCX_h__

#pragma option push -b -w-inl

#include <vcl/utilcls.h>
#if !defined(__UTILCLS_H_VERSION) || (__UTILCLS_H_VERSION < 0x0101)
#error "This file requires an newer version of the header file UTILCLS.H"
#endif

#include <olectl.h>
#include <ocidl.h>
#if !defined(_NO_VCL)   // For Console applications that don't use VCL
#include <vcl/stdvcl.hpp>
#endif  //   _NO_VCL
#include <vcl/ocxproxy.h>

//#include "GKMBIPRTLib_TLB.h"

// C++ TLBWRTR : $Revision:   1.96.1.27  $
// File generated on 99/03/04 14:39:29 from Type Library described below.

// ************************************************************************ //
// Type Lib: C:\FFC\GKITOCX.BE\MEDIATOOLS\GKMBIPRT.OCX
// IID\LCID: {242846C7-BC5F-11D2-A590-00A0C92509F5}\0
// Helpfile: C:\FFC\GKITOCX.BE\MEDIATOOLS\GKMBIPRT.hlp
// DepndLst: 
//   (1) v2.0 stdole, (C:\WINDOWS\SYSTEM\STDOLE2.TLB)
//   (2) v4.0 StdVCL, (C:\WINDOWS\SYSTEM\STDVCL40.DLL)
//   (3) v2.0 StdType, (C:\WINDOWS\SYSTEM\OLEPRO32.DLL)
// ************************************************************************ //
//#ifndef   __GKMBIPRTLib_TLB_h__
//#define   __GKMBIPRTLib_TLB_h__

#pragma option push -b -w-inl

#include <vcl/utilcls.h>
#if !defined(__UTILCLS_H_VERSION) || (__UTILCLS_H_VERSION < 0x0101)
#error "This file requires an newer version of the header file UTILCLS.H"
#endif

#include <olectl.h>
#include <ocidl.h>
#if defined(USING_ATLVCL) || defined(USING_ATL)
#if !defined(__TLB_NO_EVENT_WRAPPERS)
#include <atl/atlmod.h>
#endif
#endif


// *********************************************************************//
// Forward reference of some VCL types (to avoid including STDVCL.HPP)  //
// *********************************************************************//
namespace Stdvcl {class IStrings; class IStringsDisp;}
using namespace Stdvcl;

namespace Gkmbiprtlib_tlb
{

// *********************************************************************//
// HelpString: GKit Image Print Control Borland Edition
// Version:    2.0
// *********************************************************************//


// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:      //
//   Type Libraries     : LIBID_xxxx                                    //
//   CoClasses          : CLSID_xxxx                                    //
//   DISPInterfaces     : DIID_xxxx                                     //
//   Non-DISP interfaces: IID_xxxx                                      //
// *********************************************************************//
DEFINE_GUID(LIBID_GKMBIPRTLib, 0x242846C7, 0xBC5F, 0x11D2, 0xA5, 0x90, 0x00, 0xA0, 0xC9, 0x25, 0x09, 0xF5);
DEFINE_GUID(DIID__DImagePrint, 0x242846C8, 0xBC5F, 0x11D2, 0xA5, 0x90, 0x00, 0xA0, 0xC9, 0x25, 0x09, 0xF5);
DEFINE_GUID(DIID__DImagePrintEvents, 0x242846C9, 0xBC5F, 0x11D2, 0xA5, 0x90, 0x00, 0xA0, 0xC9, 0x25, 0x09, 0xF5);
DEFINE_GUID(CLSID_ImagePrint, 0x242846CA, 0xBC5F, 0x11D2, 0xA5, 0x90, 0x00, 0xA0, 0xC9, 0x25, 0x09, 0xF5);

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                  //
// *********************************************************************//
enum      CommonConstants;
enum      MediaFormatConstants;
enum      ErrorConstants;
enum      PrintModeConstants;
enum      PaperSizeConstants;
enum      PaperOrientationConstants;
enum      PrintDoneConstants;
interface DECLSPEC_UUID("{242846C8-BC5F-11D2-A590-00A0C92509F5}") _DImagePrint;
interface DECLSPEC_UUID("{242846C9-BC5F-11D2-A590-00A0C92509F5}") _DImagePrintEvents;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                     //
// (NOTE: Here we map each CoClass to its Default Interface)            //
//                                                                      //
// The LIBID_OF_ macro(s) map a LIBID_OF_CoClassName to the GUID of this//
// TypeLibrary. It simplifies the updating of macros when CoClass name  //
// change.                                                              //
// *********************************************************************//
typedef _DImagePrint ImagePrint;

#define LIBID_OF_ImagePrint (&LIBID_GKMBIPRTLib)

// *********************************************************************//
// Declaration of Enumerations defined in Type Library                  //
// *********************************************************************//
typedef enum CommonConstants
{
  cwmUnknown = 0xFFFFFFFF
} CommonConstants;

typedef enum MediaFormatConstants
{
  cwmFileBMP = 101, 
  cwmFileTIFF = 102, 
  cwmFileJPEG = 103, 
  cwmFilePCX = 104, 
  cwmFilePNG = 106, 
  cwmFileSIA = 107
} MediaFormatConstants;

typedef enum ErrorConstants
{
  cwmSuccess = 0, 
  cwmErrInvalidParam = 1001, 
  cwmErrInvalidRectValue = 1002, 
  cwmErrInvalidIndex = 1003, 
  cwmErrInvalidCompression = 1010, 
  cwmErrInvalidColorDepth = 1011, 
  cwmErrInvalidSaveFormat = 1012, 
  cwmErrSequenceError = 1100, 
  cwmErrUnsetMediaData = 1101, 
  cwmErrUserAbort = 1110, 
  cwmErrAcquireNotComplete = 1111, 
  cwmErrNotSupportFileFormat = 2000, 
  cwmErrInvalidFileFormat = 2001, 
  cwmErrFileNotFound = 2110, 
  cwmErrFileAlreadyExists = 2111, 
  cwmErrPathNotFound = 2112, 
  cwmErrFileLoadIncomplete = 2113, 
  cwmErrFileIOError = 2120, 
  cwmErrDiskFull = 2130, 
  cwmErrClipboardError = 2200, 
  cwmErrClipboardInvalidFormat = 2201, 
  cwmErrPrtError = 7000, 
  cwmErrPrtAppAbort = 7001, 
  cwmErrPrtUserAbort = 7002, 
  cwmErrDeviceError = 8000, 
  cwmErrDeviceNotFound = 8001, 
  cwmErrDeviceNotInstall = 8002, 
  cwmErrCDDriveNotFound = 8003, 
  cwmErrDeviceBusy = 8010, 
  cwmErrOutofMemory = 9000, 
  cwmErrSystemError = 9900, 
  cwmErrSystemNotFound = 9910, 
  cwmErrTwainDllNotFound = 9911, 
  cwmErrPcdLibNotFound = 9912
} ErrorConstants;

typedef enum PrintModeConstants
{
  cwmPMPaperFitSize = 1, 
  cwmPMViewSize = 2, 
  cwmPMActualSize = 3
} PrintModeConstants;

typedef enum PaperSizeConstants
{
  cwmPSDefault = 0, 
  cwmPSLetter = 1, 
  cwmPSLetterSmall = 2, 
  cwmPSTabloid = 3, 
  cwmPSLedger = 4, 
  cwmPSLegal = 5, 
  cwmPSStatement = 6, 
  cwmPSExecutive = 7, 
  cwmPSA3 = 8, 
  cwmPSA4 = 9, 
  cwmPSA4Small = 10, 
  cwmPSA5 = 11, 
  cwmPSB4 = 12, 
  cwmPSB5 = 13, 
  cwmPSFolio = 14, 
  cwmPSQuarto = 15, 
  cwmPS10X14 = 16, 
  cwmPS11X17 = 17, 
  cwmPSNote = 18, 
  cwmPSEnv9 = 19, 
  cwmPSEnv10 = 20, 
  cwmPSEnv11 = 21, 
  cwmPSEnv12 = 22, 
  cwmPSEnv14 = 23, 
  cwmPSCSheet = 24, 
  cwmPSDSheet = 25, 
  cwmPSESheet = 26, 
  cwmPSEnvDL = 27, 
  cwmPSEnvC5 = 28, 
  cwmPSEnvC3 = 29, 
  cwmPSEnvC4 = 30, 
  cwmPSEnvC6 = 31, 
  cwmPSEnvC65 = 32, 
  cwmPSEnvB4 = 33, 
  cwmPSEnvB5 = 34, 
  cwmPSEnvB6 = 35, 
  cwmPSEnvItaly = 36, 
  cwmPSEnvMonarch = 37, 
  cwmPSEnvPersonal = 38, 
  cwmPSFanFoldUS = 39, 
  cwmPSFanFoldStdGM = 40, 
  cwmPSFanFoldLegalGM = 41, 
  cwmPSISOB4 = 42, 
  cwmPSJapanesePostcard = 43, 
  cwmPS9X11 = 44, 
  cwmPS10X11 = 45, 
  cwmPS15X11 = 46
} PaperSizeConstants;

typedef enum PaperOrientationConstants
{
  cwmPODefault = 0, 
  cwmPOPortrait = 1, 
  cwmPOLandscape = 2
} PaperOrientationConstants;

typedef enum PrintDoneConstants
{
  cwmPrintSuccess = 0, 
  cwmPrintAllSuccess = 1, 
  cwmPrintAbort = 2, 
  cwmPrintError = 3
} PrintDoneConstants;

// *********************************************************************//
// Interface: _DImagePrint
// Flags:     (4112) Hidden Dispatchable
// GUID:      {242846C8-BC5F-11D2-A590-00A0C92509F5}
// *********************************************************************//
interface _DImagePrint : public IDispatch
{
// DispInterfaces have no methods. Their methods and properties are
// accessed via IDispatch::Invoke. See the class _DImagePrintDisp provided
// below for an easy way to access the methods/properties of this
// interface.
};

// *********************************************************************//
// Interface: _DImagePrintEvents
// Flags:     (4096) Dispatchable
// GUID:      {242846C9-BC5F-11D2-A590-00A0C92509F5}
// *********************************************************************//
interface _DImagePrintEvents : public IDispatch
{
// DispInterfaces have no methods. Their methods and properties are
// accessed via IDispatch::Invoke. See the class _DImagePrintEventsDisp provided
// below for an easy way to access the methods/properties of this
// interface.
};

#if !defined(__TLB_NO_INTERFACE_WRAPPERS)
// *********************************************************************//
// DispIntf:  _DImagePrint
// Flags:     (4112) Hidden Dispatchable
// GUID:      {242846C8-BC5F-11D2-A590-00A0C92509F5}
// *********************************************************************//
template<class T>
class _DImagePrintDispT : public TAutoDriver<_DImagePrint>
{
public:
  _DImagePrintDispT(){}

  _DImagePrintDispT(_DImagePrint *pintf)
  {
    TAutoDriver<_DImagePrint>::Bind(pintf);
  }

  _DImagePrintDispT& operator=(_DImagePrint *pintf)
  {
    TAutoDriver<_DImagePrint>::Bind(pintf);
    return *this;
  }

  HRESULT BindDefault(/*Binds to new instance of CoClass ImagePrint*/)
  {
    return OLECHECK(Bind(CLSID_ImagePrint));
  }

  HRESULT BindRunning(/*Binds to a running instance of CoClass ImagePrint*/)
  {
    return BindToActive(CLSID_ImagePrint);
  }

  void            __fastcall set_DocTitle(BSTR Value);
  BSTR            __fastcall get_DocTitle();
  void            __fastcall set_FileName(BSTR Value);
  BSTR            __fastcall get_FileName();
  void            __fastcall set_HeaderText(BSTR Value);
  BSTR            __fastcall get_HeaderText();
  void            __fastcall set_FooterText(BSTR Value);
  BSTR            __fastcall get_FooterText();
  void            __fastcall set_FromPage(short Value);
  short           __fastcall get_FromPage();
  void            __fastcall set_ToPage(short Value);
  short           __fastcall get_ToPage();
  void            __fastcall set_TotalPage(short Value);
  short           __fastcall get_TotalPage();
  void            __fastcall set_MediaFormat(Gkmbiprtlib_tlb::MediaFormatConstants Value);
  Gkmbiprtlib_tlb::MediaFormatConstants __fastcall get_MediaFormat();
  void            __fastcall set_MarginBottom(float Value);
  float           __fastcall get_MarginBottom();
  void            __fastcall set_MarginLeft(float Value);
  float           __fastcall get_MarginLeft();
  void            __fastcall set_MarginRight(float Value);
  float           __fastcall get_MarginRight();
  void            __fastcall set_MarginTop(float Value);
  float           __fastcall get_MarginTop();
  void            __fastcall set_PrintDC(OLE_HANDLE Value);
  OLE_HANDLE      __fastcall get_PrintDC();
  void            __fastcall set_PaperOrientation(Gkmbiprtlib_tlb::PaperOrientationConstants Value);
  Gkmbiprtlib_tlb::PaperOrientationConstants __fastcall get_PaperOrientation();
  void            __fastcall set_PaperSize(Gkmbiprtlib_tlb::PaperSizeConstants Value);
  Gkmbiprtlib_tlb::PaperSizeConstants __fastcall get_PaperSize();
  void            __fastcall set_PrintMode(Gkmbiprtlib_tlb::PrintModeConstants Value);
  Gkmbiprtlib_tlb::PrintModeConstants __fastcall get_PrintMode();
  void            __fastcall set_HeaderFont(IFontDisp* Value);
  IFontDisp*      __fastcall get_HeaderFont();
  TOLEBOOL        __fastcall StartPrint();
  void            __fastcall SetupPage();
  void            __fastcall CancelPrint();
  TOLEBOOL        __fastcall SetMemHandle(OLE_HANDLE MemHandle, long MemSize);
  short           __fastcall GetErrorCode();
  TOLEBOOL        __fastcall SetDIB(OLE_HANDLE hDIB, TOLEBOOL bOwner);
  void            __fastcall AboutBox();

  __property   BSTR            DocTitle = {read = get_DocTitle, write = set_DocTitle};
  __property   BSTR            FileName = {read = get_FileName, write = set_FileName};
  __property   BSTR            HeaderText = {read = get_HeaderText, write = set_HeaderText};
  __property   BSTR            FooterText = {read = get_FooterText, write = set_FooterText};
  __property   short           FromPage = {read = get_FromPage, write = set_FromPage};
  __property   short           ToPage = {read = get_ToPage, write = set_ToPage};
  __property   short           TotalPage = {read = get_TotalPage, write = set_TotalPage};
  __property   Gkmbiprtlib_tlb::MediaFormatConstants MediaFormat = {read = get_MediaFormat, write = set_MediaFormat};
  __property   float           MarginBottom = {read = get_MarginBottom, write = set_MarginBottom};
  __property   float           MarginLeft = {read = get_MarginLeft, write = set_MarginLeft};
  __property   float           MarginRight = {read = get_MarginRight, write = set_MarginRight};
  __property   float           MarginTop = {read = get_MarginTop, write = set_MarginTop};
  __property   OLE_HANDLE      PrintDC = {read = get_PrintDC, write = set_PrintDC};
  __property   Gkmbiprtlib_tlb::PaperOrientationConstants PaperOrientation = {read = get_PaperOrientation, write = set_PaperOrientation};
  __property   Gkmbiprtlib_tlb::PaperSizeConstants PaperSize = {read = get_PaperSize, write = set_PaperSize};
  __property   Gkmbiprtlib_tlb::PrintModeConstants PrintMode = {read = get_PrintMode, write = set_PrintMode};
  __property   IFontDisp*      HeaderFont = {read = get_HeaderFont, write = set_HeaderFont};
};
typedef _DImagePrintDispT<_DImagePrint> _DImagePrintDisp;

// *********************************************************************//
// DispIntf:  _DImagePrintEvents
// Flags:     (4096) Dispatchable
// GUID:      {242846C9-BC5F-11D2-A590-00A0C92509F5}
// *********************************************************************//
template <class T>
class _DImagePrintEventsDispT : public TAutoDriver<_DImagePrintEvents>
{
public:
  _DImagePrintEventsDispT(){}

  void Attach(LPUNKNOWN punk)
  { m_Dispatch = static_cast<T*>(punk); }

  void            __fastcall PrintDone(short PageNo, short Status);

};
typedef _DImagePrintEventsDispT<_DImagePrintEvents> _DImagePrintEventsDisp;

// *********************************************************************//
// DispIntf:  _DImagePrint
// Flags:     (4112) Hidden Dispatchable
// GUID:      {242846C8-BC5F-11D2-A590-00A0C92509F5}
// *********************************************************************//
template <class T> void __fastcall
_DImagePrintDispT<T>::set_DocTitle(BSTR /*[VT_BSTR:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("DocTitle"), DISPID(1));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> BSTR /*[VT_BSTR:0]*/ __fastcall
_DImagePrintDispT<T>::get_DocTitle()
{
  static _TDispID _dispid(*this, OLETEXT("DocTitle"), DISPID(1));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImagePrintDispT<T>::set_FileName(BSTR /*[VT_BSTR:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("FileName"), DISPID(4));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> BSTR /*[VT_BSTR:0]*/ __fastcall
_DImagePrintDispT<T>::get_FileName()
{
  static _TDispID _dispid(*this, OLETEXT("FileName"), DISPID(4));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImagePrintDispT<T>::set_HeaderText(BSTR /*[VT_BSTR:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("HeaderText"), DISPID(2));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> BSTR /*[VT_BSTR:0]*/ __fastcall
_DImagePrintDispT<T>::get_HeaderText()
{
  static _TDispID _dispid(*this, OLETEXT("HeaderText"), DISPID(2));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImagePrintDispT<T>::set_FooterText(BSTR /*[VT_BSTR:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("FooterText"), DISPID(3));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> BSTR /*[VT_BSTR:0]*/ __fastcall
_DImagePrintDispT<T>::get_FooterText()
{
  static _TDispID _dispid(*this, OLETEXT("FooterText"), DISPID(3));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImagePrintDispT<T>::set_FromPage(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("FromPage"), DISPID(5));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DImagePrintDispT<T>::get_FromPage()
{
  static _TDispID _dispid(*this, OLETEXT("FromPage"), DISPID(5));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImagePrintDispT<T>::set_ToPage(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("ToPage"), DISPID(6));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DImagePrintDispT<T>::get_ToPage()
{
  static _TDispID _dispid(*this, OLETEXT("ToPage"), DISPID(6));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImagePrintDispT<T>::set_TotalPage(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("TotalPage"), DISPID(7));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DImagePrintDispT<T>::get_TotalPage()
{
  static _TDispID _dispid(*this, OLETEXT("TotalPage"), DISPID(7));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImagePrintDispT<T>::set_MediaFormat(Gkmbiprtlib_tlb::MediaFormatConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("MediaFormat"), DISPID(8));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbiprtlib_tlb::MediaFormatConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbiprtlib_tlb::MediaFormatConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImagePrintDispT<T>::get_MediaFormat()
{
  static _TDispID _dispid(*this, OLETEXT("MediaFormat"), DISPID(8));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbiprtlib_tlb::MediaFormatConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImagePrintDispT<T>::set_MarginBottom(float /*[VT_R4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("MarginBottom"), DISPID(9));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> float /*[VT_R4:0]*/ __fastcall
_DImagePrintDispT<T>::get_MarginBottom()
{
  static _TDispID _dispid(*this, OLETEXT("MarginBottom"), DISPID(9));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImagePrintDispT<T>::set_MarginLeft(float /*[VT_R4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("MarginLeft"), DISPID(10));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> float /*[VT_R4:0]*/ __fastcall
_DImagePrintDispT<T>::get_MarginLeft()
{
  static _TDispID _dispid(*this, OLETEXT("MarginLeft"), DISPID(10));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImagePrintDispT<T>::set_MarginRight(float /*[VT_R4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("MarginRight"), DISPID(11));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> float /*[VT_R4:0]*/ __fastcall
_DImagePrintDispT<T>::get_MarginRight()
{
  static _TDispID _dispid(*this, OLETEXT("MarginRight"), DISPID(11));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImagePrintDispT<T>::set_MarginTop(float /*[VT_R4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("MarginTop"), DISPID(12));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> float /*[VT_R4:0]*/ __fastcall
_DImagePrintDispT<T>::get_MarginTop()
{
  static _TDispID _dispid(*this, OLETEXT("MarginTop"), DISPID(12));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImagePrintDispT<T>::set_PrintDC(OLE_HANDLE /*[VT_INT:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("PrintDC"), DISPID(13));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> OLE_HANDLE /*[VT_INT:0]*/ __fastcall
_DImagePrintDispT<T>::get_PrintDC()
{
  static _TDispID _dispid(*this, OLETEXT("PrintDC"), DISPID(13));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImagePrintDispT<T>::set_PaperOrientation(Gkmbiprtlib_tlb::PaperOrientationConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("PaperOrientation"), DISPID(14));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbiprtlib_tlb::PaperOrientationConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbiprtlib_tlb::PaperOrientationConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImagePrintDispT<T>::get_PaperOrientation()
{
  static _TDispID _dispid(*this, OLETEXT("PaperOrientation"), DISPID(14));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbiprtlib_tlb::PaperOrientationConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImagePrintDispT<T>::set_PaperSize(Gkmbiprtlib_tlb::PaperSizeConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("PaperSize"), DISPID(15));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbiprtlib_tlb::PaperSizeConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbiprtlib_tlb::PaperSizeConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImagePrintDispT<T>::get_PaperSize()
{
  static _TDispID _dispid(*this, OLETEXT("PaperSize"), DISPID(15));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbiprtlib_tlb::PaperSizeConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImagePrintDispT<T>::set_PrintMode(Gkmbiprtlib_tlb::PrintModeConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("PrintMode"), DISPID(16));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbiprtlib_tlb::PrintModeConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbiprtlib_tlb::PrintModeConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImagePrintDispT<T>::get_PrintMode()
{
  static _TDispID _dispid(*this, OLETEXT("PrintMode"), DISPID(16));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbiprtlib_tlb::PrintModeConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImagePrintDispT<T>::set_HeaderFont(IFontDisp* /*[VT_USERDEFINED:1]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("HeaderFont"), DISPID(17));
  TAutoArgs<1> _args;
  _args[1] = (LPDISPATCH) /*[VT_DISPATCH:1]*/ (IFontDisp* /*[VT_USERDEFINED:1]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> IFontDisp* /*[VT_USERDEFINED:1]*/ __fastcall
_DImagePrintDispT<T>::get_HeaderFont()
{
  static _TDispID _dispid(*this, OLETEXT("HeaderFont"), DISPID(17));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (IFontDisp* /*[VT_USERDEFINED:1]*/)(LPDISPATCH)_args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImagePrintDispT<T>::StartPrint()
{
  static _TDispID _dispid(*this, OLETEXT("StartPrint"), DISPID(18));
  TAutoArgs<0> _args;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImagePrintDispT<T>::SetupPage()
{
  static _TDispID _dispid(*this, OLETEXT("SetupPage"), DISPID(19));
  OleProcedure(_dispid);
}

template <class T> void __fastcall
_DImagePrintDispT<T>::CancelPrint()
{
  static _TDispID _dispid(*this, OLETEXT("CancelPrint"), DISPID(20));
  OleProcedure(_dispid);
}

template <class T> TOLEBOOL __fastcall
_DImagePrintDispT<T>::SetMemHandle(OLE_HANDLE MemHandle, long MemSize)
{
  static _TDispID _dispid(*this, OLETEXT("SetMemHandle"), DISPID(21));
  TAutoArgs<2> _args;
  _args[1] = MemHandle /*[VT_INT:0]*/;
  _args[2] = MemSize /*[VT_I4:0]*/;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> short __fastcall
_DImagePrintDispT<T>::GetErrorCode()
{
  static _TDispID _dispid(*this, OLETEXT("GetErrorCode"), DISPID(22));
  TAutoArgs<0> _args;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImagePrintDispT<T>::SetDIB(OLE_HANDLE hDIB, TOLEBOOL bOwner)
{
  static _TDispID _dispid(*this, OLETEXT("SetDIB"), DISPID(23));
  TAutoArgs<2> _args;
  _args[1] = hDIB /*[VT_INT:0]*/;
  _args[2] = bOwner /*[VT_BOOL:0]*/;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImagePrintDispT<T>::AboutBox()
{
  static _TDispID _dispid(*this, OLETEXT("AboutBox"), DISPID(-552));
  OleProcedure(_dispid);
}

// *********************************************************************//
// DispIntf:  _DImagePrintEvents
// Flags:     (4096) Dispatchable
// GUID:      {242846C9-BC5F-11D2-A590-00A0C92509F5}
// *********************************************************************//
template <class T> void __fastcall
_DImagePrintEventsDispT<T>::PrintDone(short PageNo, short Status)
{
  static _TDispID _dispid(/* PrintDone */ DISPID(1));
  TAutoArgs<2> _args;
  _args[1] = PageNo /*[VT_I2:0]*/;
  _args[2] = Status /*[VT_I2:0]*/;
  OleProcedure(_dispid, _args);
}

#endif  //   __TLB_NO_INTERFACE_WRAPPERS


#if !defined(__TLB_NO_EVENT_WRAPPERS) && defined(USING_ATLVCL)
// *********************************************************************//
// CONNECTIONPOINT/EVENT PROXY
// CoClass         : ImagePrint
// Event Interface : _DImagePrintEvents
// *********************************************************************//
template <class T>
class TEvents_ImagePrint : public IConnectionPointImpl<T,
                                                 &DIID__DImagePrintEvents,
                                                 CComUnkArray<CONNECTIONPOINT_ARRAY_SIZE> >
{
public:
  void            Fire_PrintDone(short PageNo, short Status);
protected:
  _DImagePrintEventsDisp m_EventIntfObj;
};

template <class T> void
TEvents_ImagePrint<T>::Fire_PrintDone(short PageNo, short Status)
{
  T * pT = (T*)this;
  pT->Lock();
  IUnknown ** pp = m_vec.begin();
  while (pp < m_vec.end())
  {
    if (*pp != NULL)
    {
      m_EventIntfObj.Attach(*pp);
      m_EventIntfObj.PrintDone(PageNo, Status);
      m_EventIntfObj.Attach(0);
    }
    pp++;
  }
  pT->Unlock();
}

#endif  //   __TLB_NO_EVENT_WRAPPERS

};     // namespace Gkmbiprtlib_tlb

#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using  namespace Gkmbiprtlib_tlb;
#endif

#pragma option pop

//#endif // __GKMBIPRTLib_TLB_h__

namespace Gkmbiprtlib_tlb
{

// *********************************************************************//
// HelpString: GKit Image Print Control Borland Edition
// Version:    2.0
// *********************************************************************//


// *********************************************************************//
// OCX PROXY CLASS DECLARATION
// Control Name     : TGKitImagePrint
// Help String      : GKit Image Print Control Borland Edition
// Default Interface: _DImagePrint
// Def. Intf. Object: _DImagePrintDisp
// Def. Intf. DISP? : Yes
// Event   Interface: _DImagePrintEvents
// TypeFlags        : (38) CanCreate Licensed Control
// *********************************************************************//

// *********************************************************************//
// Definition of closures to allow VCL handlers to catch OCX events.    //
// *********************************************************************//
typedef void __fastcall (__closure * TGKitImagePrintPrintDone)(System::TObject * Sender, 
                                                               short PageNo, short Status);
//+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
// Proxy class to host GKit Image Print Control Borland Edition in CBuilder IDE/Applications.
//-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
class PACKAGE TGKitImagePrint : public TOleControl
{
  OVERLOADED_PROP_METHODS;
  static TNoParam  OptParam;
  static GUID      DEF_CTL_INTF;

  // Instance of Closures to expose OCX Events as VCL ones
  //
  TGKitImagePrintPrintDone       FOnPrintDone;

  // Default Interace of OCX
  //
  _DImagePrintDisp m_OCXIntf;

  // VCL Property Getters/Setters which delegate to OCX
  //

  // Static variables used by all instances of OCX proxy
  //
  static int          EventDispIDs[1];
  static WCHAR        wLicenseKey[97];
  static int          TFontIDs[1];
  static TControlData CControlData;
  static GUID         CTL_DEF_INTF;

  // Method providing access to interface as __property 
  //
  _DImagePrintDisp __fastcall GetControlInterface(void);

protected:
  void     __fastcall CreateControl  (void);
  void     __fastcall InitControlData(void);

public:
  virtual  __fastcall TGKitImagePrint(TComponent* AOwner) : TOleControl(AOwner)
  {};
  virtual  __fastcall TGKitImagePrint(HWND        Parent) : TOleControl(Parent)
  {};

  // OCX methods
  //
  TOLEBOOL        __fastcall StartPrint(void);
  void            __fastcall SetupPage(void);
  void            __fastcall CancelPrint(void);
  TOLEBOOL        __fastcall SetMemHandle(OLE_HANDLE MemHandle, long MemSize);
  short           __fastcall GetErrorCode(void);
  TOLEBOOL        __fastcall SetDIB(OLE_HANDLE hDIB, TOLEBOOL bOwner);
  void            __fastcall AboutBox(void);

  // OCX properties
  //
  __property _DImagePrintDisp ControlInterface={ read=GetControlInterface };

  // Published properties
  //
__published:

  // Standard/Extended properties
  //

  // OCX properties
  //
  __property System::WideString DocTitle={ read=GetWideStringProp, write=SetWideStringProp, stored=false, index=1 };
  __property System::WideString FileName={ read=GetWideStringProp, write=SetWideStringProp, stored=false, index=4 };
  __property System::WideString HeaderText={ read=GetWideStringProp, write=SetWideStringProp, stored=false, index=2 };
  __property System::WideString FooterText={ read=GetWideStringProp, write=SetWideStringProp, stored=false, index=3 };
  __property short FromPage={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=5 };
  __property short ToPage={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=6 };
  __property short TotalPage={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=7 };
  __property TOleEnum MediaFormat={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=8 };
  __property float MarginBottom={ read=GetSingleProp, write=SetSingleProp, stored=false, index=9 };
  __property float MarginLeft={ read=GetSingleProp, write=SetSingleProp, stored=false, index=10 };
  __property float MarginRight={ read=GetSingleProp, write=SetSingleProp, stored=false, index=11 };
  __property float MarginTop={ read=GetSingleProp, write=SetSingleProp, stored=false, index=12 };
  __property int PrintDC={ read=GetIntegerProp, write=SetIntegerProp, stored=false, index=13 };
  __property TOleEnum PaperOrientation={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=14 };
  __property TOleEnum PaperSize={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=15 };
  __property TOleEnum PrintMode={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=16 };
  __property Graphics::TFont * HeaderFont={ read=GetTFontProp, write=SetTFontProp, stored=false, index=17 };

  // OCX Events
  //
  __property TGKitImagePrintPrintDone OnPrintDone={ read=FOnPrintDone, write=FOnPrintDone };
};
typedef TGKitImagePrint  TGKitImagePrintProxy;

};     // namespace Gkmbiprtlib_tlb

#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using  namespace Gkmbiprtlib_tlb;
#endif

#pragma option pop

#endif // __GKMBIPRTLib_OCX_h__
