// ************************************************************************ //
//                                                                          //
// GKit Audio Record Control Borland Edition                                //
//                                                                          //
// GKitAudioRec.h Copyright (c) FUJITSU SHIZUOKA ENGINEERING LIMITED 1999   //
//                                                                          //
// ************************************************************************ //

// C++ TLBWRTR : $Revision:   1.96.1.27  $
// File generated on 99/03/04 13:54:44 from Type Library described below.

// ************************************************************************ //
// Type Lib: C:\FFC\GKITOCX.BE\MEDIATOOLS\GKMBSRED.OCX
// IID\LCID: {4AAE8AE4-BAB7-11D2-BF10-00A0C92400D1}\0
// Helpfile: C:\FFC\GKITOCX.BE\MEDIATOOLS\GKMBSRED.hlp
// DepndLst: 
//   (1) v2.0 stdole, (C:\WINDOWS\SYSTEM\STDOLE2.TLB)
//   (2) v4.0 StdVCL, (C:\WINDOWS\SYSTEM\STDVCL40.DLL)
//   (3) v2.0 StdType, (C:\WINDOWS\SYSTEM\OLEPRO32.DLL)
// ************************************************************************ //
#ifndef   __GKMBSREDLib_OCX_h__
#define   __GKMBSREDLib_OCX_h__

#pragma option push -b -w-inl

#include <vcl/utilcls.h>
#if !defined(__UTILCLS_H_VERSION) || (__UTILCLS_H_VERSION < 0x0101)
#error "This file requires an newer version of the header file UTILCLS.H"
#endif

#include <olectl.h>
#include <ocidl.h>
#if !defined(_NO_VCL)   // For Console applications that don't use VCL
#include <vcl/stdvcl.hpp>
#endif  //   _NO_VCL
#include <vcl/ocxproxy.h>

//#include "GKMBSREDLib_TLB.h"

// C++ TLBWRTR : $Revision:   1.96.1.27  $
// File generated on 99/03/04 13:54:44 from Type Library described below.

// ************************************************************************ //
// Type Lib: C:\FFC\GKITOCX.BE\MEDIATOOLS\GKMBSRED.OCX
// IID\LCID: {4AAE8AE4-BAB7-11D2-BF10-00A0C92400D1}\0
// Helpfile: C:\FFC\GKITOCX.BE\MEDIATOOLS\GKMBSRED.hlp
// DepndLst: 
//   (1) v2.0 stdole, (C:\WINDOWS\SYSTEM\STDOLE2.TLB)
//   (2) v4.0 StdVCL, (C:\WINDOWS\SYSTEM\STDVCL40.DLL)
//   (3) v2.0 StdType, (C:\WINDOWS\SYSTEM\OLEPRO32.DLL)
// ************************************************************************ //
//#ifndef   __GKMBSREDLib_TLB_h__
//#define   __GKMBSREDLib_TLB_h__

#pragma option push -b -w-inl

#include <vcl/utilcls.h>
#if !defined(__UTILCLS_H_VERSION) || (__UTILCLS_H_VERSION < 0x0101)
#error "This file requires an newer version of the header file UTILCLS.H"
#endif

#include <olectl.h>
#include <ocidl.h>
#if defined(USING_ATLVCL) || defined(USING_ATL)
#if !defined(__TLB_NO_EVENT_WRAPPERS)
#include <atl/atlmod.h>
#endif
#endif


// *********************************************************************//
// Forward reference of some VCL types (to avoid including STDVCL.HPP)  //
// *********************************************************************//
namespace Stdvcl {class IStrings; class IStringsDisp;}
using namespace Stdvcl;

namespace Gkmbsredlib_tlb
{

// *********************************************************************//
// HelpString: GKit Audio Record Control Borland Edition
// Version:    2.0
// *********************************************************************//


// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:      //
//   Type Libraries     : LIBID_xxxx                                    //
//   CoClasses          : CLSID_xxxx                                    //
//   DISPInterfaces     : DIID_xxxx                                     //
//   Non-DISP interfaces: IID_xxxx                                      //
// *********************************************************************//
DEFINE_GUID(LIBID_GKMBSREDLib, 0x4AAE8AE4, 0xBAB7, 0x11D2, 0xBF, 0x10, 0x00, 0xA0, 0xC9, 0x24, 0x00, 0xD1);
DEFINE_GUID(DIID__DAudioRec, 0x4AAE8AE5, 0xBAB7, 0x11D2, 0xBF, 0x10, 0x00, 0xA0, 0xC9, 0x24, 0x00, 0xD1);
DEFINE_GUID(DIID__DAudioRecEvents, 0x4AAE8AE6, 0xBAB7, 0x11D2, 0xBF, 0x10, 0x00, 0xA0, 0xC9, 0x24, 0x00, 0xD1);
DEFINE_GUID(CLSID_AudioRec, 0x4AAE8AE7, 0xBAB7, 0x11D2, 0xBF, 0x10, 0x00, 0xA0, 0xC9, 0x24, 0x00, 0xD1);

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                  //
// *********************************************************************//
enum      NotifyStatusConstants;
enum      CommonConstants;
enum      MediaFormatConstants;
enum      ChannelsConstants;
enum      SamplespersecConstants;
enum      BitspersampleConstants;
enum      ErrorConstants;
interface DECLSPEC_UUID("{4AAE8AE5-BAB7-11D2-BF10-00A0C92400D1}") _DAudioRec;
interface DECLSPEC_UUID("{4AAE8AE6-BAB7-11D2-BF10-00A0C92400D1}") _DAudioRecEvents;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                     //
// (NOTE: Here we map each CoClass to its Default Interface)            //
//                                                                      //
// The LIBID_OF_ macro(s) map a LIBID_OF_CoClassName to the GUID of this//
// TypeLibrary. It simplifies the updating of macros when CoClass name  //
// change.                                                              //
// *********************************************************************//
typedef _DAudioRec AudioRec;

#define LIBID_OF_AudioRec (&LIBID_GKMBSREDLib)

// *********************************************************************//
// Declaration of Enumerations defined in Type Library                  //
// *********************************************************************//
typedef enum NotifyStatusConstants
{
  cwmNotifyRecordStart = 1, 
  cwmNotifyRecordStop = 2, 
  cwmNotifyRecordEnd = 3, 
  cwmNotifyRecordAbort = 4
} NotifyStatusConstants;

typedef enum CommonConstants
{
  cwmUnknown = 0xFFFFFFFF
} CommonConstants;

typedef enum MediaFormatConstants
{
  cwmFileWAVE = 201
} MediaFormatConstants;

typedef enum ChannelsConstants
{
  cwmChannelsMono = 1, 
  cwmChannelsStereo = 2
} ChannelsConstants;

typedef enum SamplespersecConstants
{
  cwmSamplesPerSec11K = 11, 
  cwmSamplesPerSec22K = 22, 
  cwmSamplesPerSec44K = 44
} SamplespersecConstants;

typedef enum BitspersampleConstants
{
  cwmBitsPerSample8 = 8, 
  cwmBitsPerSample16 = 16
} BitspersampleConstants;

typedef enum ErrorConstants
{
  cwmSuccess = 0, 
  cwmErrInvalidParam = 1001, 
  cwmErrInvalidRectValue = 1002, 
  cwmErrInvalidIndex = 1003, 
  cwmErrInvalidCompression = 1010, 
  cwmErrInvalidColorDepth = 1011, 
  cwmErrInvalidSaveFormat = 1012, 
  cwmErrSequenceError = 1100, 
  cwmErrUnsetMediaData = 1101, 
  cwmErrUserAbort = 1110, 
  cwmErrAcquireNotComplete = 1111, 
  cwmErrNotSupportFileFormat = 2000, 
  cwmErrInvalidFileFormat = 2001, 
  cwmErrFileNotFound = 2110, 
  cwmErrFileAlreadyExists = 2111, 
  cwmErrPathNotFound = 2112, 
  cwmErrFileLoadIncomplete = 2113, 
  cwmErrFileIOError = 2120, 
  cwmErrDiskFull = 2130, 
  cwmErrClipboardError = 2200, 
  cwmErrClipboardInvalidFormat = 2201, 
  cwmErrPrtError = 7000, 
  cwmErrPrtAppAbort = 7001, 
  cwmErrPrtUserAbort = 7002, 
  cwmErrDeviceError = 8000, 
  cwmErrDeviceNotFound = 8001, 
  cwmErrDeviceNotInstall = 8002, 
  cwmErrCDDriveNotFound = 8003, 
  cwmErrDeviceBusy = 8010, 
  cwmErrOutofMemory = 9000, 
  cwmErrSystemError = 9900, 
  cwmErrSystemNotFound = 9910, 
  cwmErrTwainDllNotFound = 9911, 
  cwmErrPcdLibNotFound = 9912
} ErrorConstants;

// *********************************************************************//
// Interface: _DAudioRec
// Flags:     (4112) Hidden Dispatchable
// GUID:      {4AAE8AE5-BAB7-11D2-BF10-00A0C92400D1}
// *********************************************************************//
interface _DAudioRec : public IDispatch
{
// DispInterfaces have no methods. Their methods and properties are
// accessed via IDispatch::Invoke. See the class _DAudioRecDisp provided
// below for an easy way to access the methods/properties of this
// interface.
};

// *********************************************************************//
// Interface: _DAudioRecEvents
// Flags:     (4096) Dispatchable
// GUID:      {4AAE8AE6-BAB7-11D2-BF10-00A0C92400D1}
// *********************************************************************//
interface _DAudioRecEvents : public IDispatch
{
// DispInterfaces have no methods. Their methods and properties are
// accessed via IDispatch::Invoke. See the class _DAudioRecEventsDisp provided
// below for an easy way to access the methods/properties of this
// interface.
};

#if !defined(__TLB_NO_INTERFACE_WRAPPERS)
// *********************************************************************//
// DispIntf:  _DAudioRec
// Flags:     (4112) Hidden Dispatchable
// GUID:      {4AAE8AE5-BAB7-11D2-BF10-00A0C92400D1}
// *********************************************************************//
template<class T>
class _DAudioRecDispT : public TAutoDriver<_DAudioRec>
{
public:
  _DAudioRecDispT(){}

  _DAudioRecDispT(_DAudioRec *pintf)
  {
    TAutoDriver<_DAudioRec>::Bind(pintf);
  }

  _DAudioRecDispT& operator=(_DAudioRec *pintf)
  {
    TAutoDriver<_DAudioRec>::Bind(pintf);
    return *this;
  }

  HRESULT BindDefault(/*Binds to new instance of CoClass AudioRec*/)
  {
    return OLECHECK(Bind(CLSID_AudioRec));
  }

  HRESULT BindRunning(/*Binds to a running instance of CoClass AudioRec*/)
  {
    return BindToActive(CLSID_AudioRec);
  }

  void            __fastcall set_Channels(Gkmbsredlib_tlb::ChannelsConstants Value);
  Gkmbsredlib_tlb::ChannelsConstants __fastcall get_Channels();
  void            __fastcall set_SamplesPerSecond(Gkmbsredlib_tlb::SamplespersecConstants Value);
  Gkmbsredlib_tlb::SamplespersecConstants __fastcall get_SamplesPerSecond();
  void            __fastcall set_BitsPerSample(Gkmbsredlib_tlb::BitspersampleConstants Value);
  Gkmbsredlib_tlb::BitspersampleConstants __fastcall get_BitsPerSample();
  void            __fastcall set_RecordTimeLimit(long Value);
  long            __fastcall get_RecordTimeLimit();
  void            __fastcall set_Length(long Value);
  long            __fastcall get_Length();
  void            __fastcall set_RecordedChannels(Gkmbsredlib_tlb::ChannelsConstants Value);
  Gkmbsredlib_tlb::ChannelsConstants __fastcall get_RecordedChannels();
  void            __fastcall set_RecordedSamplesPerSecond(Gkmbsredlib_tlb::SamplespersecConstants Value);
  Gkmbsredlib_tlb::SamplespersecConstants __fastcall get_RecordedSamplesPerSecond();
  void            __fastcall set_RecordedBitsPerSample(Gkmbsredlib_tlb::BitspersampleConstants Value);
  Gkmbsredlib_tlb::BitspersampleConstants __fastcall get_RecordedBitsPerSample();
  void            __fastcall set_MediaFormat(Gkmbsredlib_tlb::MediaFormatConstants Value);
  Gkmbsredlib_tlb::MediaFormatConstants __fastcall get_MediaFormat();
  TOLEBOOL        __fastcall StartRecord();
  TOLEBOOL        __fastcall StopRecord();
  TOLEBOOL        __fastcall SetAudioFormat();
  short           __fastcall GetErrorCode();
  TOLEBOOL        __fastcall Delete();
  TOLEBOOL        __fastcall Save(BSTR FileName);
  TOLEBOOL        __fastcall GetMemHandle(OLE_HANDLE* MemHandle, long* MemSize);
  void            __fastcall AboutBox();

  __property   Gkmbsredlib_tlb::ChannelsConstants Channels = {read = get_Channels, write = set_Channels};
  __property   Gkmbsredlib_tlb::SamplespersecConstants SamplesPerSecond = {read = get_SamplesPerSecond, write = set_SamplesPerSecond};
  __property   Gkmbsredlib_tlb::BitspersampleConstants BitsPerSample = {read = get_BitsPerSample, write = set_BitsPerSample};
  __property   long            RecordTimeLimit = {read = get_RecordTimeLimit, write = set_RecordTimeLimit};
  __property   long            Length = {read = get_Length, write = set_Length};
  __property   Gkmbsredlib_tlb::ChannelsConstants RecordedChannels = {read = get_RecordedChannels, write = set_RecordedChannels};
  __property   Gkmbsredlib_tlb::SamplespersecConstants RecordedSamplesPerSecond = {read = get_RecordedSamplesPerSecond, write = set_RecordedSamplesPerSecond};
  __property   Gkmbsredlib_tlb::BitspersampleConstants RecordedBitsPerSample = {read = get_RecordedBitsPerSample, write = set_RecordedBitsPerSample};
  __property   Gkmbsredlib_tlb::MediaFormatConstants MediaFormat = {read = get_MediaFormat, write = set_MediaFormat};
};
typedef _DAudioRecDispT<_DAudioRec> _DAudioRecDisp;

// *********************************************************************//
// DispIntf:  _DAudioRecEvents
// Flags:     (4096) Dispatchable
// GUID:      {4AAE8AE6-BAB7-11D2-BF10-00A0C92400D1}
// *********************************************************************//
template <class T>
class _DAudioRecEventsDispT : public TAutoDriver<_DAudioRecEvents>
{
public:
  _DAudioRecEventsDispT(){}

  void Attach(LPUNKNOWN punk)
  { m_Dispatch = static_cast<T*>(punk); }

  void            __fastcall Notify(short Status, long Detail);

};
typedef _DAudioRecEventsDispT<_DAudioRecEvents> _DAudioRecEventsDisp;

// *********************************************************************//
// DispIntf:  _DAudioRec
// Flags:     (4112) Hidden Dispatchable
// GUID:      {4AAE8AE5-BAB7-11D2-BF10-00A0C92400D1}
// *********************************************************************//
template <class T> void __fastcall
_DAudioRecDispT<T>::set_Channels(Gkmbsredlib_tlb::ChannelsConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("Channels"), DISPID(1));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbsredlib_tlb::ChannelsConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbsredlib_tlb::ChannelsConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DAudioRecDispT<T>::get_Channels()
{
  static _TDispID _dispid(*this, OLETEXT("Channels"), DISPID(1));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbsredlib_tlb::ChannelsConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DAudioRecDispT<T>::set_SamplesPerSecond(Gkmbsredlib_tlb::SamplespersecConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("SamplesPerSecond"), DISPID(2));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbsredlib_tlb::SamplespersecConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbsredlib_tlb::SamplespersecConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DAudioRecDispT<T>::get_SamplesPerSecond()
{
  static _TDispID _dispid(*this, OLETEXT("SamplesPerSecond"), DISPID(2));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbsredlib_tlb::SamplespersecConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DAudioRecDispT<T>::set_BitsPerSample(Gkmbsredlib_tlb::BitspersampleConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("BitsPerSample"), DISPID(3));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbsredlib_tlb::BitspersampleConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbsredlib_tlb::BitspersampleConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DAudioRecDispT<T>::get_BitsPerSample()
{
  static _TDispID _dispid(*this, OLETEXT("BitsPerSample"), DISPID(3));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbsredlib_tlb::BitspersampleConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DAudioRecDispT<T>::set_RecordTimeLimit(long /*[VT_I4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("RecordTimeLimit"), DISPID(4));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> long /*[VT_I4:0]*/ __fastcall
_DAudioRecDispT<T>::get_RecordTimeLimit()
{
  static _TDispID _dispid(*this, OLETEXT("RecordTimeLimit"), DISPID(4));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DAudioRecDispT<T>::set_Length(long /*[VT_I4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("Length"), DISPID(5));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> long /*[VT_I4:0]*/ __fastcall
_DAudioRecDispT<T>::get_Length()
{
  static _TDispID _dispid(*this, OLETEXT("Length"), DISPID(5));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DAudioRecDispT<T>::set_RecordedChannels(Gkmbsredlib_tlb::ChannelsConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("RecordedChannels"), DISPID(6));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbsredlib_tlb::ChannelsConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbsredlib_tlb::ChannelsConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DAudioRecDispT<T>::get_RecordedChannels()
{
  static _TDispID _dispid(*this, OLETEXT("RecordedChannels"), DISPID(6));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbsredlib_tlb::ChannelsConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DAudioRecDispT<T>::set_RecordedSamplesPerSecond(Gkmbsredlib_tlb::SamplespersecConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("RecordedSamplesPerSecond"), DISPID(7));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbsredlib_tlb::SamplespersecConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbsredlib_tlb::SamplespersecConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DAudioRecDispT<T>::get_RecordedSamplesPerSecond()
{
  static _TDispID _dispid(*this, OLETEXT("RecordedSamplesPerSecond"), DISPID(7));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbsredlib_tlb::SamplespersecConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DAudioRecDispT<T>::set_RecordedBitsPerSample(Gkmbsredlib_tlb::BitspersampleConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("RecordedBitsPerSample"), DISPID(8));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbsredlib_tlb::BitspersampleConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbsredlib_tlb::BitspersampleConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DAudioRecDispT<T>::get_RecordedBitsPerSample()
{
  static _TDispID _dispid(*this, OLETEXT("RecordedBitsPerSample"), DISPID(8));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbsredlib_tlb::BitspersampleConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DAudioRecDispT<T>::set_MediaFormat(Gkmbsredlib_tlb::MediaFormatConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("MediaFormat"), DISPID(9));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbsredlib_tlb::MediaFormatConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbsredlib_tlb::MediaFormatConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DAudioRecDispT<T>::get_MediaFormat()
{
  static _TDispID _dispid(*this, OLETEXT("MediaFormat"), DISPID(9));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbsredlib_tlb::MediaFormatConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DAudioRecDispT<T>::StartRecord()
{
  static _TDispID _dispid(*this, OLETEXT("StartRecord"), DISPID(10));
  TAutoArgs<0> _args;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DAudioRecDispT<T>::StopRecord()
{
  static _TDispID _dispid(*this, OLETEXT("StopRecord"), DISPID(11));
  TAutoArgs<0> _args;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DAudioRecDispT<T>::SetAudioFormat()
{
  static _TDispID _dispid(*this, OLETEXT("SetAudioFormat"), DISPID(12));
  TAutoArgs<0> _args;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> short __fastcall
_DAudioRecDispT<T>::GetErrorCode()
{
  static _TDispID _dispid(*this, OLETEXT("GetErrorCode"), DISPID(13));
  TAutoArgs<0> _args;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DAudioRecDispT<T>::Delete()
{
  static _TDispID _dispid(*this, OLETEXT("Delete"), DISPID(14));
  TAutoArgs<0> _args;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DAudioRecDispT<T>::Save(BSTR FileName)
{
  static _TDispID _dispid(*this, OLETEXT("Save"), DISPID(15));
  TAutoArgs<1> _args;
  _args[1] = FileName /*[VT_BSTR:0]*/;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DAudioRecDispT<T>::GetMemHandle(OLE_HANDLE* MemHandle, long* MemSize)
{
  static _TDispID _dispid(*this, OLETEXT("GetMemHandle"), DISPID(16));
  TAutoArgs<2> _args;
  _args[1] = MemHandle /*[VT_INT:1]*/;
  _args[2] = MemSize /*[VT_I4:1]*/;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DAudioRecDispT<T>::AboutBox()
{
  static _TDispID _dispid(*this, OLETEXT("AboutBox"), DISPID(-552));
  OleProcedure(_dispid);
}

// *********************************************************************//
// DispIntf:  _DAudioRecEvents
// Flags:     (4096) Dispatchable
// GUID:      {4AAE8AE6-BAB7-11D2-BF10-00A0C92400D1}
// *********************************************************************//
template <class T> void __fastcall
_DAudioRecEventsDispT<T>::Notify(short Status, long Detail)
{
  static _TDispID _dispid(/* Notify */ DISPID(1));
  TAutoArgs<2> _args;
  _args[1] = Status /*[VT_I2:0]*/;
  _args[2] = Detail /*[VT_I4:0]*/;
  OleProcedure(_dispid, _args);
}

#endif  //   __TLB_NO_INTERFACE_WRAPPERS


#if !defined(__TLB_NO_EVENT_WRAPPERS) && defined(USING_ATLVCL)
// *********************************************************************//
// CONNECTIONPOINT/EVENT PROXY
// CoClass         : AudioRec
// Event Interface : _DAudioRecEvents
// *********************************************************************//
template <class T>
class TEvents_AudioRec : public IConnectionPointImpl<T,
                                                 &DIID__DAudioRecEvents,
                                                 CComUnkArray<CONNECTIONPOINT_ARRAY_SIZE> >
{
public:
  void            Fire_Notify(short Status, long Detail);
protected:
  _DAudioRecEventsDisp m_EventIntfObj;
};

template <class T> void
TEvents_AudioRec<T>::Fire_Notify(short Status, long Detail)
{
  T * pT = (T*)this;
  pT->Lock();
  IUnknown ** pp = m_vec.begin();
  while (pp < m_vec.end())
  {
    if (*pp != NULL)
    {
      m_EventIntfObj.Attach(*pp);
      m_EventIntfObj.Notify(Status, Detail);
      m_EventIntfObj.Attach(0);
    }
    pp++;
  }
  pT->Unlock();
}

#endif  //   __TLB_NO_EVENT_WRAPPERS

};     // namespace Gkmbsredlib_tlb

#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using  namespace Gkmbsredlib_tlb;
#endif

#pragma option pop

//#endif // __GKMBSREDLib_TLB_h__

namespace Gkmbsredlib_tlb
{

// *********************************************************************//
// HelpString: GKit Audio Record Control Borland Edition
// Version:    2.0
// *********************************************************************//


// *********************************************************************//
// OCX PROXY CLASS DECLARATION
// Control Name     : TGKitAudioRec
// Help String      : GKit Audio Record Control Borland Edition
// Default Interface: _DAudioRec
// Def. Intf. Object: _DAudioRecDisp
// Def. Intf. DISP? : Yes
// Event   Interface: _DAudioRecEvents
// TypeFlags        : (38) CanCreate Licensed Control
// *********************************************************************//

// *********************************************************************//
// Definition of closures to allow VCL handlers to catch OCX events.    //
// *********************************************************************//
typedef void __fastcall (__closure * TGKitAudioRecNotify)(System::TObject * Sender, 
                                                          short Status, long Detail);
//+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
// Proxy class to host GKit Audio Record Control Borland Edition in CBuilder IDE/Applications.
//-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
class PACKAGE TGKitAudioRec : public TOleControl
{
  OVERLOADED_PROP_METHODS;
  static TNoParam  OptParam;
  static GUID      DEF_CTL_INTF;

  // Instance of Closures to expose OCX Events as VCL ones
  //
  TGKitAudioRecNotify            FOnNotify;

  // Default Interace of OCX
  //
  _DAudioRecDisp m_OCXIntf;

  // VCL Property Getters/Setters which delegate to OCX
  //

  // Static variables used by all instances of OCX proxy
  //
  static int          EventDispIDs[1];
  static WCHAR        wLicenseKey[98];
  static TControlData CControlData;
  static GUID         CTL_DEF_INTF;

  // Method providing access to interface as __property 
  //
  _DAudioRecDisp __fastcall GetControlInterface(void);

protected:
  void     __fastcall CreateControl  (void);
  void     __fastcall InitControlData(void);

public:
  virtual  __fastcall TGKitAudioRec(TComponent* AOwner) : TOleControl(AOwner)
  {};
  virtual  __fastcall TGKitAudioRec(HWND        Parent) : TOleControl(Parent)
  {};

  // OCX methods
  //
  TOLEBOOL        __fastcall StartRecord(void);
  TOLEBOOL        __fastcall StopRecord(void);
  TOLEBOOL        __fastcall SetAudioFormat(void);
  short           __fastcall GetErrorCode(void);
  TOLEBOOL        __fastcall Delete(void);
  TOLEBOOL        __fastcall Save(BSTR FileName);
  TOLEBOOL        __fastcall GetMemHandle(OLE_HANDLE* MemHandle, long* MemSize);
  void            __fastcall AboutBox(void);

  // OCX properties
  //
  __property _DAudioRecDisp ControlInterface={ read=GetControlInterface };

  // Published properties
  //
__published:

  // Standard/Extended properties
  //

  // OCX properties
  //
  __property TOleEnum Channels={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=1 };
  __property TOleEnum SamplesPerSecond={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=2 };
  __property TOleEnum BitsPerSample={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=3 };
  __property int RecordTimeLimit={ read=GetIntegerProp, write=SetIntegerProp, stored=false, index=4 };
  __property int Length={ read=GetIntegerProp, write=SetIntegerProp, stored=false, index=5 };
  __property TOleEnum RecordedChannels={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=6 };
  __property TOleEnum RecordedSamplesPerSecond={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=7 };
  __property TOleEnum RecordedBitsPerSample={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=8 };
  __property TOleEnum MediaFormat={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=9 };

  // OCX Events
  //
  __property TGKitAudioRecNotify OnNotify={ read=FOnNotify, write=FOnNotify };
};
typedef TGKitAudioRec  TGKitAudioRecProxy;

};     // namespace Gkmbsredlib_tlb

#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using  namespace Gkmbsredlib_tlb;
#endif

#pragma option pop

#endif // __GKMBSREDLib_OCX_h__
