// ************************************************************************ //
//                                                                          //
// GKit Image Auto Acquire Control Borland Edition                          //
//                                                                          //
// GKitImageAutoAcquire.h                                                   //
//                                                                          //
// Copyright (c) FUJITSU SHIZUOKA ENGINEERING LIMITED 1999                  //
//                                                                          //
// ************************************************************************ //

// C++ TLBWRTR : $Revision:   1.96.1.27  $
// File generated on 99/03/04 14:06:13 from Type Library described below.

// ************************************************************************ //
// Type Lib: C:\FFC\GKITOCX.BE\MEDIATOOLS\GKMBBIAQ.OCX
// IID\LCID: {242846A6-BC5F-11D2-A590-00A0C92509F5}\0
// Helpfile: C:\FFC\GKITOCX.BE\MEDIATOOLS\GKMBBIAQ.hlp
// DepndLst: 
//   (1) v2.0 stdole, (C:\WINDOWS\SYSTEM\STDOLE2.TLB)
//   (2) v4.0 StdVCL, (C:\WINDOWS\SYSTEM\STDVCL40.DLL)
//   (3) v2.0 StdType, (C:\WINDOWS\SYSTEM\OLEPRO32.DLL)
// ************************************************************************ //
#ifndef   __GKMBBIAQLib_OCX_h__
#define   __GKMBBIAQLib_OCX_h__

#pragma option push -b -w-inl

#include <vcl/utilcls.h>
#if !defined(__UTILCLS_H_VERSION) || (__UTILCLS_H_VERSION < 0x0101)
#error "This file requires an newer version of the header file UTILCLS.H"
#endif

#include <olectl.h>
#include <ocidl.h>
#if !defined(_NO_VCL)   // For Console applications that don't use VCL
#include <vcl/stdvcl.hpp>
#endif  //   _NO_VCL
#include <vcl/ocxproxy.h>

//#include "GKMBBIAQLib_TLB.h"

// C++ TLBWRTR : $Revision:   1.96.1.27  $
// File generated on 99/03/04 14:06:13 from Type Library described below.

// ************************************************************************ //
// Type Lib: C:\FFC\GKITOCX.BE\MEDIATOOLS\GKMBBIAQ.OCX
// IID\LCID: {242846A6-BC5F-11D2-A590-00A0C92509F5}\0
// Helpfile: C:\FFC\GKITOCX.BE\MEDIATOOLS\GKMBBIAQ.hlp
// DepndLst: 
//   (1) v2.0 stdole, (C:\WINDOWS\SYSTEM\STDOLE2.TLB)
//   (2) v4.0 StdVCL, (C:\WINDOWS\SYSTEM\STDVCL40.DLL)
//   (3) v2.0 StdType, (C:\WINDOWS\SYSTEM\OLEPRO32.DLL)
// ************************************************************************ //
//#ifndef   __GKMBBIAQLib_TLB_h__
//#define   __GKMBBIAQLib_TLB_h__

#pragma option push -b -w-inl

#include <vcl/utilcls.h>
#if !defined(__UTILCLS_H_VERSION) || (__UTILCLS_H_VERSION < 0x0101)
#error "This file requires an newer version of the header file UTILCLS.H"
#endif

#include <olectl.h>
#include <ocidl.h>
#if defined(USING_ATLVCL) || defined(USING_ATL)
#if !defined(__TLB_NO_EVENT_WRAPPERS)
#include <atl/atlmod.h>
#endif
#endif


// *********************************************************************//
// Forward reference of some VCL types (to avoid including STDVCL.HPP)  //
// *********************************************************************//
namespace Stdvcl {class IStrings; class IStringsDisp;}
using namespace Stdvcl;

namespace Gkmbbiaqlib_tlb
{

// *********************************************************************//
// HelpString: GKit Image Auto Acquire Control Borland Edition
// Version:    2.0
// *********************************************************************//


// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:      //
//   Type Libraries     : LIBID_xxxx                                    //
//   CoClasses          : CLSID_xxxx                                    //
//   DISPInterfaces     : DIID_xxxx                                     //
//   Non-DISP interfaces: IID_xxxx                                      //
// *********************************************************************//
DEFINE_GUID(LIBID_GKMBBIAQLib, 0x242846A6, 0xBC5F, 0x11D2, 0xA5, 0x90, 0x00, 0xA0, 0xC9, 0x25, 0x09, 0xF5);
DEFINE_GUID(DIID__DImageAcquire, 0x242846A7, 0xBC5F, 0x11D2, 0xA5, 0x90, 0x00, 0xA0, 0xC9, 0x25, 0x09, 0xF5);
DEFINE_GUID(DIID__DImageAcquireEvents, 0x242846A8, 0xBC5F, 0x11D2, 0xA5, 0x90, 0x00, 0xA0, 0xC9, 0x25, 0x09, 0xF5);
DEFINE_GUID(CLSID_ImageAcquire, 0x242846A9, 0xBC5F, 0x11D2, 0xA5, 0x90, 0x00, 0xA0, 0xC9, 0x25, 0x09, 0xF5);

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                  //
// *********************************************************************//
enum      MediaFormatConstants;
enum      CompressionConstants;
enum      ImageColorConstants;
enum      InterlaceConstants;
enum      InputSourceConstants;
enum      InputUnitConstants;
enum      TwainPaperSizeConstants;
enum      PcdDataSizeConstants;
enum      AcquireStatusConstants;
enum      RotateConstants;
enum      ErrorConstants;
interface DECLSPEC_UUID("{242846A7-BC5F-11D2-A590-00A0C92509F5}") _DImageAcquire;
interface DECLSPEC_UUID("{242846A8-BC5F-11D2-A590-00A0C92509F5}") _DImageAcquireEvents;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                     //
// (NOTE: Here we map each CoClass to its Default Interface)            //
//                                                                      //
// The LIBID_OF_ macro(s) map a LIBID_OF_CoClassName to the GUID of this//
// TypeLibrary. It simplifies the updating of macros when CoClass name  //
// change.                                                              //
// *********************************************************************//
typedef _DImageAcquire ImageAcquire;

#define LIBID_OF_ImageAcquire (&LIBID_GKMBBIAQLib)

// *********************************************************************//
// Declaration of Enumerations defined in Type Library                  //
// *********************************************************************//
typedef enum MediaFormatConstants
{
  cwmFileBMP = 101, 
  cwmFileTIFF = 102, 
  cwmFileJPEG = 103, 
  cwmFilePCX = 104, 
  cwmFilePNG = 106
} MediaFormatConstants;

typedef enum CompressionConstants
{
  cwmCompNone = 1, 
  cwmCompRLE = 101, 
  cwmCompPackbits = 202, 
  cwmCompHuffman = 203, 
  cwmCompMH = 204, 
  cwmCompMR = 205, 
  cwmCompMMR = 206
} CompressionConstants;

typedef enum ImageColorConstants
{
  cwmColorDefault = 0, 
  cwmColorBitmap = 1, 
  cwmColor16 = 4, 
  cwmColor256 = 8, 
  cwmColorGrayscale = 9, 
  cwmColorRGB = 12
} ImageColorConstants;

typedef enum InterlaceConstants
{
  cwmInterlaceNone = 1, 
  cwmInterlaced = 2
} InterlaceConstants;

typedef enum InputSourceConstants
{
  cwmSrcTwain = 2, 
  cwmSrcPhotoCD = 3
} InputSourceConstants;

typedef enum InputUnitConstants
{
  cwmUnitPixel = 1, 
  cwmUnitInch = 2, 
  cwmUnitCentimeter = 3
} InputUnitConstants;

typedef enum TwainPaperSizeConstants
{
  cwmSizeDefault = 0, 
  cwmSizeMaximum = 1, 
  cwmSizeUserDefined = 2, 
  cwmSizePortA3 = 3, 
  cwmSizePortA4 = 4, 
  cwmSizePortA5 = 5, 
  cwmSizePortB4 = 6, 
  cwmSizePortB5 = 7, 
  cwmSizeLandA3 = 8, 
  cwmSizeLandA4 = 9, 
  cwmSizeLandA5 = 10, 
  cwmSizeLandB4 = 11, 
  cwmSizeLandB5 = 12, 
  cwmSizeLetter = 13, 
  cwmSizeLegal = 14, 
  cwmSizePortPostcard = 15, 
  cwmSizeLandPostcard = 16
} TwainPaperSizeConstants;

typedef enum PcdDataSizeConstants
{
  cwmPcdResBaseOver64 = 1, 
  cwmPcdResBaseOver16 = 2, 
  cwmPcdResBaseOver4 = 3, 
  cwmPcdResBase = 4, 
  cwmPcdRes4Base = 5, 
  cwmPcdRes16Base = 6, 
  cwmPcdRes64Base = 7
} PcdDataSizeConstants;

typedef enum AcquireStatusConstants
{
  cwmAcquireSuccess = 1, 
  cwmAcquireCancel = 2, 
  cwmAcquireAbort = 3
} AcquireStatusConstants;

typedef enum RotateConstants
{
  cwmRotate0 = 0, 
  cwmRotate90 = 1, 
  cwmRotate180 = 2, 
  cwmRotate270 = 3
} RotateConstants;

typedef enum ErrorConstants
{
  cwmSuccess = 0, 
  cwmErrInvalidParam = 1001, 
  cwmErrInvalidRectValue = 1002, 
  cwmErrInvalidIndex = 1003, 
  cwmErrInvalidCompression = 1010, 
  cwmErrInvalidColorDepth = 1011, 
  cwmErrInvalidSaveFormat = 1012, 
  cwmErrSequenceError = 1100, 
  cwmErrUnsetMediaData = 1101, 
  cwmErrUserAbort = 1110, 
  cwmErrAcquireNotComplete = 1111, 
  cwmErrNotSupportFileFormat = 2000, 
  cwmErrInvalidFileFormat = 2001, 
  cwmErrFileNotFound = 2110, 
  cwmErrFileAlreadyExists = 2111, 
  cwmErrPathNotFound = 2112, 
  cwmErrFileLoadIncomplete = 2113, 
  cwmErrFileIOError = 2120, 
  cwmErrDiskFull = 2130, 
  cwmErrClipboardError = 2200, 
  cwmErrClipboardInvalidFormat = 2201, 
  cwmErrPrtError = 7000, 
  cwmErrPrtAppAbort = 7001, 
  cwmErrPrtUserAbort = 7002, 
  cwmErrDeviceError = 8000, 
  cwmErrDeviceNotFound = 8001, 
  cwmErrDeviceNotInstall = 8002, 
  cwmErrCDDriveNotFound = 8003, 
  cwmErrDeviceBusy = 8010, 
  cwmErrOutofMemory = 9000, 
  cwmErrSystemError = 9900, 
  cwmErrSystemNotFound = 9910, 
  cwmErrTwainDllNotFound = 9911, 
  cwmErrPcdLibNotFound = 9912
} ErrorConstants;

// *********************************************************************//
// Interface: _DImageAcquire
// Flags:     (4112) Hidden Dispatchable
// GUID:      {242846A7-BC5F-11D2-A590-00A0C92509F5}
// *********************************************************************//
interface _DImageAcquire : public IDispatch
{
// DispInterfaces have no methods. Their methods and properties are
// accessed via IDispatch::Invoke. See the class _DImageAcquireDisp provided
// below for an easy way to access the methods/properties of this
// interface.
};

// *********************************************************************//
// Interface: _DImageAcquireEvents
// Flags:     (4096) Dispatchable
// GUID:      {242846A8-BC5F-11D2-A590-00A0C92509F5}
// *********************************************************************//
interface _DImageAcquireEvents : public IDispatch
{
// DispInterfaces have no methods. Their methods and properties are
// accessed via IDispatch::Invoke. See the class _DImageAcquireEventsDisp provided
// below for an easy way to access the methods/properties of this
// interface.
};

#if !defined(__TLB_NO_INTERFACE_WRAPPERS)
// *********************************************************************//
// DispIntf:  _DImageAcquire
// Flags:     (4112) Hidden Dispatchable
// GUID:      {242846A7-BC5F-11D2-A590-00A0C92509F5}
// *********************************************************************//
template<class T>
class _DImageAcquireDispT : public TAutoDriver<_DImageAcquire>
{
public:
  _DImageAcquireDispT(){}

  _DImageAcquireDispT(_DImageAcquire *pintf)
  {
    TAutoDriver<_DImageAcquire>::Bind(pintf);
  }

  _DImageAcquireDispT& operator=(_DImageAcquire *pintf)
  {
    TAutoDriver<_DImageAcquire>::Bind(pintf);
    return *this;
  }

  HRESULT BindDefault(/*Binds to new instance of CoClass ImageAcquire*/)
  {
    return OLECHECK(Bind(CLSID_ImageAcquire));
  }

  HRESULT BindRunning(/*Binds to a running instance of CoClass ImageAcquire*/)
  {
    return BindToActive(CLSID_ImageAcquire);
  }

  void            __fastcall set_AspectRatio(TOLEBOOL Value);
  TOLEBOOL        __fastcall get_AspectRatio();
  void            __fastcall set_FillingColor(::OLE_COLOR Value);
  ::OLE_COLOR     __fastcall get_FillingColor();
  void            __fastcall set_ColorDepth(Gkmbbiaqlib_tlb::ImageColorConstants Value);
  Gkmbbiaqlib_tlb::ImageColorConstants __fastcall get_ColorDepth();
  void            __fastcall set_Compression(Gkmbbiaqlib_tlb::CompressionConstants Value);
  Gkmbbiaqlib_tlb::CompressionConstants __fastcall get_Compression();
  void            __fastcall set_ImageHeight(long Value);
  long            __fastcall get_ImageHeight();
  void            __fastcall set_ImageWidth(long Value);
  long            __fastcall get_ImageWidth();
  void            __fastcall set_InputSource(Gkmbbiaqlib_tlb::InputSourceConstants Value);
  Gkmbbiaqlib_tlb::InputSourceConstants __fastcall get_InputSource();
  void            __fastcall set_MediaFormat(Gkmbbiaqlib_tlb::MediaFormatConstants Value);
  Gkmbbiaqlib_tlb::MediaFormatConstants __fastcall get_MediaFormat();
  void            __fastcall set_Quality(short Value);
  short           __fastcall get_Quality();
  void            __fastcall set_Rotation(Gkmbbiaqlib_tlb::RotateConstants Value);
  Gkmbbiaqlib_tlb::RotateConstants __fastcall get_Rotation();
  void            __fastcall set_SaveDataPath(BSTR Value);
  BSTR            __fastcall get_SaveDataPath();
  void            __fastcall set_ShowUI(TOLEBOOL Value);
  TOLEBOOL        __fastcall get_ShowUI();
  void            __fastcall set_TwainAutoFeeder(TOLEBOOL Value);
  TOLEBOOL        __fastcall get_TwainAutoFeeder();
  void            __fastcall set_TwainSourceName(BSTR Value);
  BSTR            __fastcall get_TwainSourceName();
  void            __fastcall set_InterlacedImage(Gkmbbiaqlib_tlb::InterlaceConstants Value);
  Gkmbbiaqlib_tlb::InterlaceConstants __fastcall get_InterlacedImage();
  void            __fastcall set_PcdDataSize(Gkmbbiaqlib_tlb::PcdDataSizeConstants Value);
  Gkmbbiaqlib_tlb::PcdDataSizeConstants __fastcall get_PcdDataSize();
  void            __fastcall set_SrcRectUnit(Gkmbbiaqlib_tlb::InputUnitConstants Value);
  Gkmbbiaqlib_tlb::InputUnitConstants __fastcall get_SrcRectUnit();
  void            __fastcall set_SrcLeft(float Value);
  float           __fastcall get_SrcLeft();
  void            __fastcall set_SrcTop(float Value);
  float           __fastcall get_SrcTop();
  void            __fastcall set_SrcWidth(float Value);
  float           __fastcall get_SrcWidth();
  void            __fastcall set_SrcHeight(float Value);
  float           __fastcall get_SrcHeight();
  void            __fastcall set_PcdPath(BSTR Value);
  BSTR            __fastcall get_PcdPath();
  void            __fastcall set_TwainPaperSize(Gkmbbiaqlib_tlb::TwainPaperSizeConstants Value);
  Gkmbbiaqlib_tlb::TwainPaperSizeConstants __fastcall get_TwainPaperSize();
  void            __fastcall set_FileNameFormat(BSTR Value);
  BSTR            __fastcall get_FileNameFormat();
  void            __fastcall set_InitialNumber(long Value);
  long            __fastcall get_InitialNumber();
  void            __fastcall set_AcquireCount(long Value);
  long            __fastcall get_AcquireCount();
  void            __fastcall set_AcquireStartNo(long Value);
  long            __fastcall get_AcquireStartNo();
  void            __fastcall set_AcquiredCount(long Value);
  long            __fastcall get_AcquiredCount();
  void            __fastcall set_AutoSave(TOLEBOOL Value);
  TOLEBOOL        __fastcall get_AutoSave();
  void            __fastcall set_TwainResolution(short Value);
  short           __fastcall get_TwainResolution();
  void            __fastcall set_MultiPage(TOLEBOOL Value);
  TOLEBOOL        __fastcall get_MultiPage();
  void            __fastcall set_XResolution(short Value);
  short           __fastcall get_XResolution();
  void            __fastcall set_YResolution(short Value);
  short           __fastcall get_YResolution();
  TOLEBOOL        __fastcall SelectTwainSource();
  void            __fastcall Cancel();
  TOLEBOOL        __fastcall AcquireImages();
  short           __fastcall GetErrorCode();
  TOLEBOOL        __fastcall GetMemHandle(OLE_HANDLE* MemHandle, long* MemSize);
  OLE_HANDLE      __fastcall GetDIB();
  void            __fastcall AboutBox();

  __property   TOLEBOOL        AspectRatio = {read = get_AspectRatio, write = set_AspectRatio};
  __property   ::OLE_COLOR     FillingColor = {read = get_FillingColor, write = set_FillingColor};
  __property   Gkmbbiaqlib_tlb::ImageColorConstants ColorDepth = {read = get_ColorDepth, write = set_ColorDepth};
  __property   Gkmbbiaqlib_tlb::CompressionConstants Compression = {read = get_Compression, write = set_Compression};
  __property   long            ImageHeight = {read = get_ImageHeight, write = set_ImageHeight};
  __property   long            ImageWidth = {read = get_ImageWidth, write = set_ImageWidth};
  __property   Gkmbbiaqlib_tlb::InputSourceConstants InputSource = {read = get_InputSource, write = set_InputSource};
  __property   Gkmbbiaqlib_tlb::MediaFormatConstants MediaFormat = {read = get_MediaFormat, write = set_MediaFormat};
  __property   short           Quality = {read = get_Quality, write = set_Quality};
  __property   Gkmbbiaqlib_tlb::RotateConstants Rotation = {read = get_Rotation, write = set_Rotation};
  __property   BSTR            SaveDataPath = {read = get_SaveDataPath, write = set_SaveDataPath};
  __property   TOLEBOOL        ShowUI = {read = get_ShowUI, write = set_ShowUI};
  __property   TOLEBOOL        TwainAutoFeeder = {read = get_TwainAutoFeeder, write = set_TwainAutoFeeder};
  __property   BSTR            TwainSourceName = {read = get_TwainSourceName, write = set_TwainSourceName};
  __property   Gkmbbiaqlib_tlb::InterlaceConstants InterlacedImage = {read = get_InterlacedImage, write = set_InterlacedImage};
  __property   Gkmbbiaqlib_tlb::PcdDataSizeConstants PcdDataSize = {read = get_PcdDataSize, write = set_PcdDataSize};
  __property   Gkmbbiaqlib_tlb::InputUnitConstants SrcRectUnit = {read = get_SrcRectUnit, write = set_SrcRectUnit};
  __property   float           SrcLeft = {read = get_SrcLeft, write = set_SrcLeft};
  __property   float           SrcTop = {read = get_SrcTop, write = set_SrcTop};
  __property   float           SrcWidth = {read = get_SrcWidth, write = set_SrcWidth};
  __property   float           SrcHeight = {read = get_SrcHeight, write = set_SrcHeight};
  __property   BSTR            PcdPath = {read = get_PcdPath, write = set_PcdPath};
  __property   Gkmbbiaqlib_tlb::TwainPaperSizeConstants TwainPaperSize = {read = get_TwainPaperSize, write = set_TwainPaperSize};
  __property   BSTR            FileNameFormat = {read = get_FileNameFormat, write = set_FileNameFormat};
  __property   long            InitialNumber = {read = get_InitialNumber, write = set_InitialNumber};
  __property   long            AcquireCount = {read = get_AcquireCount, write = set_AcquireCount};
  __property   long            AcquireStartNo = {read = get_AcquireStartNo, write = set_AcquireStartNo};
  __property   long            AcquiredCount = {read = get_AcquiredCount, write = set_AcquiredCount};
  __property   TOLEBOOL        AutoSave = {read = get_AutoSave, write = set_AutoSave};
  __property   short           TwainResolution = {read = get_TwainResolution, write = set_TwainResolution};
  __property   TOLEBOOL        MultiPage = {read = get_MultiPage, write = set_MultiPage};
  __property   short           XResolution = {read = get_XResolution, write = set_XResolution};
  __property   short           YResolution = {read = get_YResolution, write = set_YResolution};
};
typedef _DImageAcquireDispT<_DImageAcquire> _DImageAcquireDisp;

// *********************************************************************//
// DispIntf:  _DImageAcquireEvents
// Flags:     (4096) Dispatchable
// GUID:      {242846A8-BC5F-11D2-A590-00A0C92509F5}
// *********************************************************************//
template <class T>
class _DImageAcquireEventsDispT : public TAutoDriver<_DImageAcquireEvents>
{
public:
  _DImageAcquireEventsDispT(){}

  void Attach(LPUNKNOWN punk)
  { m_Dispatch = static_cast<T*>(punk); }

  void            __fastcall AcquireNotify(long DataNo, short Status);
  void            __fastcall FileSaveNotify(long DataNo, BSTR FileName, TOLEBOOL Success);

};
typedef _DImageAcquireEventsDispT<_DImageAcquireEvents> _DImageAcquireEventsDisp;

// *********************************************************************//
// DispIntf:  _DImageAcquire
// Flags:     (4112) Hidden Dispatchable
// GUID:      {242846A7-BC5F-11D2-A590-00A0C92509F5}
// *********************************************************************//
template <class T> void __fastcall
_DImageAcquireDispT<T>::set_AspectRatio(TOLEBOOL /*[VT_BOOL:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("AspectRatio"), DISPID(1));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> TOLEBOOL /*[VT_BOOL:0]*/ __fastcall
_DImageAcquireDispT<T>::get_AspectRatio()
{
  static _TDispID _dispid(*this, OLETEXT("AspectRatio"), DISPID(1));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageAcquireDispT<T>::set_FillingColor(::OLE_COLOR /*[VT_UI4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("FillingColor"), DISPID(2));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> ::OLE_COLOR /*[VT_UI4:0]*/ __fastcall
_DImageAcquireDispT<T>::get_FillingColor()
{
  static _TDispID _dispid(*this, OLETEXT("FillingColor"), DISPID(2));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageAcquireDispT<T>::set_ColorDepth(Gkmbbiaqlib_tlb::ImageColorConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("ColorDepth"), DISPID(10));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbbiaqlib_tlb::ImageColorConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbbiaqlib_tlb::ImageColorConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImageAcquireDispT<T>::get_ColorDepth()
{
  static _TDispID _dispid(*this, OLETEXT("ColorDepth"), DISPID(10));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbbiaqlib_tlb::ImageColorConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImageAcquireDispT<T>::set_Compression(Gkmbbiaqlib_tlb::CompressionConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("Compression"), DISPID(11));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbbiaqlib_tlb::CompressionConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbbiaqlib_tlb::CompressionConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImageAcquireDispT<T>::get_Compression()
{
  static _TDispID _dispid(*this, OLETEXT("Compression"), DISPID(11));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbbiaqlib_tlb::CompressionConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImageAcquireDispT<T>::set_ImageHeight(long /*[VT_I4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("ImageHeight"), DISPID(12));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> long /*[VT_I4:0]*/ __fastcall
_DImageAcquireDispT<T>::get_ImageHeight()
{
  static _TDispID _dispid(*this, OLETEXT("ImageHeight"), DISPID(12));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageAcquireDispT<T>::set_ImageWidth(long /*[VT_I4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("ImageWidth"), DISPID(13));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> long /*[VT_I4:0]*/ __fastcall
_DImageAcquireDispT<T>::get_ImageWidth()
{
  static _TDispID _dispid(*this, OLETEXT("ImageWidth"), DISPID(13));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageAcquireDispT<T>::set_InputSource(Gkmbbiaqlib_tlb::InputSourceConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("InputSource"), DISPID(14));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbbiaqlib_tlb::InputSourceConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbbiaqlib_tlb::InputSourceConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImageAcquireDispT<T>::get_InputSource()
{
  static _TDispID _dispid(*this, OLETEXT("InputSource"), DISPID(14));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbbiaqlib_tlb::InputSourceConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImageAcquireDispT<T>::set_MediaFormat(Gkmbbiaqlib_tlb::MediaFormatConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("MediaFormat"), DISPID(15));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbbiaqlib_tlb::MediaFormatConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbbiaqlib_tlb::MediaFormatConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImageAcquireDispT<T>::get_MediaFormat()
{
  static _TDispID _dispid(*this, OLETEXT("MediaFormat"), DISPID(15));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbbiaqlib_tlb::MediaFormatConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImageAcquireDispT<T>::set_Quality(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("Quality"), DISPID(16));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DImageAcquireDispT<T>::get_Quality()
{
  static _TDispID _dispid(*this, OLETEXT("Quality"), DISPID(16));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageAcquireDispT<T>::set_Rotation(Gkmbbiaqlib_tlb::RotateConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("Rotation"), DISPID(17));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbbiaqlib_tlb::RotateConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbbiaqlib_tlb::RotateConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImageAcquireDispT<T>::get_Rotation()
{
  static _TDispID _dispid(*this, OLETEXT("Rotation"), DISPID(17));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbbiaqlib_tlb::RotateConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImageAcquireDispT<T>::set_SaveDataPath(BSTR /*[VT_BSTR:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("SaveDataPath"), DISPID(3));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> BSTR /*[VT_BSTR:0]*/ __fastcall
_DImageAcquireDispT<T>::get_SaveDataPath()
{
  static _TDispID _dispid(*this, OLETEXT("SaveDataPath"), DISPID(3));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageAcquireDispT<T>::set_ShowUI(TOLEBOOL /*[VT_BOOL:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("ShowUI"), DISPID(4));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> TOLEBOOL /*[VT_BOOL:0]*/ __fastcall
_DImageAcquireDispT<T>::get_ShowUI()
{
  static _TDispID _dispid(*this, OLETEXT("ShowUI"), DISPID(4));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageAcquireDispT<T>::set_TwainAutoFeeder(TOLEBOOL /*[VT_BOOL:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("TwainAutoFeeder"), DISPID(5));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> TOLEBOOL /*[VT_BOOL:0]*/ __fastcall
_DImageAcquireDispT<T>::get_TwainAutoFeeder()
{
  static _TDispID _dispid(*this, OLETEXT("TwainAutoFeeder"), DISPID(5));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageAcquireDispT<T>::set_TwainSourceName(BSTR /*[VT_BSTR:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("TwainSourceName"), DISPID(6));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> BSTR /*[VT_BSTR:0]*/ __fastcall
_DImageAcquireDispT<T>::get_TwainSourceName()
{
  static _TDispID _dispid(*this, OLETEXT("TwainSourceName"), DISPID(6));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageAcquireDispT<T>::set_InterlacedImage(Gkmbbiaqlib_tlb::InterlaceConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("InterlacedImage"), DISPID(18));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbbiaqlib_tlb::InterlaceConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbbiaqlib_tlb::InterlaceConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImageAcquireDispT<T>::get_InterlacedImage()
{
  static _TDispID _dispid(*this, OLETEXT("InterlacedImage"), DISPID(18));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbbiaqlib_tlb::InterlaceConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImageAcquireDispT<T>::set_PcdDataSize(Gkmbbiaqlib_tlb::PcdDataSizeConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("PcdDataSize"), DISPID(19));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbbiaqlib_tlb::PcdDataSizeConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbbiaqlib_tlb::PcdDataSizeConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImageAcquireDispT<T>::get_PcdDataSize()
{
  static _TDispID _dispid(*this, OLETEXT("PcdDataSize"), DISPID(19));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbbiaqlib_tlb::PcdDataSizeConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImageAcquireDispT<T>::set_SrcRectUnit(Gkmbbiaqlib_tlb::InputUnitConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("SrcRectUnit"), DISPID(20));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbbiaqlib_tlb::InputUnitConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbbiaqlib_tlb::InputUnitConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImageAcquireDispT<T>::get_SrcRectUnit()
{
  static _TDispID _dispid(*this, OLETEXT("SrcRectUnit"), DISPID(20));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbbiaqlib_tlb::InputUnitConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImageAcquireDispT<T>::set_SrcLeft(float /*[VT_R4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("SrcLeft"), DISPID(21));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> float /*[VT_R4:0]*/ __fastcall
_DImageAcquireDispT<T>::get_SrcLeft()
{
  static _TDispID _dispid(*this, OLETEXT("SrcLeft"), DISPID(21));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageAcquireDispT<T>::set_SrcTop(float /*[VT_R4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("SrcTop"), DISPID(22));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> float /*[VT_R4:0]*/ __fastcall
_DImageAcquireDispT<T>::get_SrcTop()
{
  static _TDispID _dispid(*this, OLETEXT("SrcTop"), DISPID(22));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageAcquireDispT<T>::set_SrcWidth(float /*[VT_R4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("SrcWidth"), DISPID(23));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> float /*[VT_R4:0]*/ __fastcall
_DImageAcquireDispT<T>::get_SrcWidth()
{
  static _TDispID _dispid(*this, OLETEXT("SrcWidth"), DISPID(23));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageAcquireDispT<T>::set_SrcHeight(float /*[VT_R4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("SrcHeight"), DISPID(24));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> float /*[VT_R4:0]*/ __fastcall
_DImageAcquireDispT<T>::get_SrcHeight()
{
  static _TDispID _dispid(*this, OLETEXT("SrcHeight"), DISPID(24));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageAcquireDispT<T>::set_PcdPath(BSTR /*[VT_BSTR:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("PcdPath"), DISPID(7));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> BSTR /*[VT_BSTR:0]*/ __fastcall
_DImageAcquireDispT<T>::get_PcdPath()
{
  static _TDispID _dispid(*this, OLETEXT("PcdPath"), DISPID(7));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageAcquireDispT<T>::set_TwainPaperSize(Gkmbbiaqlib_tlb::TwainPaperSizeConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("TwainPaperSize"), DISPID(25));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbbiaqlib_tlb::TwainPaperSizeConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbbiaqlib_tlb::TwainPaperSizeConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImageAcquireDispT<T>::get_TwainPaperSize()
{
  static _TDispID _dispid(*this, OLETEXT("TwainPaperSize"), DISPID(25));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbbiaqlib_tlb::TwainPaperSizeConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImageAcquireDispT<T>::set_FileNameFormat(BSTR /*[VT_BSTR:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("FileNameFormat"), DISPID(8));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> BSTR /*[VT_BSTR:0]*/ __fastcall
_DImageAcquireDispT<T>::get_FileNameFormat()
{
  static _TDispID _dispid(*this, OLETEXT("FileNameFormat"), DISPID(8));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageAcquireDispT<T>::set_InitialNumber(long /*[VT_I4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("InitialNumber"), DISPID(26));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> long /*[VT_I4:0]*/ __fastcall
_DImageAcquireDispT<T>::get_InitialNumber()
{
  static _TDispID _dispid(*this, OLETEXT("InitialNumber"), DISPID(26));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageAcquireDispT<T>::set_AcquireCount(long /*[VT_I4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("AcquireCount"), DISPID(27));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> long /*[VT_I4:0]*/ __fastcall
_DImageAcquireDispT<T>::get_AcquireCount()
{
  static _TDispID _dispid(*this, OLETEXT("AcquireCount"), DISPID(27));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageAcquireDispT<T>::set_AcquireStartNo(long /*[VT_I4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("AcquireStartNo"), DISPID(28));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> long /*[VT_I4:0]*/ __fastcall
_DImageAcquireDispT<T>::get_AcquireStartNo()
{
  static _TDispID _dispid(*this, OLETEXT("AcquireStartNo"), DISPID(28));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageAcquireDispT<T>::set_AcquiredCount(long /*[VT_I4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("AcquiredCount"), DISPID(29));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> long /*[VT_I4:0]*/ __fastcall
_DImageAcquireDispT<T>::get_AcquiredCount()
{
  static _TDispID _dispid(*this, OLETEXT("AcquiredCount"), DISPID(29));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageAcquireDispT<T>::set_AutoSave(TOLEBOOL /*[VT_BOOL:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("AutoSave"), DISPID(9));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> TOLEBOOL /*[VT_BOOL:0]*/ __fastcall
_DImageAcquireDispT<T>::get_AutoSave()
{
  static _TDispID _dispid(*this, OLETEXT("AutoSave"), DISPID(9));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageAcquireDispT<T>::set_TwainResolution(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("TwainResolution"), DISPID(30));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DImageAcquireDispT<T>::get_TwainResolution()
{
  static _TDispID _dispid(*this, OLETEXT("TwainResolution"), DISPID(30));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageAcquireDispT<T>::set_MultiPage(TOLEBOOL /*[VT_BOOL:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("MultiPage"), DISPID(36));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> TOLEBOOL /*[VT_BOOL:0]*/ __fastcall
_DImageAcquireDispT<T>::get_MultiPage()
{
  static _TDispID _dispid(*this, OLETEXT("MultiPage"), DISPID(36));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageAcquireDispT<T>::set_XResolution(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("XResolution"), DISPID(37));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DImageAcquireDispT<T>::get_XResolution()
{
  static _TDispID _dispid(*this, OLETEXT("XResolution"), DISPID(37));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageAcquireDispT<T>::set_YResolution(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("YResolution"), DISPID(38));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DImageAcquireDispT<T>::get_YResolution()
{
  static _TDispID _dispid(*this, OLETEXT("YResolution"), DISPID(38));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageAcquireDispT<T>::SelectTwainSource()
{
  static _TDispID _dispid(*this, OLETEXT("SelectTwainSource"), DISPID(31));
  TAutoArgs<0> _args;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageAcquireDispT<T>::Cancel()
{
  static _TDispID _dispid(*this, OLETEXT("Cancel"), DISPID(32));
  OleProcedure(_dispid);
}

template <class T> TOLEBOOL __fastcall
_DImageAcquireDispT<T>::AcquireImages()
{
  static _TDispID _dispid(*this, OLETEXT("AcquireImages"), DISPID(33));
  TAutoArgs<0> _args;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> short __fastcall
_DImageAcquireDispT<T>::GetErrorCode()
{
  static _TDispID _dispid(*this, OLETEXT("GetErrorCode"), DISPID(34));
  TAutoArgs<0> _args;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageAcquireDispT<T>::GetMemHandle(OLE_HANDLE* MemHandle, long* MemSize)
{
  static _TDispID _dispid(*this, OLETEXT("GetMemHandle"), DISPID(35));
  TAutoArgs<2> _args;
  _args[1] = MemHandle /*[VT_INT:1]*/;
  _args[2] = MemSize /*[VT_I4:1]*/;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> OLE_HANDLE __fastcall
_DImageAcquireDispT<T>::GetDIB()
{
  static _TDispID _dispid(*this, OLETEXT("GetDIB"), DISPID(39));
  TAutoArgs<0> _args;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageAcquireDispT<T>::AboutBox()
{
  static _TDispID _dispid(*this, OLETEXT("AboutBox"), DISPID(-552));
  OleProcedure(_dispid);
}

// *********************************************************************//
// DispIntf:  _DImageAcquireEvents
// Flags:     (4096) Dispatchable
// GUID:      {242846A8-BC5F-11D2-A590-00A0C92509F5}
// *********************************************************************//
template <class T> void __fastcall
_DImageAcquireEventsDispT<T>::AcquireNotify(long DataNo, short Status)
{
  static _TDispID _dispid(/* AcquireNotify */ DISPID(1));
  TAutoArgs<2> _args;
  _args[1] = DataNo /*[VT_I4:0]*/;
  _args[2] = Status /*[VT_I2:0]*/;
  OleProcedure(_dispid, _args);
}

template <class T> void __fastcall
_DImageAcquireEventsDispT<T>::FileSaveNotify(long DataNo, BSTR FileName, TOLEBOOL Success)
{
  static _TDispID _dispid(/* FileSaveNotify */ DISPID(2));
  TAutoArgs<3> _args;
  _args[1] = DataNo /*[VT_I4:0]*/;
  _args[2] = FileName /*[VT_BSTR:0]*/;
  _args[3] = Success /*[VT_BOOL:0]*/;
  OleProcedure(_dispid, _args);
}

#endif  //   __TLB_NO_INTERFACE_WRAPPERS


#if !defined(__TLB_NO_EVENT_WRAPPERS) && defined(USING_ATLVCL)
// *********************************************************************//
// CONNECTIONPOINT/EVENT PROXY
// CoClass         : ImageAcquire
// Event Interface : _DImageAcquireEvents
// *********************************************************************//
template <class T>
class TEvents_ImageAcquire : public IConnectionPointImpl<T,
                                                 &DIID__DImageAcquireEvents,
                                                 CComUnkArray<CONNECTIONPOINT_ARRAY_SIZE> >
{
public:
  void            Fire_AcquireNotify(long DataNo, short Status);
  void            Fire_FileSaveNotify(long DataNo, BSTR FileName, TOLEBOOL Success);
protected:
  _DImageAcquireEventsDisp m_EventIntfObj;
};

template <class T> void
TEvents_ImageAcquire<T>::Fire_AcquireNotify(long DataNo, short Status)
{
  T * pT = (T*)this;
  pT->Lock();
  IUnknown ** pp = m_vec.begin();
  while (pp < m_vec.end())
  {
    if (*pp != NULL)
    {
      m_EventIntfObj.Attach(*pp);
      m_EventIntfObj.AcquireNotify(DataNo, Status);
      m_EventIntfObj.Attach(0);
    }
    pp++;
  }
  pT->Unlock();
}

template <class T> void
TEvents_ImageAcquire<T>::Fire_FileSaveNotify(long DataNo, BSTR FileName, TOLEBOOL Success)
{
  T * pT = (T*)this;
  pT->Lock();
  IUnknown ** pp = m_vec.begin();
  while (pp < m_vec.end())
  {
    if (*pp != NULL)
    {
      m_EventIntfObj.Attach(*pp);
      m_EventIntfObj.FileSaveNotify(DataNo, FileName, Success);
      m_EventIntfObj.Attach(0);
    }
    pp++;
  }
  pT->Unlock();
}

#endif  //   __TLB_NO_EVENT_WRAPPERS

};     // namespace Gkmbbiaqlib_tlb

#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using  namespace Gkmbbiaqlib_tlb;
#endif

#pragma option pop

//#endif // __GKMBBIAQLib_TLB_h__

namespace Gkmbbiaqlib_tlb
{

// *********************************************************************//
// HelpString: GKit Image Auto Acquire Control Borland Edition
// Version:    2.0
// *********************************************************************//


// *********************************************************************//
// OCX PROXY CLASS DECLARATION
// Control Name     : TGKitImageAcquire
// Help String      : GKit Image Auto Acquire Control Borland Edition
// Default Interface: _DImageAcquire
// Def. Intf. Object: _DImageAcquireDisp
// Def. Intf. DISP? : Yes
// Event   Interface: _DImageAcquireEvents
// TypeFlags        : (38) CanCreate Licensed Control
// *********************************************************************//

// *********************************************************************//
// Definition of closures to allow VCL handlers to catch OCX events.    //
// *********************************************************************//
typedef void __fastcall (__closure * TGKitImageAcquireAcquireNotify)(System::TObject * Sender, 
                                                                     long DataNo, short Status);
typedef void __fastcall (__closure * TGKitImageAcquireFileSaveNotify)(System::TObject * Sender, 
                                                                      long DataNo, BSTR FileName, 
                                                                      TOLEBOOL Success);
//+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
// Proxy class to host GKit Image Auto Acquire Control Borland Edition in CBuilder IDE/Applications.
//-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
class PACKAGE TGKitImageAcquire : public TOleControl
{
  OVERLOADED_PROP_METHODS;
  static TNoParam  OptParam;
  static GUID      DEF_CTL_INTF;

  // Instance of Closures to expose OCX Events as VCL ones
  //
  TGKitImageAcquireAcquireNotify FOnAcquireNotify;
  TGKitImageAcquireFileSaveNotify FOnFileSaveNotify;

  // Default Interace of OCX
  //
  _DImageAcquireDisp m_OCXIntf;

  // VCL Property Getters/Setters which delegate to OCX
  //

  // Static variables used by all instances of OCX proxy
  //
  static int          EventDispIDs[2];
  static WCHAR        wLicenseKey[104];
  static TControlData CControlData;
  static GUID         CTL_DEF_INTF;

  // Method providing access to interface as __property 
  //
  _DImageAcquireDisp __fastcall GetControlInterface(void);

protected:
  void     __fastcall CreateControl  (void);
  void     __fastcall InitControlData(void);

public:
  virtual  __fastcall TGKitImageAcquire(TComponent* AOwner) : TOleControl(AOwner)
  {};
  virtual  __fastcall TGKitImageAcquire(HWND        Parent) : TOleControl(Parent)
  {};

  // OCX methods
  //
  TOLEBOOL        __fastcall SelectTwainSource(void);
  void            __fastcall Cancel(void);
  TOLEBOOL        __fastcall AcquireImages(void);
  short           __fastcall GetErrorCode(void);
  TOLEBOOL        __fastcall GetMemHandle(OLE_HANDLE* MemHandle, long* MemSize);
  OLE_HANDLE      __fastcall GetDIB(void);
  void            __fastcall AboutBox(void);

  // OCX properties
  //
  __property _DImageAcquireDisp ControlInterface={ read=GetControlInterface };

  // Published properties
  //
__published:

  // Standard/Extended properties
  //

  // OCX properties
  //
  __property bool AspectRatio={ read=GetWordBoolProp, write=SetWordBoolProp, stored=false, index=1 };
  __property Graphics::TColor FillingColor={ read=GetTColorProp, write=SetTColorProp, stored=false, index=2 };
  __property TOleEnum ColorDepth={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=10 };
  __property TOleEnum Compression={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=11 };
  __property int ImageHeight={ read=GetIntegerProp, write=SetIntegerProp, stored=false, index=12 };
  __property int ImageWidth={ read=GetIntegerProp, write=SetIntegerProp, stored=false, index=13 };
  __property TOleEnum InputSource={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=14 };
  __property TOleEnum MediaFormat={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=15 };
  __property short Quality={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=16 };
  __property TOleEnum Rotation={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=17 };
  __property System::WideString SaveDataPath={ read=GetWideStringProp, write=SetWideStringProp, stored=false, index=3 };
  __property bool ShowUI={ read=GetWordBoolProp, write=SetWordBoolProp, stored=false, index=4 };
  __property bool TwainAutoFeeder={ read=GetWordBoolProp, write=SetWordBoolProp, stored=false, index=5 };
  __property System::WideString TwainSourceName={ read=GetWideStringProp, write=SetWideStringProp, stored=false, index=6 };
  __property TOleEnum InterlacedImage={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=18 };
  __property TOleEnum PcdDataSize={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=19 };
  __property TOleEnum SrcRectUnit={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=20 };
  __property float SrcLeft={ read=GetSingleProp, write=SetSingleProp, stored=false, index=21 };
  __property float SrcTop={ read=GetSingleProp, write=SetSingleProp, stored=false, index=22 };
  __property float SrcWidth={ read=GetSingleProp, write=SetSingleProp, stored=false, index=23 };
  __property float SrcHeight={ read=GetSingleProp, write=SetSingleProp, stored=false, index=24 };
  __property System::WideString PcdPath={ read=GetWideStringProp, write=SetWideStringProp, stored=false, index=7 };
  __property TOleEnum TwainPaperSize={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=25 };
  __property System::WideString FileNameFormat={ read=GetWideStringProp, write=SetWideStringProp, stored=false, index=8 };
  __property int InitialNumber={ read=GetIntegerProp, write=SetIntegerProp, stored=false, index=26 };
  __property int AcquireCount={ read=GetIntegerProp, write=SetIntegerProp, stored=false, index=27 };
  __property int AcquireStartNo={ read=GetIntegerProp, write=SetIntegerProp, stored=false, index=28 };
  __property int AcquiredCount={ read=GetIntegerProp, write=SetIntegerProp, stored=false, index=29 };
  __property bool AutoSave={ read=GetWordBoolProp, write=SetWordBoolProp, stored=false, index=9 };
  __property short TwainResolution={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=30 };
  __property bool MultiPage={ read=GetWordBoolProp, write=SetWordBoolProp, stored=false, index=36 };
  __property short XResolution={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=37 };
  __property short YResolution={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=38 };

  // OCX Events
  //
  __property TGKitImageAcquireAcquireNotify OnAcquireNotify={ read=FOnAcquireNotify, write=FOnAcquireNotify };
  __property TGKitImageAcquireFileSaveNotify OnFileSaveNotify={ read=FOnFileSaveNotify, write=FOnFileSaveNotify };
};
typedef TGKitImageAcquire  TGKitImageAcquireProxy;

};     // namespace Gkmbbiaqlib_tlb

#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using  namespace Gkmbbiaqlib_tlb;
#endif

#pragma option pop

#endif // __GKMBBIAQLib_OCX_h__
