// ************************************************************************ //
//                                                                          //
// GKit Image View Control Borland Edition                                  //
//                                                                          //
// GKitImageView.h Copyright (c) FUJITSU SHIZUOKA ENGINEERING LIMITED 1999  //
//                                                                          //
// ************************************************************************ //

// C++ TLBWRTR : $Revision:   1.96.1.27  $
// File generated on 99/03/04 14:48:09 from Type Library described below.

// ************************************************************************ //
// Type Lib: C:\FFC\GKITOCX.BE\MEDIATOOLS\GKMBIVW.OCX
// IID\LCID: {48523B84-B76E-11D2-BF10-00A0C92400D1}\0
// Helpfile: C:\FFC\GKITOCX.BE\MEDIATOOLS\GKMBIVW.hlp
// DepndLst: 
//   (1) v2.0 stdole, (C:\WINDOWS\SYSTEM\STDOLE2.TLB)
//   (2) v4.0 StdVCL, (C:\WINDOWS\SYSTEM\STDVCL40.DLL)
//   (3) v2.0 StdType, (C:\WINDOWS\SYSTEM\OLEPRO32.DLL)
// ************************************************************************ //
#ifndef   __GKMBIVWLib_OCX_h__
#define   __GKMBIVWLib_OCX_h__

#pragma option push -b -w-inl

#include <vcl/utilcls.h>
#if !defined(__UTILCLS_H_VERSION) || (__UTILCLS_H_VERSION < 0x0101)
#error "This file requires an newer version of the header file UTILCLS.H"
#endif

#include <olectl.h>
#include <ocidl.h>
#if !defined(_NO_VCL)   // For Console applications that don't use VCL
#include <vcl/stdvcl.hpp>
#endif  //   _NO_VCL
#include <vcl/ocxproxy.h>

//#include "GKMBIVWLib_TLB.h"

// C++ TLBWRTR : $Revision:   1.96.1.27  $
// File generated on 99/03/04 14:48:09 from Type Library described below.

// ************************************************************************ //
// Type Lib: C:\FFC\GKITOCX.BE\MEDIATOOLS\GKMBIVW.OCX
// IID\LCID: {48523B84-B76E-11D2-BF10-00A0C92400D1}\0
// Helpfile: C:\FFC\GKITOCX.BE\MEDIATOOLS\GKMBIVW.hlp
// DepndLst: 
//   (1) v2.0 stdole, (C:\WINDOWS\SYSTEM\STDOLE2.TLB)
//   (2) v4.0 StdVCL, (C:\WINDOWS\SYSTEM\STDVCL40.DLL)
//   (3) v2.0 StdType, (C:\WINDOWS\SYSTEM\OLEPRO32.DLL)
// ************************************************************************ //
//#ifndef   __GKMBIVWLib_TLB_h__
//#define   __GKMBIVWLib_TLB_h__

#pragma option push -b -w-inl

#include <vcl/utilcls.h>
#if !defined(__UTILCLS_H_VERSION) || (__UTILCLS_H_VERSION < 0x0101)
#error "This file requires an newer version of the header file UTILCLS.H"
#endif

#include <olectl.h>
#include <ocidl.h>
#if defined(USING_ATLVCL) || defined(USING_ATL)
#if !defined(__TLB_NO_EVENT_WRAPPERS)
#include <atl/atlmod.h>
#endif
#endif


// *********************************************************************//
// Forward reference of some VCL types (to avoid including STDVCL.HPP)  //
// *********************************************************************//
namespace Stdvcl {class IStrings; class IStringsDisp;}
using namespace Stdvcl;

namespace Gkmbivwlib_tlb
{

// *********************************************************************//
// HelpString: GKit Image View Control Borland Edition
// Version:    2.0
// *********************************************************************//


// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:      //
//   Type Libraries     : LIBID_xxxx                                    //
//   CoClasses          : CLSID_xxxx                                    //
//   DISPInterfaces     : DIID_xxxx                                     //
//   Non-DISP interfaces: IID_xxxx                                      //
// *********************************************************************//
DEFINE_GUID(LIBID_GKMBIVWLib, 0x48523B84, 0xB76E, 0x11D2, 0xBF, 0x10, 0x00, 0xA0, 0xC9, 0x24, 0x00, 0xD1);
DEFINE_GUID(DIID__DImageView, 0x48523B85, 0xB76E, 0x11D2, 0xBF, 0x10, 0x00, 0xA0, 0xC9, 0x24, 0x00, 0xD1);
DEFINE_GUID(DIID__DImageViewEvents, 0x48523B86, 0xB76E, 0x11D2, 0xBF, 0x10, 0x00, 0xA0, 0xC9, 0x24, 0x00, 0xD1);
DEFINE_GUID(CLSID_ImageView, 0x48523B87, 0xB76E, 0x11D2, 0xBF, 0x10, 0x00, 0xA0, 0xC9, 0x24, 0x00, 0xD1);

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                  //
// *********************************************************************//
enum      MediaFormatConstants;
enum      ImageColorConstants;
enum      ViewHorzPlaceConstants;
enum      ViewVertPlaceConstants;
enum      MorphologyConstants;
enum      InterpolationConstants;
enum      PosEventConstants;
enum      EffectConstants;
enum      ErrorConstants;
interface DECLSPEC_UUID("{48523B85-B76E-11D2-BF10-00A0C92400D1}") _DImageView;
interface DECLSPEC_UUID("{48523B86-B76E-11D2-BF10-00A0C92400D1}") _DImageViewEvents;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                     //
// (NOTE: Here we map each CoClass to its Default Interface)            //
//                                                                      //
// The LIBID_OF_ macro(s) map a LIBID_OF_CoClassName to the GUID of this//
// TypeLibrary. It simplifies the updating of macros when CoClass name  //
// change.                                                              //
// *********************************************************************//
typedef _DImageView ImageView;

#define LIBID_OF_ImageView (&LIBID_GKMBIVWLib)

// *********************************************************************//
// Declaration of Enumerations defined in Type Library                  //
// *********************************************************************//
typedef enum MediaFormatConstants
{
  cwmFileBMP = 101, 
  cwmFileTIFF = 102, 
  cwmFileJPEG = 103, 
  cwmFilePCX = 104, 
  cwmFilePNG = 106, 
  cwmFileSIA = 107
} MediaFormatConstants;

typedef enum ImageColorConstants
{
  cwmColorBitmap = 1, 
  cwmColor4 = 2, 
  cwmColor8 = 3, 
  cwmColor16 = 4, 
  cwmColor32 = 5, 
  cwmColor64 = 6, 
  cwmColor128 = 7, 
  cwmColor256 = 8, 
  cwmColorGrayscale = 9, 
  cwmColor32K = 10, 
  cwmColor64K = 11, 
  cwmColorRGB = 12
} ImageColorConstants;

typedef enum ViewHorzPlaceConstants
{
  cwmHorzPlaceLeft = 0, 
  cwmHorzPlaceCenter = 1, 
  cwmHorzPlaceRight = 2
} ViewHorzPlaceConstants;

typedef enum ViewVertPlaceConstants
{
  cwmVertPlaceTop = 0, 
  cwmVertPlaceCenter = 1, 
  cwmVertPlaceBottom = 2
} ViewVertPlaceConstants;

typedef enum MorphologyConstants
{
  cwmMorphologyNone = 1, 
  cwmMorphologyOn = 2, 
  cwmMorphologyOff = 3
} MorphologyConstants;

typedef enum InterpolationConstants
{
  cwmInterNearest = 1, 
  cwmInterBilinear = 2, 
  cwmInterBSpline = 3, 
  cwmInterConvolution = 4
} InterpolationConstants;

typedef enum PosEventConstants
{
  cwmPosEventNone = 0, 
  cwmPosEventPos = 1
} PosEventConstants;

typedef enum EffectConstants
{
  cwmEffectNone = 0, 
  cwmEffectFadeIn = 1, 
  cwmEffectFadeOut = 2, 
  cwmEffectFadeInOut = 3, 
  cwmEffectFadeChange = 4, 
  cwmEffectClearWipe1 = 11, 
  cwmEffectClearWipe2 = 12, 
  cwmEffectClearWipe3 = 13, 
  cwmEffectClearWipe4 = 14, 
  cwmEffectWipe1 = 21, 
  cwmEffectWipe2 = 22, 
  cwmEffectWipe3 = 23, 
  cwmEffectWipe4 = 24, 
  cwmEffectClearScrollIn1 = 31, 
  cwmEffectClearScrollIn2 = 32, 
  cwmEffectClearScrollIn3 = 33, 
  cwmEffectClearScrollIn4 = 34, 
  cwmEffectScrollIn1 = 41, 
  cwmEffectScrollIn2 = 42, 
  cwmEffectScrollIn3 = 43, 
  cwmEffectScrollIn4 = 44, 
  cwmEffectScrollOut1 = 51, 
  cwmEffectScrollOut2 = 52, 
  cwmEffectScrollOut3 = 53, 
  cwmEffectScrollOut4 = 54, 
  cwmEffectSlide1 = 61, 
  cwmEffectSlide2 = 62, 
  cwmEffectSlide3 = 63, 
  cwmEffectSlide4 = 64, 
  cwmEffectRandomWipe1 = 71, 
  cwmEffectRandomWipe2 = 72
} EffectConstants;

typedef enum ErrorConstants
{
  cwmSuccess = 0, 
  cwmErrInvalidParam = 1001, 
  cwmErrInvalidRectValue = 1002, 
  cwmErrInvalidIndex = 1003, 
  cwmErrInvalidCompression = 1010, 
  cwmErrInvalidColorDepth = 1011, 
  cwmErrInvalidSaveFormat = 1012, 
  cwmErrSequenceError = 1100, 
  cwmErrUnsetMediaData = 1101, 
  cwmErrUserAbort = 1110, 
  cwmErrAcquireNotComplete = 1111, 
  cwmErrNotSupportFileFormat = 2000, 
  cwmErrInvalidFileFormat = 2001, 
  cwmErrFileNotFound = 2110, 
  cwmErrFileAlreadyExists = 2111, 
  cwmErrPathNotFound = 2112, 
  cwmErrFileLoadIncomplete = 2113, 
  cwmErrFileIOError = 2120, 
  cwmErrDiskFull = 2130, 
  cwmErrClipboardError = 2200, 
  cwmErrClipboardInvalidFormat = 2201, 
  cwmErrPrtError = 7000, 
  cwmErrPrtAppAbort = 7001, 
  cwmErrPrtUserAbort = 7002, 
  cwmErrDeviceError = 8000, 
  cwmErrDeviceNotFound = 8001, 
  cwmErrDeviceNotInstall = 8002, 
  cwmErrCDDriveNotFound = 8003, 
  cwmErrDeviceBusy = 8010, 
  cwmErrOutofMemory = 9000, 
  cwmErrSystemError = 9900, 
  cwmErrSystemNotFound = 9910, 
  cwmErrTwainDllNotFound = 9911, 
  cwmErrPcdLibNotFound = 9912
} ErrorConstants;

// *********************************************************************//
// Interface: _DImageView
// Flags:     (4112) Hidden Dispatchable
// GUID:      {48523B85-B76E-11D2-BF10-00A0C92400D1}
// *********************************************************************//
interface _DImageView : public IDispatch
{
// DispInterfaces have no methods. Their methods and properties are
// accessed via IDispatch::Invoke. See the class _DImageViewDisp provided
// below for an easy way to access the methods/properties of this
// interface.
};

// *********************************************************************//
// Interface: _DImageViewEvents
// Flags:     (4096) Dispatchable
// GUID:      {48523B86-B76E-11D2-BF10-00A0C92400D1}
// *********************************************************************//
interface _DImageViewEvents : public IDispatch
{
// DispInterfaces have no methods. Their methods and properties are
// accessed via IDispatch::Invoke. See the class _DImageViewEventsDisp provided
// below for an easy way to access the methods/properties of this
// interface.
};

#if !defined(__TLB_NO_INTERFACE_WRAPPERS)
// *********************************************************************//
// DispIntf:  _DImageView
// Flags:     (4112) Hidden Dispatchable
// GUID:      {48523B85-B76E-11D2-BF10-00A0C92400D1}
// *********************************************************************//
template<class T>
class _DImageViewDispT : public TAutoDriver<_DImageView>
{
public:
  _DImageViewDispT(){}

  _DImageViewDispT(_DImageView *pintf)
  {
    TAutoDriver<_DImageView>::Bind(pintf);
  }

  _DImageViewDispT& operator=(_DImageView *pintf)
  {
    TAutoDriver<_DImageView>::Bind(pintf);
    return *this;
  }

  HRESULT BindDefault(/*Binds to new instance of CoClass ImageView*/)
  {
    return OLECHECK(Bind(CLSID_ImageView));
  }

  HRESULT BindRunning(/*Binds to a running instance of CoClass ImageView*/)
  {
    return BindToActive(CLSID_ImageView);
  }

  void            __fastcall set_FileName(BSTR Value);
  BSTR            __fastcall get_FileName();
  void            __fastcall set_ImageWidth(long Value);
  long            __fastcall get_ImageWidth();
  void            __fastcall set_ImageHeight(long Value);
  long            __fastcall get_ImageHeight();
  void            __fastcall set_ColorDepth(Gkmbivwlib_tlb::ImageColorConstants Value);
  Gkmbivwlib_tlb::ImageColorConstants __fastcall get_ColorDepth();
  void            __fastcall set_TotalPage(short Value);
  short           __fastcall get_TotalPage();
  void            __fastcall set_Page(short Value);
  short           __fastcall get_Page();
  void            __fastcall set_SourceLeft(long Value);
  long            __fastcall get_SourceLeft();
  void            __fastcall set_SourceTop(long Value);
  long            __fastcall get_SourceTop();
  void            __fastcall set_SourceWidth(long Value);
  long            __fastcall get_SourceWidth();
  void            __fastcall set_SourceHeight(long Value);
  long            __fastcall get_SourceHeight();
  void            __fastcall set_HorzScrollMin(short Value);
  short           __fastcall get_HorzScrollMin();
  void            __fastcall set_HorzScrollMax(short Value);
  short           __fastcall get_HorzScrollMax();
  void            __fastcall set_HorzScrollPos(short Value);
  short           __fastcall get_HorzScrollPos();
  void            __fastcall set_VertScrollMin(short Value);
  short           __fastcall get_VertScrollMin();
  void            __fastcall set_VertScrollMax(short Value);
  short           __fastcall get_VertScrollMax();
  void            __fastcall set_VertScrollPos(short Value);
  short           __fastcall get_VertScrollPos();
  void            __fastcall set_ViewportLeft(long Value);
  long            __fastcall get_ViewportLeft();
  void            __fastcall set_ViewportTop(long Value);
  long            __fastcall get_ViewportTop();
  void            __fastcall set_ViewportWidth(long Value);
  long            __fastcall get_ViewportWidth();
  void            __fastcall set_ViewportHeight(long Value);
  long            __fastcall get_ViewportHeight();
  void            __fastcall set_HorzPos(Gkmbivwlib_tlb::ViewHorzPlaceConstants Value);
  Gkmbivwlib_tlb::ViewHorzPlaceConstants __fastcall get_HorzPos();
  void            __fastcall set_VertPos(Gkmbivwlib_tlb::ViewVertPlaceConstants Value);
  Gkmbivwlib_tlb::ViewVertPlaceConstants __fastcall get_VertPos();
  void            __fastcall set_Zoom(short Value);
  short           __fastcall get_Zoom();
  void            __fastcall set_Stretch(TOLEBOOL Value);
  TOLEBOOL        __fastcall get_Stretch();
  void            __fastcall set_AspectRatio(TOLEBOOL Value);
  TOLEBOOL        __fastcall get_AspectRatio();
  void            __fastcall set_ScrollBar(TOLEBOOL Value);
  TOLEBOOL        __fastcall get_ScrollBar();
  void            __fastcall set_ControlBar(TOLEBOOL Value);
  TOLEBOOL        __fastcall get_ControlBar();
  void            __fastcall set_DispDelay(TOLEBOOL Value);
  TOLEBOOL        __fastcall get_DispDelay();
  void            __fastcall set_AutoColorDecrease(TOLEBOOL Value);
  TOLEBOOL        __fastcall get_AutoColorDecrease();
  void            __fastcall set_Morphology(Gkmbivwlib_tlb::MorphologyConstants Value);
  Gkmbivwlib_tlb::MorphologyConstants __fastcall get_Morphology();
  void            __fastcall set_Interpolation(Gkmbivwlib_tlb::InterpolationConstants Value);
  Gkmbivwlib_tlb::InterpolationConstants __fastcall get_Interpolation();
  void            __fastcall set_Effect(Gkmbivwlib_tlb::EffectConstants Value);
  Gkmbivwlib_tlb::EffectConstants __fastcall get_Effect();
  void            __fastcall set_PositionEvent(Gkmbivwlib_tlb::PosEventConstants Value);
  Gkmbivwlib_tlb::PosEventConstants __fastcall get_PositionEvent();
  void            __fastcall set_MediaFormat(Gkmbivwlib_tlb::MediaFormatConstants Value);
  Gkmbivwlib_tlb::MediaFormatConstants __fastcall get_MediaFormat();
  void            __fastcall set_ReadyState(long Value);
  long            __fastcall get_ReadyState();
  void            __fastcall set_Appearance(short Value);
  short           __fastcall get_Appearance();
  void            __fastcall set_BackColor(::OLE_COLOR Value);
  ::OLE_COLOR     __fastcall get_BackColor();
  void            __fastcall set_BorderStyle(short Value);
  short           __fastcall get_BorderStyle();
  TOLEBOOL        __fastcall SetMemHandle(OLE_HANDLE MemHandle, long MemSize);
  short           __fastcall GetErrorCode();
  void            __fastcall Refresh();
  TOLEBOOL        __fastcall SetDIB(OLE_HANDLE hDIB, TOLEBOOL bOwner);
  TOLEBOOL        __fastcall CopyToClipboard();
  TOLEBOOL        __fastcall PasteFromClipboard();
  void            __fastcall AboutBox();

  __property   BSTR            FileName = {read = get_FileName, write = set_FileName};
  __property   long            ImageWidth = {read = get_ImageWidth, write = set_ImageWidth};
  __property   long            ImageHeight = {read = get_ImageHeight, write = set_ImageHeight};
  __property   Gkmbivwlib_tlb::ImageColorConstants ColorDepth = {read = get_ColorDepth, write = set_ColorDepth};
  __property   short           TotalPage = {read = get_TotalPage, write = set_TotalPage};
  __property   short           Page = {read = get_Page, write = set_Page};
  __property   long            SourceLeft = {read = get_SourceLeft, write = set_SourceLeft};
  __property   long            SourceTop = {read = get_SourceTop, write = set_SourceTop};
  __property   long            SourceWidth = {read = get_SourceWidth, write = set_SourceWidth};
  __property   long            SourceHeight = {read = get_SourceHeight, write = set_SourceHeight};
  __property   short           HorzScrollMin = {read = get_HorzScrollMin, write = set_HorzScrollMin};
  __property   short           HorzScrollMax = {read = get_HorzScrollMax, write = set_HorzScrollMax};
  __property   short           HorzScrollPos = {read = get_HorzScrollPos, write = set_HorzScrollPos};
  __property   short           VertScrollMin = {read = get_VertScrollMin, write = set_VertScrollMin};
  __property   short           VertScrollMax = {read = get_VertScrollMax, write = set_VertScrollMax};
  __property   short           VertScrollPos = {read = get_VertScrollPos, write = set_VertScrollPos};
  __property   long            ViewportLeft = {read = get_ViewportLeft, write = set_ViewportLeft};
  __property   long            ViewportTop = {read = get_ViewportTop, write = set_ViewportTop};
  __property   long            ViewportWidth = {read = get_ViewportWidth, write = set_ViewportWidth};
  __property   long            ViewportHeight = {read = get_ViewportHeight, write = set_ViewportHeight};
  __property   Gkmbivwlib_tlb::ViewHorzPlaceConstants HorzPos = {read = get_HorzPos, write = set_HorzPos};
  __property   Gkmbivwlib_tlb::ViewVertPlaceConstants VertPos = {read = get_VertPos, write = set_VertPos};
  __property   short           Zoom = {read = get_Zoom, write = set_Zoom};
  __property   TOLEBOOL        Stretch = {read = get_Stretch, write = set_Stretch};
  __property   TOLEBOOL        AspectRatio = {read = get_AspectRatio, write = set_AspectRatio};
  __property   TOLEBOOL        ScrollBar = {read = get_ScrollBar, write = set_ScrollBar};
  __property   TOLEBOOL        ControlBar = {read = get_ControlBar, write = set_ControlBar};
  __property   TOLEBOOL        DispDelay = {read = get_DispDelay, write = set_DispDelay};
  __property   TOLEBOOL        AutoColorDecrease = {read = get_AutoColorDecrease, write = set_AutoColorDecrease};
  __property   Gkmbivwlib_tlb::MorphologyConstants Morphology = {read = get_Morphology, write = set_Morphology};
  __property   Gkmbivwlib_tlb::InterpolationConstants Interpolation = {read = get_Interpolation, write = set_Interpolation};
  __property   Gkmbivwlib_tlb::EffectConstants Effect = {read = get_Effect, write = set_Effect};
  __property   Gkmbivwlib_tlb::PosEventConstants PositionEvent = {read = get_PositionEvent, write = set_PositionEvent};
  __property   Gkmbivwlib_tlb::MediaFormatConstants MediaFormat = {read = get_MediaFormat, write = set_MediaFormat};
  __property   long            ReadyState = {read = get_ReadyState};
  __property   short           Appearance = {read = get_Appearance, write = set_Appearance};
  __property   ::OLE_COLOR     BackColor = {read = get_BackColor, write = set_BackColor};
  __property   short           BorderStyle = {read = get_BorderStyle, write = set_BorderStyle};
};
typedef _DImageViewDispT<_DImageView> _DImageViewDisp;

// *********************************************************************//
// DispIntf:  _DImageViewEvents
// Flags:     (4096) Dispatchable
// GUID:      {48523B86-B76E-11D2-BF10-00A0C92400D1}
// *********************************************************************//
template <class T>
class _DImageViewEventsDispT : public TAutoDriver<_DImageViewEvents>
{
public:
  _DImageViewEventsDispT(){}

  void Attach(LPUNKNOWN punk)
  { m_Dispatch = static_cast<T*>(punk); }

  void            __fastcall NotifyPos(long x, long y);
  void            __fastcall ReadyStateChange();
  void            __fastcall Click();
  void            __fastcall DblClick();
  void            __fastcall Error(short Number, BSTR* Description, SCODE Scode, BSTR Source, 
                                   BSTR HelpFile, long HelpContext, TOLEBOOL* CancelDisplay);
  void            __fastcall MouseDown(short Button, short Shift, OLE_XPOS_PIXELS x, 
                                       OLE_YPOS_PIXELS y);
  void            __fastcall MouseUp(short Button, short Shift, OLE_XPOS_PIXELS x, OLE_YPOS_PIXELS y);
  void            __fastcall MouseMove(short Button, short Shift, OLE_XPOS_PIXELS x, 
                                       OLE_YPOS_PIXELS y);
  void            __fastcall KeyDown(short* KeyCode, short Shift);
  void            __fastcall KeyUp(short* KeyCode, short Shift);

};
typedef _DImageViewEventsDispT<_DImageViewEvents> _DImageViewEventsDisp;

// *********************************************************************//
// DispIntf:  _DImageView
// Flags:     (4112) Hidden Dispatchable
// GUID:      {48523B85-B76E-11D2-BF10-00A0C92400D1}
// *********************************************************************//
template <class T> void __fastcall
_DImageViewDispT<T>::set_FileName(BSTR /*[VT_BSTR:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("FileName"), DISPID(1));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> BSTR /*[VT_BSTR:0]*/ __fastcall
_DImageViewDispT<T>::get_FileName()
{
  static _TDispID _dispid(*this, OLETEXT("FileName"), DISPID(1));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_ImageWidth(long /*[VT_I4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("ImageWidth"), DISPID(2));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> long /*[VT_I4:0]*/ __fastcall
_DImageViewDispT<T>::get_ImageWidth()
{
  static _TDispID _dispid(*this, OLETEXT("ImageWidth"), DISPID(2));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_ImageHeight(long /*[VT_I4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("ImageHeight"), DISPID(3));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> long /*[VT_I4:0]*/ __fastcall
_DImageViewDispT<T>::get_ImageHeight()
{
  static _TDispID _dispid(*this, OLETEXT("ImageHeight"), DISPID(3));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_ColorDepth(Gkmbivwlib_tlb::ImageColorConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("ColorDepth"), DISPID(4));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbivwlib_tlb::ImageColorConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbivwlib_tlb::ImageColorConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImageViewDispT<T>::get_ColorDepth()
{
  static _TDispID _dispid(*this, OLETEXT("ColorDepth"), DISPID(4));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbivwlib_tlb::ImageColorConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_TotalPage(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("TotalPage"), DISPID(5));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DImageViewDispT<T>::get_TotalPage()
{
  static _TDispID _dispid(*this, OLETEXT("TotalPage"), DISPID(5));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_Page(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("Page"), DISPID(6));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DImageViewDispT<T>::get_Page()
{
  static _TDispID _dispid(*this, OLETEXT("Page"), DISPID(6));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_SourceLeft(long /*[VT_I4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("SourceLeft"), DISPID(7));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> long /*[VT_I4:0]*/ __fastcall
_DImageViewDispT<T>::get_SourceLeft()
{
  static _TDispID _dispid(*this, OLETEXT("SourceLeft"), DISPID(7));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_SourceTop(long /*[VT_I4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("SourceTop"), DISPID(8));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> long /*[VT_I4:0]*/ __fastcall
_DImageViewDispT<T>::get_SourceTop()
{
  static _TDispID _dispid(*this, OLETEXT("SourceTop"), DISPID(8));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_SourceWidth(long /*[VT_I4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("SourceWidth"), DISPID(9));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> long /*[VT_I4:0]*/ __fastcall
_DImageViewDispT<T>::get_SourceWidth()
{
  static _TDispID _dispid(*this, OLETEXT("SourceWidth"), DISPID(9));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_SourceHeight(long /*[VT_I4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("SourceHeight"), DISPID(10));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> long /*[VT_I4:0]*/ __fastcall
_DImageViewDispT<T>::get_SourceHeight()
{
  static _TDispID _dispid(*this, OLETEXT("SourceHeight"), DISPID(10));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_HorzScrollMin(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("HorzScrollMin"), DISPID(11));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DImageViewDispT<T>::get_HorzScrollMin()
{
  static _TDispID _dispid(*this, OLETEXT("HorzScrollMin"), DISPID(11));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_HorzScrollMax(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("HorzScrollMax"), DISPID(12));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DImageViewDispT<T>::get_HorzScrollMax()
{
  static _TDispID _dispid(*this, OLETEXT("HorzScrollMax"), DISPID(12));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_HorzScrollPos(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("HorzScrollPos"), DISPID(13));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DImageViewDispT<T>::get_HorzScrollPos()
{
  static _TDispID _dispid(*this, OLETEXT("HorzScrollPos"), DISPID(13));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_VertScrollMin(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("VertScrollMin"), DISPID(14));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DImageViewDispT<T>::get_VertScrollMin()
{
  static _TDispID _dispid(*this, OLETEXT("VertScrollMin"), DISPID(14));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_VertScrollMax(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("VertScrollMax"), DISPID(15));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DImageViewDispT<T>::get_VertScrollMax()
{
  static _TDispID _dispid(*this, OLETEXT("VertScrollMax"), DISPID(15));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_VertScrollPos(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("VertScrollPos"), DISPID(16));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DImageViewDispT<T>::get_VertScrollPos()
{
  static _TDispID _dispid(*this, OLETEXT("VertScrollPos"), DISPID(16));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_ViewportLeft(long /*[VT_I4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("ViewportLeft"), DISPID(17));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> long /*[VT_I4:0]*/ __fastcall
_DImageViewDispT<T>::get_ViewportLeft()
{
  static _TDispID _dispid(*this, OLETEXT("ViewportLeft"), DISPID(17));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_ViewportTop(long /*[VT_I4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("ViewportTop"), DISPID(18));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> long /*[VT_I4:0]*/ __fastcall
_DImageViewDispT<T>::get_ViewportTop()
{
  static _TDispID _dispid(*this, OLETEXT("ViewportTop"), DISPID(18));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_ViewportWidth(long /*[VT_I4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("ViewportWidth"), DISPID(19));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> long /*[VT_I4:0]*/ __fastcall
_DImageViewDispT<T>::get_ViewportWidth()
{
  static _TDispID _dispid(*this, OLETEXT("ViewportWidth"), DISPID(19));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_ViewportHeight(long /*[VT_I4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("ViewportHeight"), DISPID(20));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> long /*[VT_I4:0]*/ __fastcall
_DImageViewDispT<T>::get_ViewportHeight()
{
  static _TDispID _dispid(*this, OLETEXT("ViewportHeight"), DISPID(20));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_HorzPos(Gkmbivwlib_tlb::ViewHorzPlaceConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("HorzPos"), DISPID(21));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbivwlib_tlb::ViewHorzPlaceConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbivwlib_tlb::ViewHorzPlaceConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImageViewDispT<T>::get_HorzPos()
{
  static _TDispID _dispid(*this, OLETEXT("HorzPos"), DISPID(21));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbivwlib_tlb::ViewHorzPlaceConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_VertPos(Gkmbivwlib_tlb::ViewVertPlaceConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("VertPos"), DISPID(22));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbivwlib_tlb::ViewVertPlaceConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbivwlib_tlb::ViewVertPlaceConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImageViewDispT<T>::get_VertPos()
{
  static _TDispID _dispid(*this, OLETEXT("VertPos"), DISPID(22));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbivwlib_tlb::ViewVertPlaceConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_Zoom(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("Zoom"), DISPID(23));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DImageViewDispT<T>::get_Zoom()
{
  static _TDispID _dispid(*this, OLETEXT("Zoom"), DISPID(23));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_Stretch(TOLEBOOL /*[VT_BOOL:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("Stretch"), DISPID(24));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> TOLEBOOL /*[VT_BOOL:0]*/ __fastcall
_DImageViewDispT<T>::get_Stretch()
{
  static _TDispID _dispid(*this, OLETEXT("Stretch"), DISPID(24));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_AspectRatio(TOLEBOOL /*[VT_BOOL:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("AspectRatio"), DISPID(25));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> TOLEBOOL /*[VT_BOOL:0]*/ __fastcall
_DImageViewDispT<T>::get_AspectRatio()
{
  static _TDispID _dispid(*this, OLETEXT("AspectRatio"), DISPID(25));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_ScrollBar(TOLEBOOL /*[VT_BOOL:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("ScrollBar"), DISPID(26));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> TOLEBOOL /*[VT_BOOL:0]*/ __fastcall
_DImageViewDispT<T>::get_ScrollBar()
{
  static _TDispID _dispid(*this, OLETEXT("ScrollBar"), DISPID(26));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_ControlBar(TOLEBOOL /*[VT_BOOL:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("ControlBar"), DISPID(27));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> TOLEBOOL /*[VT_BOOL:0]*/ __fastcall
_DImageViewDispT<T>::get_ControlBar()
{
  static _TDispID _dispid(*this, OLETEXT("ControlBar"), DISPID(27));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_DispDelay(TOLEBOOL /*[VT_BOOL:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("DispDelay"), DISPID(28));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> TOLEBOOL /*[VT_BOOL:0]*/ __fastcall
_DImageViewDispT<T>::get_DispDelay()
{
  static _TDispID _dispid(*this, OLETEXT("DispDelay"), DISPID(28));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_AutoColorDecrease(TOLEBOOL /*[VT_BOOL:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("AutoColorDecrease"), DISPID(29));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> TOLEBOOL /*[VT_BOOL:0]*/ __fastcall
_DImageViewDispT<T>::get_AutoColorDecrease()
{
  static _TDispID _dispid(*this, OLETEXT("AutoColorDecrease"), DISPID(29));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_Morphology(Gkmbivwlib_tlb::MorphologyConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("Morphology"), DISPID(30));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbivwlib_tlb::MorphologyConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbivwlib_tlb::MorphologyConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImageViewDispT<T>::get_Morphology()
{
  static _TDispID _dispid(*this, OLETEXT("Morphology"), DISPID(30));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbivwlib_tlb::MorphologyConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_Interpolation(Gkmbivwlib_tlb::InterpolationConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("Interpolation"), DISPID(31));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbivwlib_tlb::InterpolationConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbivwlib_tlb::InterpolationConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImageViewDispT<T>::get_Interpolation()
{
  static _TDispID _dispid(*this, OLETEXT("Interpolation"), DISPID(31));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbivwlib_tlb::InterpolationConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_Effect(Gkmbivwlib_tlb::EffectConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("Effect"), DISPID(32));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbivwlib_tlb::EffectConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbivwlib_tlb::EffectConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImageViewDispT<T>::get_Effect()
{
  static _TDispID _dispid(*this, OLETEXT("Effect"), DISPID(32));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbivwlib_tlb::EffectConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_PositionEvent(Gkmbivwlib_tlb::PosEventConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("PositionEvent"), DISPID(33));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbivwlib_tlb::PosEventConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbivwlib_tlb::PosEventConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImageViewDispT<T>::get_PositionEvent()
{
  static _TDispID _dispid(*this, OLETEXT("PositionEvent"), DISPID(33));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbivwlib_tlb::PosEventConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_MediaFormat(Gkmbivwlib_tlb::MediaFormatConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("MediaFormat"), DISPID(34));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbivwlib_tlb::MediaFormatConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbivwlib_tlb::MediaFormatConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DImageViewDispT<T>::get_MediaFormat()
{
  static _TDispID _dispid(*this, OLETEXT("MediaFormat"), DISPID(34));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbivwlib_tlb::MediaFormatConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_ReadyState(long /*[VT_I4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("ReadyState"), DISPID(-525));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> long /*[VT_I4:0]*/ __fastcall
_DImageViewDispT<T>::get_ReadyState()
{
  static _TDispID _dispid(*this, OLETEXT("ReadyState"), DISPID(-525));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_Appearance(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("Appearance"), DISPID(-520));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DImageViewDispT<T>::get_Appearance()
{
  static _TDispID _dispid(*this, OLETEXT("Appearance"), DISPID(-520));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_BackColor(::OLE_COLOR /*[VT_UI4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("BackColor"), DISPID(-501));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> ::OLE_COLOR /*[VT_UI4:0]*/ __fastcall
_DImageViewDispT<T>::get_BackColor()
{
  static _TDispID _dispid(*this, OLETEXT("BackColor"), DISPID(-501));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::set_BorderStyle(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("BorderStyle"), DISPID(-504));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DImageViewDispT<T>::get_BorderStyle()
{
  static _TDispID _dispid(*this, OLETEXT("BorderStyle"), DISPID(-504));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageViewDispT<T>::SetMemHandle(OLE_HANDLE MemHandle, long MemSize)
{
  static _TDispID _dispid(*this, OLETEXT("SetMemHandle"), DISPID(35));
  TAutoArgs<2> _args;
  _args[1] = MemHandle /*[VT_INT:0]*/;
  _args[2] = MemSize /*[VT_I4:0]*/;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> short __fastcall
_DImageViewDispT<T>::GetErrorCode()
{
  static _TDispID _dispid(*this, OLETEXT("GetErrorCode"), DISPID(36));
  TAutoArgs<0> _args;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::Refresh()
{
  static _TDispID _dispid(*this, OLETEXT("Refresh"), DISPID(-550));
  OleProcedure(_dispid);
}

template <class T> TOLEBOOL __fastcall
_DImageViewDispT<T>::SetDIB(OLE_HANDLE hDIB, TOLEBOOL bOwner)
{
  static _TDispID _dispid(*this, OLETEXT("SetDIB"), DISPID(37));
  TAutoArgs<2> _args;
  _args[1] = hDIB /*[VT_INT:0]*/;
  _args[2] = bOwner /*[VT_BOOL:0]*/;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageViewDispT<T>::CopyToClipboard()
{
  static _TDispID _dispid(*this, OLETEXT("CopyToClipboard"), DISPID(38));
  TAutoArgs<0> _args;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DImageViewDispT<T>::PasteFromClipboard()
{
  static _TDispID _dispid(*this, OLETEXT("PasteFromClipboard"), DISPID(39));
  TAutoArgs<0> _args;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DImageViewDispT<T>::AboutBox()
{
  static _TDispID _dispid(*this, OLETEXT("AboutBox"), DISPID(-552));
  OleProcedure(_dispid);
}

// *********************************************************************//
// DispIntf:  _DImageViewEvents
// Flags:     (4096) Dispatchable
// GUID:      {48523B86-B76E-11D2-BF10-00A0C92400D1}
// *********************************************************************//
template <class T> void __fastcall
_DImageViewEventsDispT<T>::NotifyPos(long x, long y)
{
  static _TDispID _dispid(/* NotifyPos */ DISPID(1));
  TAutoArgs<2> _args;
  _args[1] = x /*[VT_I4:0]*/;
  _args[2] = y /*[VT_I4:0]*/;
  OleProcedure(_dispid, _args);
}

template <class T> void __fastcall
_DImageViewEventsDispT<T>::ReadyStateChange()
{
  static _TDispID _dispid(/* ReadyStateChange */ DISPID(-609));
  OleProcedure(_dispid);
}

template <class T> void __fastcall
_DImageViewEventsDispT<T>::Click()
{
  static _TDispID _dispid(/* Click */ DISPID(-600));
  OleProcedure(_dispid);
}

template <class T> void __fastcall
_DImageViewEventsDispT<T>::DblClick()
{
  static _TDispID _dispid(/* DblClick */ DISPID(-601));
  OleProcedure(_dispid);
}

template <class T> void __fastcall
_DImageViewEventsDispT<T>::Error(short Number, BSTR* Description, SCODE Scode, BSTR Source, 
                                 BSTR HelpFile, long HelpContext, TOLEBOOL* CancelDisplay)
{
  static _TDispID _dispid(/* Error */ DISPID(-608));
  TAutoArgs<7> _args;
  _args[1] = Number /*[VT_I2:0]*/;
  _args[2] = Description /*[VT_BSTR:1]*/;
  _args[3] = Scode /*[VT_ERROR:0]*/;
  _args[4] = Source /*[VT_BSTR:0]*/;
  _args[5] = HelpFile /*[VT_BSTR:0]*/;
  _args[6] = HelpContext /*[VT_I4:0]*/;
  _args[7] = CancelDisplay /*[VT_BOOL:1]*/;
  OleProcedure(_dispid, _args);
}

template <class T> void __fastcall
_DImageViewEventsDispT<T>::MouseDown(short Button, short Shift, OLE_XPOS_PIXELS x, OLE_YPOS_PIXELS y)
{
  static _TDispID _dispid(/* MouseDown */ DISPID(-605));
  TAutoArgs<4> _args;
  _args[1] = Button /*[VT_I2:0]*/;
  _args[2] = Shift /*[VT_I2:0]*/;
  _args[3] = x /*[VT_I4:0]*/;
  _args[4] = y /*[VT_I4:0]*/;
  OleProcedure(_dispid, _args);
}

template <class T> void __fastcall
_DImageViewEventsDispT<T>::MouseUp(short Button, short Shift, OLE_XPOS_PIXELS x, OLE_YPOS_PIXELS y)
{
  static _TDispID _dispid(/* MouseUp */ DISPID(-607));
  TAutoArgs<4> _args;
  _args[1] = Button /*[VT_I2:0]*/;
  _args[2] = Shift /*[VT_I2:0]*/;
  _args[3] = x /*[VT_I4:0]*/;
  _args[4] = y /*[VT_I4:0]*/;
  OleProcedure(_dispid, _args);
}

template <class T> void __fastcall
_DImageViewEventsDispT<T>::MouseMove(short Button, short Shift, OLE_XPOS_PIXELS x, OLE_YPOS_PIXELS y)
{
  static _TDispID _dispid(/* MouseMove */ DISPID(-606));
  TAutoArgs<4> _args;
  _args[1] = Button /*[VT_I2:0]*/;
  _args[2] = Shift /*[VT_I2:0]*/;
  _args[3] = x /*[VT_I4:0]*/;
  _args[4] = y /*[VT_I4:0]*/;
  OleProcedure(_dispid, _args);
}

template <class T> void __fastcall
_DImageViewEventsDispT<T>::KeyDown(short* KeyCode, short Shift)
{
  static _TDispID _dispid(/* KeyDown */ DISPID(-602));
  TAutoArgs<2> _args;
  _args[1] = KeyCode /*[VT_I2:1]*/;
  _args[2] = Shift /*[VT_I2:0]*/;
  OleProcedure(_dispid, _args);
}

template <class T> void __fastcall
_DImageViewEventsDispT<T>::KeyUp(short* KeyCode, short Shift)
{
  static _TDispID _dispid(/* KeyUp */ DISPID(-604));
  TAutoArgs<2> _args;
  _args[1] = KeyCode /*[VT_I2:1]*/;
  _args[2] = Shift /*[VT_I2:0]*/;
  OleProcedure(_dispid, _args);
}

#endif  //   __TLB_NO_INTERFACE_WRAPPERS


#if !defined(__TLB_NO_EVENT_WRAPPERS) && defined(USING_ATLVCL)
// *********************************************************************//
// CONNECTIONPOINT/EVENT PROXY
// CoClass         : ImageView
// Event Interface : _DImageViewEvents
// *********************************************************************//
template <class T>
class TEvents_ImageView : public IConnectionPointImpl<T,
                                                 &DIID__DImageViewEvents,
                                                 CComUnkArray<CONNECTIONPOINT_ARRAY_SIZE> >
{
public:
  void            Fire_NotifyPos(long x, long y);
  void            Fire_ReadyStateChange(void);
  void            Fire_Click(void);
  void            Fire_DblClick(void);
  void            Fire_Error(short Number, BSTR* Description, SCODE Scode, BSTR Source, 
                             BSTR HelpFile, long HelpContext, TOLEBOOL* CancelDisplay);
  void            Fire_MouseDown(short Button, short Shift, OLE_XPOS_PIXELS x, OLE_YPOS_PIXELS y);
  void            Fire_MouseUp(short Button, short Shift, OLE_XPOS_PIXELS x, OLE_YPOS_PIXELS y);
  void            Fire_MouseMove(short Button, short Shift, OLE_XPOS_PIXELS x, OLE_YPOS_PIXELS y);
  void            Fire_KeyDown(short* KeyCode, short Shift);
  void            Fire_KeyUp(short* KeyCode, short Shift);
protected:
  _DImageViewEventsDisp m_EventIntfObj;
};

template <class T> void
TEvents_ImageView<T>::Fire_NotifyPos(long x, long y)
{
  T * pT = (T*)this;
  pT->Lock();
  IUnknown ** pp = m_vec.begin();
  while (pp < m_vec.end())
  {
    if (*pp != NULL)
    {
      m_EventIntfObj.Attach(*pp);
      m_EventIntfObj.NotifyPos(x, y);
      m_EventIntfObj.Attach(0);
    }
    pp++;
  }
  pT->Unlock();
}

template <class T> void
TEvents_ImageView<T>::Fire_ReadyStateChange(void)
{
  T * pT = (T*)this;
  pT->Lock();
  IUnknown ** pp = m_vec.begin();
  while (pp < m_vec.end())
  {
    if (*pp != NULL)
    {
      m_EventIntfObj.Attach(*pp);
      m_EventIntfObj.ReadyStateChange();
      m_EventIntfObj.Attach(0);
    }
    pp++;
  }
  pT->Unlock();
}

template <class T> void
TEvents_ImageView<T>::Fire_Click(void)
{
  T * pT = (T*)this;
  pT->Lock();
  IUnknown ** pp = m_vec.begin();
  while (pp < m_vec.end())
  {
    if (*pp != NULL)
    {
      m_EventIntfObj.Attach(*pp);
      m_EventIntfObj.Click();
      m_EventIntfObj.Attach(0);
    }
    pp++;
  }
  pT->Unlock();
}

template <class T> void
TEvents_ImageView<T>::Fire_DblClick(void)
{
  T * pT = (T*)this;
  pT->Lock();
  IUnknown ** pp = m_vec.begin();
  while (pp < m_vec.end())
  {
    if (*pp != NULL)
    {
      m_EventIntfObj.Attach(*pp);
      m_EventIntfObj.DblClick();
      m_EventIntfObj.Attach(0);
    }
    pp++;
  }
  pT->Unlock();
}

template <class T> void
TEvents_ImageView<T>::Fire_Error(short Number, BSTR* Description, SCODE Scode, BSTR Source, 
                                 BSTR HelpFile, long HelpContext, TOLEBOOL* CancelDisplay)
{
  T * pT = (T*)this;
  pT->Lock();
  IUnknown ** pp = m_vec.begin();
  while (pp < m_vec.end())
  {
    if (*pp != NULL)
    {
      m_EventIntfObj.Attach(*pp);
      m_EventIntfObj.Error(Number, Description, Scode, Source, HelpFile, HelpContext, CancelDisplay);
      m_EventIntfObj.Attach(0);
    }
    pp++;
  }
  pT->Unlock();
}

template <class T> void
TEvents_ImageView<T>::Fire_MouseDown(short Button, short Shift, OLE_XPOS_PIXELS x, OLE_YPOS_PIXELS y)
{
  T * pT = (T*)this;
  pT->Lock();
  IUnknown ** pp = m_vec.begin();
  while (pp < m_vec.end())
  {
    if (*pp != NULL)
    {
      m_EventIntfObj.Attach(*pp);
      m_EventIntfObj.MouseDown(Button, Shift, x, y);
      m_EventIntfObj.Attach(0);
    }
    pp++;
  }
  pT->Unlock();
}

template <class T> void
TEvents_ImageView<T>::Fire_MouseUp(short Button, short Shift, OLE_XPOS_PIXELS x, OLE_YPOS_PIXELS y)
{
  T * pT = (T*)this;
  pT->Lock();
  IUnknown ** pp = m_vec.begin();
  while (pp < m_vec.end())
  {
    if (*pp != NULL)
    {
      m_EventIntfObj.Attach(*pp);
      m_EventIntfObj.MouseUp(Button, Shift, x, y);
      m_EventIntfObj.Attach(0);
    }
    pp++;
  }
  pT->Unlock();
}

template <class T> void
TEvents_ImageView<T>::Fire_MouseMove(short Button, short Shift, OLE_XPOS_PIXELS x, OLE_YPOS_PIXELS y)
{
  T * pT = (T*)this;
  pT->Lock();
  IUnknown ** pp = m_vec.begin();
  while (pp < m_vec.end())
  {
    if (*pp != NULL)
    {
      m_EventIntfObj.Attach(*pp);
      m_EventIntfObj.MouseMove(Button, Shift, x, y);
      m_EventIntfObj.Attach(0);
    }
    pp++;
  }
  pT->Unlock();
}

template <class T> void
TEvents_ImageView<T>::Fire_KeyDown(short* KeyCode, short Shift)
{
  T * pT = (T*)this;
  pT->Lock();
  IUnknown ** pp = m_vec.begin();
  while (pp < m_vec.end())
  {
    if (*pp != NULL)
    {
      m_EventIntfObj.Attach(*pp);
      m_EventIntfObj.KeyDown(KeyCode, Shift);
      m_EventIntfObj.Attach(0);
    }
    pp++;
  }
  pT->Unlock();
}

template <class T> void
TEvents_ImageView<T>::Fire_KeyUp(short* KeyCode, short Shift)
{
  T * pT = (T*)this;
  pT->Lock();
  IUnknown ** pp = m_vec.begin();
  while (pp < m_vec.end())
  {
    if (*pp != NULL)
    {
      m_EventIntfObj.Attach(*pp);
      m_EventIntfObj.KeyUp(KeyCode, Shift);
      m_EventIntfObj.Attach(0);
    }
    pp++;
  }
  pT->Unlock();
}

#endif  //   __TLB_NO_EVENT_WRAPPERS

};     // namespace Gkmbivwlib_tlb

#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using  namespace Gkmbivwlib_tlb;
#endif

#pragma option pop

//#endif // __GKMBIVWLib_TLB_h__

namespace Gkmbivwlib_tlb
{

// *********************************************************************//
// HelpString: GKit Image View Control Borland Edition
// Version:    2.0
// *********************************************************************//


// *********************************************************************//
// OCX PROXY CLASS DECLARATION
// Control Name     : TGKitImageView
// Help String      : GKit Image View Control Borland Edition
// Default Interface: _DImageView
// Def. Intf. Object: _DImageViewDisp
// Def. Intf. DISP? : Yes
// Event   Interface: _DImageViewEvents
// TypeFlags        : (38) CanCreate Licensed Control
// *********************************************************************//

// *********************************************************************//
// Definition of closures to allow VCL handlers to catch OCX events.    //
// *********************************************************************//
typedef void __fastcall (__closure * TGKitImageViewNotifyPos)(System::TObject * Sender, 
                                                              long x, long y);
typedef void __fastcall (__closure * TGKitImageViewError)(System::TObject * Sender, 
                                                          short Number, 
                                                          void* Description_which_is_really_a_Ptr_to_BSTR, 
                                                          SCODE Scode, BSTR Source, BSTR HelpFile, 
                                                          long HelpContext, 
                                                          void* CancelDisplay_which_is_really_a_Ptr_to_TOLEBOOL);
//+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
// Proxy class to host GKit Image View Control Borland Edition in CBuilder IDE/Applications.
//-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
class PACKAGE TGKitImageView : public TOleControl
{
  OVERLOADED_PROP_METHODS;
  static TNoParam  OptParam;
  static GUID      DEF_CTL_INTF;

  // Instance of Closures to expose OCX Events as VCL ones
  //
  TGKitImageViewNotifyPos        FOnNotifyPos;
  TNotifyEvent                   FOnReadyStateChange;
  TGKitImageViewError            FOnError;

  // Default Interace of OCX
  //
  _DImageViewDisp m_OCXIntf;

  // VCL Property Getters/Setters which delegate to OCX
  //

  // Static variables used by all instances of OCX proxy
  //
  static int          EventDispIDs[3];
  static WCHAR        wLicenseKey[96];
  static TControlData CControlData;
  static GUID         CTL_DEF_INTF;

  // Method providing access to interface as __property 
  //
  _DImageViewDisp __fastcall GetControlInterface(void);

protected:
  void     __fastcall CreateControl  (void);
  void     __fastcall InitControlData(void);

public:
  virtual  __fastcall TGKitImageView(TComponent* AOwner) : TOleControl(AOwner)
  {};
  virtual  __fastcall TGKitImageView(HWND        Parent) : TOleControl(Parent)
  {};

  // OCX methods
  //
  TOLEBOOL        __fastcall SetMemHandle(OLE_HANDLE MemHandle, long MemSize);
  short           __fastcall GetErrorCode(void);
  void            __fastcall Refresh(void);
  TOLEBOOL        __fastcall SetDIB(OLE_HANDLE hDIB, TOLEBOOL bOwner);
  TOLEBOOL        __fastcall CopyToClipboard(void);
  TOLEBOOL        __fastcall PasteFromClipboard(void);
  void            __fastcall AboutBox(void);

  // OCX properties
  //
  __property int ReadyState={ read=GetIntegerProp, index=-525 };
  __property _DImageViewDisp ControlInterface={ read=GetControlInterface };

  // Published properties
  //
__published:

  // Standard/Extended properties
  //
  __property ParentColor;
  __property TabStop;
  __property Align;
  __property DragCursor;
  __property DragMode;
  __property ParentShowHint;
  __property PopupMenu;
  __property ShowHint;
  __property TabOrder;
  __property Visible;
  __property OnDragDrop;
  __property OnDragOver;
  __property OnEndDrag;
  __property OnEnter;
  __property OnExit;
  __property OnStartDrag;
  __property OnMouseUp;
  __property OnMouseMove;
  __property OnMouseDown;
  __property OnKeyUp;
  __property OnKeyDown;
  __property OnDblClick;
  __property OnClick;

  // OCX properties
  //
  __property System::WideString FileName={ read=GetWideStringProp, write=SetWideStringProp, stored=false, index=1 };
  __property int ImageWidth={ read=GetIntegerProp, write=SetIntegerProp, stored=false, index=2 };
  __property int ImageHeight={ read=GetIntegerProp, write=SetIntegerProp, stored=false, index=3 };
  __property TOleEnum ColorDepth={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=4 };
  __property short TotalPage={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=5 };
  __property short Page={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=6 };
  __property int SourceLeft={ read=GetIntegerProp, write=SetIntegerProp, stored=false, index=7 };
  __property int SourceTop={ read=GetIntegerProp, write=SetIntegerProp, stored=false, index=8 };
  __property int SourceWidth={ read=GetIntegerProp, write=SetIntegerProp, stored=false, index=9 };
  __property int SourceHeight={ read=GetIntegerProp, write=SetIntegerProp, stored=false, index=10 };
  __property short HorzScrollMin={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=11 };
  __property short HorzScrollMax={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=12 };
  __property short HorzScrollPos={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=13 };
  __property short VertScrollMin={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=14 };
  __property short VertScrollMax={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=15 };
  __property short VertScrollPos={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=16 };
  __property int ViewportLeft={ read=GetIntegerProp, write=SetIntegerProp, stored=false, index=17 };
  __property int ViewportTop={ read=GetIntegerProp, write=SetIntegerProp, stored=false, index=18 };
  __property int ViewportWidth={ read=GetIntegerProp, write=SetIntegerProp, stored=false, index=19 };
  __property int ViewportHeight={ read=GetIntegerProp, write=SetIntegerProp, stored=false, index=20 };
  __property TOleEnum HorzPos={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=21 };
  __property TOleEnum VertPos={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=22 };
  __property short Zoom={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=23 };
  __property bool Stretch={ read=GetWordBoolProp, write=SetWordBoolProp, stored=false, index=24 };
  __property bool AspectRatio={ read=GetWordBoolProp, write=SetWordBoolProp, stored=false, index=25 };
  __property bool ScrollBar={ read=GetWordBoolProp, write=SetWordBoolProp, stored=false, index=26 };
  __property bool ControlBar={ read=GetWordBoolProp, write=SetWordBoolProp, stored=false, index=27 };
  __property bool DispDelay={ read=GetWordBoolProp, write=SetWordBoolProp, stored=false, index=28 };
  __property bool AutoColorDecrease={ read=GetWordBoolProp, write=SetWordBoolProp, stored=false, index=29 };
  __property TOleEnum Morphology={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=30 };
  __property TOleEnum Interpolation={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=31 };
  __property TOleEnum Effect={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=32 };
  __property TOleEnum PositionEvent={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=33 };
  __property TOleEnum MediaFormat={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=34 };
  __property short Appearance={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=-520 };
  __property Graphics::TColor BackColor={ read=GetTColorProp, write=SetTColorProp, stored=false, index=-501 };
  __property short BorderStyle={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=-504 };

  // OCX Events
  //
  __property TGKitImageViewNotifyPos OnNotifyPos={ read=FOnNotifyPos, write=FOnNotifyPos };
  __property TNotifyEvent OnReadyStateChange={ read=FOnReadyStateChange, write=FOnReadyStateChange };
  __property TGKitImageViewError OnError={ read=FOnError, write=FOnError };
};
typedef TGKitImageView  TGKitImageViewProxy;

};     // namespace Gkmbivwlib_tlb

#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using  namespace Gkmbivwlib_tlb;
#endif

#pragma option pop

#endif // __GKMBIVWLib_OCX_h__
