// ************************************************************************ //
//                                                                          //
// GKit Multimedia Play Control Borland Edition                             //
//                                                                          //
// GKitMultimediaPlay.h                                                     //
//                                                                          //
// Copyright (c) FUJITSU SHIZUOKA ENGINEERING LIMITED 1999                  //
//                                                                          //
// ************************************************************************ //

// C++ TLBWRTR : $Revision:   1.96.1.27  $
// File generated on 99/03/04 15:05:53 from Type Library described below.

// ************************************************************************ //
// Type Lib: C:\FFC\GKITOCX.BE\MEDIATOOLS\GKMBBPLY.OCX
// IID\LCID: {6FF40883-BC82-11D2-A590-00A0C92509F5}\0
// Helpfile: C:\FFC\GKITOCX.BE\MEDIATOOLS\GKMBBPLY.hlp
// DepndLst: 
//   (1) v2.0 stdole, (C:\WINDOWS\SYSTEM\STDOLE2.TLB)
//   (2) v4.0 StdVCL, (C:\WINDOWS\SYSTEM\STDVCL40.DLL)
//   (3) v2.0 StdType, (C:\WINDOWS\SYSTEM\OLEPRO32.DLL)
// ************************************************************************ //
#ifndef   __GKMBBPLYLib_OCX_h__
#define   __GKMBBPLYLib_OCX_h__

#pragma option push -b -w-inl

#include <vcl/utilcls.h>
#if !defined(__UTILCLS_H_VERSION) || (__UTILCLS_H_VERSION < 0x0101)
#error "This file requires an newer version of the header file UTILCLS.H"
#endif

#include <olectl.h>
#include <ocidl.h>
#if !defined(_NO_VCL)   // For Console applications that don't use VCL
#include <vcl/stdvcl.hpp>
#endif  //   _NO_VCL
#include <vcl/ocxproxy.h>

//#include "GKMBBPLYLib_TLB.h"

// C++ TLBWRTR : $Revision:   1.96.1.27  $
// File generated on 99/03/04 15:05:53 from Type Library described below.

// ************************************************************************ //
// Type Lib: C:\FFC\GKITOCX.BE\MEDIATOOLS\GKMBBPLY.OCX
// IID\LCID: {6FF40883-BC82-11D2-A590-00A0C92509F5}\0
// Helpfile: C:\FFC\GKITOCX.BE\MEDIATOOLS\GKMBBPLY.hlp
// DepndLst: 
//   (1) v2.0 stdole, (C:\WINDOWS\SYSTEM\STDOLE2.TLB)
//   (2) v4.0 StdVCL, (C:\WINDOWS\SYSTEM\STDVCL40.DLL)
//   (3) v2.0 StdType, (C:\WINDOWS\SYSTEM\OLEPRO32.DLL)
// ************************************************************************ //
//#ifndef   __GKMBBPLYLib_TLB_h__
//#define   __GKMBBPLYLib_TLB_h__

#pragma option push -b -w-inl

#include <vcl/utilcls.h>
#if !defined(__UTILCLS_H_VERSION) || (__UTILCLS_H_VERSION < 0x0101)
#error "This file requires an newer version of the header file UTILCLS.H"
#endif

#include <olectl.h>
#include <ocidl.h>
#if defined(USING_ATLVCL) || defined(USING_ATL)
#if !defined(__TLB_NO_EVENT_WRAPPERS)
#include <atl/atlmod.h>
#endif
#endif


// *********************************************************************//
// Forward reference of some VCL types (to avoid including STDVCL.HPP)  //
// *********************************************************************//
namespace Stdvcl {class IStrings; class IStringsDisp;}
using namespace Stdvcl;

namespace Gkmbbplylib_tlb
{

// *********************************************************************//
// HelpString: GKit Multimedia Play Control Borland Edition
// Version:    2.0
// *********************************************************************//


// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:      //
//   Type Libraries     : LIBID_xxxx                                    //
//   CoClasses          : CLSID_xxxx                                    //
//   DISPInterfaces     : DIID_xxxx                                     //
//   Non-DISP interfaces: IID_xxxx                                      //
// *********************************************************************//
DEFINE_GUID(LIBID_GKMBBPLYLib, 0x6FF40883, 0xBC82, 0x11D2, 0xA5, 0x90, 0x00, 0xA0, 0xC9, 0x25, 0x09, 0xF5);
DEFINE_GUID(DIID__DMultimediaPlay, 0x6FF40884, 0xBC82, 0x11D2, 0xA5, 0x90, 0x00, 0xA0, 0xC9, 0x25, 0x09, 0xF5);
DEFINE_GUID(DIID__DMultimediaPlayEvents, 0x6FF40885, 0xBC82, 0x11D2, 0xA5, 0x90, 0x00, 0xA0, 0xC9, 0x25, 0x09, 0xF5);
DEFINE_GUID(CLSID_MultimediaPlay, 0x6FF40886, 0xBC82, 0x11D2, 0xA5, 0x90, 0x00, 0xA0, 0xC9, 0x25, 0x09, 0xF5);

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                  //
// *********************************************************************//
enum      CommonConstants;
enum      MediaTypeConstants;
enum      MediaFormatConstants;
enum      ErrorConstants;
enum      ViewStyleConstants;
enum      EffectConstants;
enum      NotifyPlayConstants;
interface DECLSPEC_UUID("{6FF40884-BC82-11D2-A590-00A0C92509F5}") _DMultimediaPlay;
interface DECLSPEC_UUID("{6FF40885-BC82-11D2-A590-00A0C92509F5}") _DMultimediaPlayEvents;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                     //
// (NOTE: Here we map each CoClass to its Default Interface)            //
//                                                                      //
// The LIBID_OF_ macro(s) map a LIBID_OF_CoClassName to the GUID of this//
// TypeLibrary. It simplifies the updating of macros when CoClass name  //
// change.                                                              //
// *********************************************************************//
typedef _DMultimediaPlay MultimediaPlay;

#define LIBID_OF_MultimediaPlay (&LIBID_GKMBBPLYLib)

// *********************************************************************//
// Declaration of Enumerations defined in Type Library                  //
// *********************************************************************//
typedef enum CommonConstants
{
  cwmUnknown = 0xFFFFFFFF
} CommonConstants;

typedef enum MediaTypeConstants
{
  cwmMediaImage = 1, 
  cwmMediaSound = 2, 
  cwmMediaMovie = 3
} MediaTypeConstants;

typedef enum MediaFormatConstants
{
  cwmFileBMP = 101, 
  cwmFileTIFF = 102, 
  cwmFileJPEG = 103, 
  cwmFilePCX = 104, 
  cwmFilePNG = 106, 
  cwmFileSIA = 107, 
  cwmFileWAVE = 201, 
  cwmFileMIDI = 202, 
  cwmFileAVI = 301, 
  cwmFileMPEG = 302, 
  cwmFileQTMov = 303
} MediaFormatConstants;

typedef enum ErrorConstants
{
  cwmSuccess = 0, 
  cwmErrInvalidParam = 1001, 
  cwmErrInvalidRectValue = 1002, 
  cwmErrInvalidIndex = 1003, 
  cwmErrInvalidCompression = 1010, 
  cwmErrInvalidColorDepth = 1011, 
  cwmErrInvalidSaveFormat = 1012, 
  cwmErrSequenceError = 1100, 
  cwmErrUnsetMediaData = 1101, 
  cwmErrUserAbort = 1110, 
  cwmErrAcquireNotComplete = 1111, 
  cwmErrNotSupportFileFormat = 2000, 
  cwmErrInvalidFileFormat = 2001, 
  cwmErrFileNotFound = 2110, 
  cwmErrFileAlreadyExists = 2111, 
  cwmErrPathNotFound = 2112, 
  cwmErrFileLoadIncomplete = 2113, 
  cwmErrFileIOError = 2120, 
  cwmErrDiskFull = 2130, 
  cwmErrClipboardError = 2200, 
  cwmErrClipboardInvalidFormat = 2201, 
  cwmErrPrtError = 7000, 
  cwmErrPrtAppAbort = 7001, 
  cwmErrPrtUserAbort = 7002, 
  cwmErrDeviceError = 8000, 
  cwmErrDeviceNotFound = 8001, 
  cwmErrDeviceNotInstall = 8002, 
  cwmErrCDDriveNotFound = 8003, 
  cwmErrDeviceBusy = 8010, 
  cwmErrOutofMemory = 9000, 
  cwmErrSystemError = 9900, 
  cwmErrSystemNotFound = 9910, 
  cwmErrTwainDllNotFound = 9911, 
  cwmErrPcdLibNotFound = 9912
} ErrorConstants;

typedef enum ViewStyleConstants
{
  cwmViewNormal = 0, 
  cwmViewAdjust = 1, 
  cwmViewStretch = 2, 
  cwmViewAutoSize = 3
} ViewStyleConstants;

typedef enum EffectConstants
{
  cwmEffectNone = 0, 
  cwmEffectFadeIn = 1, 
  cwmEffectFadeOut = 2, 
  cwmEffectFadeInOut = 3, 
  cwmEffectFadeChange = 4, 
  cwmEffectClearWipe1 = 11, 
  cwmEffectClearWipe2 = 12, 
  cwmEffectClearWipe3 = 13, 
  cwmEffectClearWipe4 = 14, 
  cwmEffectWipe1 = 21, 
  cwmEffectWipe2 = 22, 
  cwmEffectWipe3 = 23, 
  cwmEffectWipe4 = 24, 
  cwmEffectClearScrollIn1 = 31, 
  cwmEffectClearScrollIn2 = 32, 
  cwmEffectClearScrollIn3 = 33, 
  cwmEffectClearScrollIn4 = 34, 
  cwmEffectScrollIn1 = 41, 
  cwmEffectScrollIn2 = 42, 
  cwmEffectScrollIn3 = 43, 
  cwmEffectScrollIn4 = 44, 
  cwmEffectScrollOut1 = 51, 
  cwmEffectScrollOut2 = 52, 
  cwmEffectScrollOut3 = 53, 
  cwmEffectScrollOut4 = 54, 
  cwmEffectSlide1 = 61, 
  cwmEffectSlide2 = 62, 
  cwmEffectSlide3 = 63, 
  cwmEffectSlide4 = 64, 
  cwmEffectRandomWipe1 = 71, 
  cwmEffectRandomWipe2 = 72
} EffectConstants;

typedef enum NotifyPlayConstants
{
  cwmNotifyPlayStart = 1, 
  cwmNotifyPlayStop = 2, 
  cwmNotifyPlayPause = 3, 
  cwmNotifyPlayEnd = 4, 
  cwmNotifyPlayAbort = 5
} NotifyPlayConstants;

// *********************************************************************//
// Interface: _DMultimediaPlay
// Flags:     (4112) Hidden Dispatchable
// GUID:      {6FF40884-BC82-11D2-A590-00A0C92509F5}
// *********************************************************************//
interface _DMultimediaPlay : public IDispatch
{
// DispInterfaces have no methods. Their methods and properties are
// accessed via IDispatch::Invoke. See the class _DMultimediaPlayDisp provided
// below for an easy way to access the methods/properties of this
// interface.
};

// *********************************************************************//
// Interface: _DMultimediaPlayEvents
// Flags:     (4096) Dispatchable
// GUID:      {6FF40885-BC82-11D2-A590-00A0C92509F5}
// *********************************************************************//
interface _DMultimediaPlayEvents : public IDispatch
{
// DispInterfaces have no methods. Their methods and properties are
// accessed via IDispatch::Invoke. See the class _DMultimediaPlayEventsDisp provided
// below for an easy way to access the methods/properties of this
// interface.
};

#if !defined(__TLB_NO_INTERFACE_WRAPPERS)
// *********************************************************************//
// DispIntf:  _DMultimediaPlay
// Flags:     (4112) Hidden Dispatchable
// GUID:      {6FF40884-BC82-11D2-A590-00A0C92509F5}
// *********************************************************************//
template<class T>
class _DMultimediaPlayDispT : public TAutoDriver<_DMultimediaPlay>
{
public:
  _DMultimediaPlayDispT(){}

  _DMultimediaPlayDispT(_DMultimediaPlay *pintf)
  {
    TAutoDriver<_DMultimediaPlay>::Bind(pintf);
  }

  _DMultimediaPlayDispT& operator=(_DMultimediaPlay *pintf)
  {
    TAutoDriver<_DMultimediaPlay>::Bind(pintf);
    return *this;
  }

  HRESULT BindDefault(/*Binds to new instance of CoClass MultimediaPlay*/)
  {
    return OLECHECK(Bind(CLSID_MultimediaPlay));
  }

  HRESULT BindRunning(/*Binds to a running instance of CoClass MultimediaPlay*/)
  {
    return BindToActive(CLSID_MultimediaPlay);
  }

  void            __fastcall set_Appearance(short Value);
  short           __fastcall get_Appearance();
  void            __fastcall set_BackColor(::OLE_COLOR Value);
  ::OLE_COLOR     __fastcall get_BackColor();
  void            __fastcall set_BorderStyle(short Value);
  short           __fastcall get_BorderStyle();
  void            __fastcall set_AutoPlay(TOLEBOOL Value);
  TOLEBOOL        __fastcall get_AutoPlay();
  void            __fastcall set_ControlBar(TOLEBOOL Value);
  TOLEBOOL        __fastcall get_ControlBar();
  void            __fastcall set_StatusBar(TOLEBOOL Value);
  TOLEBOOL        __fastcall get_StatusBar();
  void            __fastcall set_Effect(Gkmbbplylib_tlb::EffectConstants Value);
  Gkmbbplylib_tlb::EffectConstants __fastcall get_Effect();
  void            __fastcall set_PlayCount(long Value);
  long            __fastcall get_PlayCount();
  void            __fastcall set_ScrollBar(TOLEBOOL Value);
  TOLEBOOL        __fastcall get_ScrollBar();
  void            __fastcall set_TrackBar(TOLEBOOL Value);
  TOLEBOOL        __fastcall get_TrackBar();
  void            __fastcall set_ViewStyle(Gkmbbplylib_tlb::ViewStyleConstants Value);
  Gkmbbplylib_tlb::ViewStyleConstants __fastcall get_ViewStyle();
  void            __fastcall set_MediaType(Gkmbbplylib_tlb::MediaTypeConstants Value);
  Gkmbbplylib_tlb::MediaTypeConstants __fastcall get_MediaType();
  void            __fastcall set_FileName(BSTR Value);
  BSTR            __fastcall get_FileName();
  void            __fastcall set_MediaFormat(Gkmbbplylib_tlb::MediaFormatConstants Value);
  Gkmbbplylib_tlb::MediaFormatConstants __fastcall get_MediaFormat();
  void            __fastcall set_ReadyState(long Value);
  long            __fastcall get_ReadyState();
  TOLEBOOL        __fastcall Pause();
  TOLEBOOL        __fastcall Play();
  TOLEBOOL        __fastcall Stop();
  short           __fastcall GetErrorCode();
  TOLEBOOL        __fastcall SetMemHandle(OLE_HANDLE MemHandle, long MemSize);
  void            __fastcall Refresh();
  void            __fastcall AboutBox();

  __property   short           Appearance = {read = get_Appearance, write = set_Appearance};
  __property   ::OLE_COLOR     BackColor = {read = get_BackColor, write = set_BackColor};
  __property   short           BorderStyle = {read = get_BorderStyle, write = set_BorderStyle};
  __property   TOLEBOOL        AutoPlay = {read = get_AutoPlay, write = set_AutoPlay};
  __property   TOLEBOOL        ControlBar = {read = get_ControlBar, write = set_ControlBar};
  __property   TOLEBOOL        StatusBar = {read = get_StatusBar, write = set_StatusBar};
  __property   Gkmbbplylib_tlb::EffectConstants Effect = {read = get_Effect, write = set_Effect};
  __property   long            PlayCount = {read = get_PlayCount, write = set_PlayCount};
  __property   TOLEBOOL        ScrollBar = {read = get_ScrollBar, write = set_ScrollBar};
  __property   TOLEBOOL        TrackBar = {read = get_TrackBar, write = set_TrackBar};
  __property   Gkmbbplylib_tlb::ViewStyleConstants ViewStyle = {read = get_ViewStyle, write = set_ViewStyle};
  __property   Gkmbbplylib_tlb::MediaTypeConstants MediaType = {read = get_MediaType, write = set_MediaType};
  __property   BSTR            FileName = {read = get_FileName, write = set_FileName};
  __property   Gkmbbplylib_tlb::MediaFormatConstants MediaFormat = {read = get_MediaFormat, write = set_MediaFormat};
  __property   long            ReadyState = {read = get_ReadyState, write = set_ReadyState};
};
typedef _DMultimediaPlayDispT<_DMultimediaPlay> _DMultimediaPlayDisp;

// *********************************************************************//
// DispIntf:  _DMultimediaPlayEvents
// Flags:     (4096) Dispatchable
// GUID:      {6FF40885-BC82-11D2-A590-00A0C92509F5}
// *********************************************************************//
template <class T>
class _DMultimediaPlayEventsDispT : public TAutoDriver<_DMultimediaPlayEvents>
{
public:
  _DMultimediaPlayEventsDispT(){}

  void Attach(LPUNKNOWN punk)
  { m_Dispatch = static_cast<T*>(punk); }

  void            __fastcall ReadyStateChange();
  void            __fastcall Click();
  void            __fastcall DblClick();
  void            __fastcall Error(short Number, BSTR* Description, long Scode, BSTR Source, 
                                   BSTR HelpFile, long HelpContext, TOLEBOOL* CancelDisplay);
  void            __fastcall KeyDown(short* KeyCode, short Shift);
  void            __fastcall KeyUp(short* KeyCode, short Shift);
  void            __fastcall MouseDown(short Button, short Shift, OLE_XPOS_PIXELS x, 
                                       OLE_YPOS_PIXELS y);
  void            __fastcall MouseMove(short Button, short Shift, OLE_XPOS_PIXELS x, 
                                       OLE_YPOS_PIXELS y);
  void            __fastcall MouseUp(short Button, short Shift, OLE_XPOS_PIXELS x, OLE_YPOS_PIXELS y);
  void            __fastcall Notify(short NotifyCode);

};
typedef _DMultimediaPlayEventsDispT<_DMultimediaPlayEvents> _DMultimediaPlayEventsDisp;

// *********************************************************************//
// DispIntf:  _DMultimediaPlay
// Flags:     (4112) Hidden Dispatchable
// GUID:      {6FF40884-BC82-11D2-A590-00A0C92509F5}
// *********************************************************************//
template <class T> void __fastcall
_DMultimediaPlayDispT<T>::set_Appearance(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("Appearance"), DISPID(-520));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DMultimediaPlayDispT<T>::get_Appearance()
{
  static _TDispID _dispid(*this, OLETEXT("Appearance"), DISPID(-520));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DMultimediaPlayDispT<T>::set_BackColor(::OLE_COLOR /*[VT_UI4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("BackColor"), DISPID(-501));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> ::OLE_COLOR /*[VT_UI4:0]*/ __fastcall
_DMultimediaPlayDispT<T>::get_BackColor()
{
  static _TDispID _dispid(*this, OLETEXT("BackColor"), DISPID(-501));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DMultimediaPlayDispT<T>::set_BorderStyle(short /*[VT_I2:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("BorderStyle"), DISPID(-504));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> short /*[VT_I2:0]*/ __fastcall
_DMultimediaPlayDispT<T>::get_BorderStyle()
{
  static _TDispID _dispid(*this, OLETEXT("BorderStyle"), DISPID(-504));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DMultimediaPlayDispT<T>::set_AutoPlay(TOLEBOOL /*[VT_BOOL:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("AutoPlay"), DISPID(1));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> TOLEBOOL /*[VT_BOOL:0]*/ __fastcall
_DMultimediaPlayDispT<T>::get_AutoPlay()
{
  static _TDispID _dispid(*this, OLETEXT("AutoPlay"), DISPID(1));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DMultimediaPlayDispT<T>::set_ControlBar(TOLEBOOL /*[VT_BOOL:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("ControlBar"), DISPID(2));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> TOLEBOOL /*[VT_BOOL:0]*/ __fastcall
_DMultimediaPlayDispT<T>::get_ControlBar()
{
  static _TDispID _dispid(*this, OLETEXT("ControlBar"), DISPID(2));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DMultimediaPlayDispT<T>::set_StatusBar(TOLEBOOL /*[VT_BOOL:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("StatusBar"), DISPID(3));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> TOLEBOOL /*[VT_BOOL:0]*/ __fastcall
_DMultimediaPlayDispT<T>::get_StatusBar()
{
  static _TDispID _dispid(*this, OLETEXT("StatusBar"), DISPID(3));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DMultimediaPlayDispT<T>::set_Effect(Gkmbbplylib_tlb::EffectConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("Effect"), DISPID(4));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbbplylib_tlb::EffectConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbbplylib_tlb::EffectConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DMultimediaPlayDispT<T>::get_Effect()
{
  static _TDispID _dispid(*this, OLETEXT("Effect"), DISPID(4));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbbplylib_tlb::EffectConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DMultimediaPlayDispT<T>::set_PlayCount(long /*[VT_I4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("PlayCount"), DISPID(5));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> long /*[VT_I4:0]*/ __fastcall
_DMultimediaPlayDispT<T>::get_PlayCount()
{
  static _TDispID _dispid(*this, OLETEXT("PlayCount"), DISPID(5));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DMultimediaPlayDispT<T>::set_ScrollBar(TOLEBOOL /*[VT_BOOL:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("ScrollBar"), DISPID(6));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> TOLEBOOL /*[VT_BOOL:0]*/ __fastcall
_DMultimediaPlayDispT<T>::get_ScrollBar()
{
  static _TDispID _dispid(*this, OLETEXT("ScrollBar"), DISPID(6));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DMultimediaPlayDispT<T>::set_TrackBar(TOLEBOOL /*[VT_BOOL:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("TrackBar"), DISPID(7));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> TOLEBOOL /*[VT_BOOL:0]*/ __fastcall
_DMultimediaPlayDispT<T>::get_TrackBar()
{
  static _TDispID _dispid(*this, OLETEXT("TrackBar"), DISPID(7));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DMultimediaPlayDispT<T>::set_ViewStyle(Gkmbbplylib_tlb::ViewStyleConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("ViewStyle"), DISPID(8));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbbplylib_tlb::ViewStyleConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbbplylib_tlb::ViewStyleConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DMultimediaPlayDispT<T>::get_ViewStyle()
{
  static _TDispID _dispid(*this, OLETEXT("ViewStyle"), DISPID(8));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbbplylib_tlb::ViewStyleConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DMultimediaPlayDispT<T>::set_MediaType(Gkmbbplylib_tlb::MediaTypeConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("MediaType"), DISPID(9));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbbplylib_tlb::MediaTypeConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbbplylib_tlb::MediaTypeConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DMultimediaPlayDispT<T>::get_MediaType()
{
  static _TDispID _dispid(*this, OLETEXT("MediaType"), DISPID(9));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbbplylib_tlb::MediaTypeConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DMultimediaPlayDispT<T>::set_FileName(BSTR /*[VT_BSTR:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("FileName"), DISPID(10));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> BSTR /*[VT_BSTR:0]*/ __fastcall
_DMultimediaPlayDispT<T>::get_FileName()
{
  static _TDispID _dispid(*this, OLETEXT("FileName"), DISPID(10));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DMultimediaPlayDispT<T>::set_MediaFormat(Gkmbbplylib_tlb::MediaFormatConstants /*[VT_USERDEFINED:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("MediaFormat"), DISPID(11));
  TAutoArgs<1> _args;
  _args[1] = (int) /*[VT_I4:0]*/ (Gkmbbplylib_tlb::MediaFormatConstants /*[VT_USERDEFINED:0]*/)Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> Gkmbbplylib_tlb::MediaFormatConstants /*[VT_USERDEFINED:0]*/ __fastcall
_DMultimediaPlayDispT<T>::get_MediaFormat()
{
  static _TDispID _dispid(*this, OLETEXT("MediaFormat"), DISPID(11));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return (Gkmbbplylib_tlb::MediaFormatConstants /*[VT_USERDEFINED:0]*/)(int)_args.GetRetVariant();
}

template <class T> void __fastcall
_DMultimediaPlayDispT<T>::set_ReadyState(long /*[VT_I4:0]*/ Value)
{
  static _TDispID _dispid(*this, OLETEXT("ReadyState"), DISPID(-525));
  TAutoArgs<1> _args;
  _args[1] = Value;
  OlePropertyPut(_dispid, _args);
}

template <class T> long /*[VT_I4:0]*/ __fastcall
_DMultimediaPlayDispT<T>::get_ReadyState()
{
  static _TDispID _dispid(*this, OLETEXT("ReadyState"), DISPID(-525));
  TAutoArgs<0> _args;
  OlePropertyGet(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DMultimediaPlayDispT<T>::Pause()
{
  static _TDispID _dispid(*this, OLETEXT("Pause"), DISPID(12));
  TAutoArgs<0> _args;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DMultimediaPlayDispT<T>::Play()
{
  static _TDispID _dispid(*this, OLETEXT("Play"), DISPID(13));
  TAutoArgs<0> _args;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DMultimediaPlayDispT<T>::Stop()
{
  static _TDispID _dispid(*this, OLETEXT("Stop"), DISPID(14));
  TAutoArgs<0> _args;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> short __fastcall
_DMultimediaPlayDispT<T>::GetErrorCode()
{
  static _TDispID _dispid(*this, OLETEXT("GetErrorCode"), DISPID(15));
  TAutoArgs<0> _args;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> TOLEBOOL __fastcall
_DMultimediaPlayDispT<T>::SetMemHandle(OLE_HANDLE MemHandle, long MemSize)
{
  static _TDispID _dispid(*this, OLETEXT("SetMemHandle"), DISPID(16));
  TAutoArgs<2> _args;
  _args[1] = MemHandle /*[VT_INT:0]*/;
  _args[2] = MemSize /*[VT_I4:0]*/;
  OleFunction(_dispid, _args);
  return _args.GetRetVariant();
}

template <class T> void __fastcall
_DMultimediaPlayDispT<T>::Refresh()
{
  static _TDispID _dispid(*this, OLETEXT("Refresh"), DISPID(-550));
  OleProcedure(_dispid);
}

template <class T> void __fastcall
_DMultimediaPlayDispT<T>::AboutBox()
{
  static _TDispID _dispid(*this, OLETEXT("AboutBox"), DISPID(-552));
  OleProcedure(_dispid);
}

// *********************************************************************//
// DispIntf:  _DMultimediaPlayEvents
// Flags:     (4096) Dispatchable
// GUID:      {6FF40885-BC82-11D2-A590-00A0C92509F5}
// *********************************************************************//
template <class T> void __fastcall
_DMultimediaPlayEventsDispT<T>::ReadyStateChange()
{
  static _TDispID _dispid(/* ReadyStateChange */ DISPID(-609));
  OleProcedure(_dispid);
}

template <class T> void __fastcall
_DMultimediaPlayEventsDispT<T>::Click()
{
  static _TDispID _dispid(/* Click */ DISPID(-600));
  OleProcedure(_dispid);
}

template <class T> void __fastcall
_DMultimediaPlayEventsDispT<T>::DblClick()
{
  static _TDispID _dispid(/* DblClick */ DISPID(-601));
  OleProcedure(_dispid);
}

template <class T> void __fastcall
_DMultimediaPlayEventsDispT<T>::Error(short Number, BSTR* Description, long Scode, BSTR Source, 
                                      BSTR HelpFile, long HelpContext, TOLEBOOL* CancelDisplay)
{
  static _TDispID _dispid(/* Error */ DISPID(-608));
  TAutoArgs<7> _args;
  _args[1] = Number /*[VT_I2:0]*/;
  _args[2] = Description /*[VT_BSTR:1]*/;
  _args[3] = Scode /*[VT_I4:0]*/;
  _args[4] = Source /*[VT_BSTR:0]*/;
  _args[5] = HelpFile /*[VT_BSTR:0]*/;
  _args[6] = HelpContext /*[VT_I4:0]*/;
  _args[7] = CancelDisplay /*[VT_BOOL:1]*/;
  OleProcedure(_dispid, _args);
}

template <class T> void __fastcall
_DMultimediaPlayEventsDispT<T>::KeyDown(short* KeyCode, short Shift)
{
  static _TDispID _dispid(/* KeyDown */ DISPID(-602));
  TAutoArgs<2> _args;
  _args[1] = KeyCode /*[VT_I2:1]*/;
  _args[2] = Shift /*[VT_I2:0]*/;
  OleProcedure(_dispid, _args);
}

template <class T> void __fastcall
_DMultimediaPlayEventsDispT<T>::KeyUp(short* KeyCode, short Shift)
{
  static _TDispID _dispid(/* KeyUp */ DISPID(-604));
  TAutoArgs<2> _args;
  _args[1] = KeyCode /*[VT_I2:1]*/;
  _args[2] = Shift /*[VT_I2:0]*/;
  OleProcedure(_dispid, _args);
}

template <class T> void __fastcall
_DMultimediaPlayEventsDispT<T>::MouseDown(short Button, short Shift, OLE_XPOS_PIXELS x, 
                                          OLE_YPOS_PIXELS y)
{
  static _TDispID _dispid(/* MouseDown */ DISPID(-605));
  TAutoArgs<4> _args;
  _args[1] = Button /*[VT_I2:0]*/;
  _args[2] = Shift /*[VT_I2:0]*/;
  _args[3] = x /*[VT_I4:0]*/;
  _args[4] = y /*[VT_I4:0]*/;
  OleProcedure(_dispid, _args);
}

template <class T> void __fastcall
_DMultimediaPlayEventsDispT<T>::MouseMove(short Button, short Shift, OLE_XPOS_PIXELS x, 
                                          OLE_YPOS_PIXELS y)
{
  static _TDispID _dispid(/* MouseMove */ DISPID(-606));
  TAutoArgs<4> _args;
  _args[1] = Button /*[VT_I2:0]*/;
  _args[2] = Shift /*[VT_I2:0]*/;
  _args[3] = x /*[VT_I4:0]*/;
  _args[4] = y /*[VT_I4:0]*/;
  OleProcedure(_dispid, _args);
}

template <class T> void __fastcall
_DMultimediaPlayEventsDispT<T>::MouseUp(short Button, short Shift, OLE_XPOS_PIXELS x, 
                                        OLE_YPOS_PIXELS y)
{
  static _TDispID _dispid(/* MouseUp */ DISPID(-607));
  TAutoArgs<4> _args;
  _args[1] = Button /*[VT_I2:0]*/;
  _args[2] = Shift /*[VT_I2:0]*/;
  _args[3] = x /*[VT_I4:0]*/;
  _args[4] = y /*[VT_I4:0]*/;
  OleProcedure(_dispid, _args);
}

template <class T> void __fastcall
_DMultimediaPlayEventsDispT<T>::Notify(short NotifyCode)
{
  static _TDispID _dispid(/* Notify */ DISPID(1));
  TAutoArgs<1> _args;
  _args[1] = NotifyCode /*[VT_I2:0]*/;
  OleProcedure(_dispid, _args);
}

#endif  //   __TLB_NO_INTERFACE_WRAPPERS


#if !defined(__TLB_NO_EVENT_WRAPPERS) && defined(USING_ATLVCL)
// *********************************************************************//
// CONNECTIONPOINT/EVENT PROXY
// CoClass         : MultimediaPlay
// Event Interface : _DMultimediaPlayEvents
// *********************************************************************//
template <class T>
class TEvents_MultimediaPlay : public IConnectionPointImpl<T,
                                                 &DIID__DMultimediaPlayEvents,
                                                 CComUnkArray<CONNECTIONPOINT_ARRAY_SIZE> >
{
public:
  void            Fire_ReadyStateChange(void);
  void            Fire_Click(void);
  void            Fire_DblClick(void);
  void            Fire_Error(short Number, BSTR* Description, long Scode, BSTR Source, BSTR HelpFile, 
                             long HelpContext, TOLEBOOL* CancelDisplay);
  void            Fire_KeyDown(short* KeyCode, short Shift);
  void            Fire_KeyUp(short* KeyCode, short Shift);
  void            Fire_MouseDown(short Button, short Shift, OLE_XPOS_PIXELS x, OLE_YPOS_PIXELS y);
  void            Fire_MouseMove(short Button, short Shift, OLE_XPOS_PIXELS x, OLE_YPOS_PIXELS y);
  void            Fire_MouseUp(short Button, short Shift, OLE_XPOS_PIXELS x, OLE_YPOS_PIXELS y);
  void            Fire_Notify(short NotifyCode);
protected:
  _DMultimediaPlayEventsDisp m_EventIntfObj;
};

template <class T> void
TEvents_MultimediaPlay<T>::Fire_ReadyStateChange(void)
{
  T * pT = (T*)this;
  pT->Lock();
  IUnknown ** pp = m_vec.begin();
  while (pp < m_vec.end())
  {
    if (*pp != NULL)
    {
      m_EventIntfObj.Attach(*pp);
      m_EventIntfObj.ReadyStateChange();
      m_EventIntfObj.Attach(0);
    }
    pp++;
  }
  pT->Unlock();
}

template <class T> void
TEvents_MultimediaPlay<T>::Fire_Click(void)
{
  T * pT = (T*)this;
  pT->Lock();
  IUnknown ** pp = m_vec.begin();
  while (pp < m_vec.end())
  {
    if (*pp != NULL)
    {
      m_EventIntfObj.Attach(*pp);
      m_EventIntfObj.Click();
      m_EventIntfObj.Attach(0);
    }
    pp++;
  }
  pT->Unlock();
}

template <class T> void
TEvents_MultimediaPlay<T>::Fire_DblClick(void)
{
  T * pT = (T*)this;
  pT->Lock();
  IUnknown ** pp = m_vec.begin();
  while (pp < m_vec.end())
  {
    if (*pp != NULL)
    {
      m_EventIntfObj.Attach(*pp);
      m_EventIntfObj.DblClick();
      m_EventIntfObj.Attach(0);
    }
    pp++;
  }
  pT->Unlock();
}

template <class T> void
TEvents_MultimediaPlay<T>::Fire_Error(short Number, BSTR* Description, long Scode, BSTR Source, 
                                      BSTR HelpFile, long HelpContext, TOLEBOOL* CancelDisplay)
{
  T * pT = (T*)this;
  pT->Lock();
  IUnknown ** pp = m_vec.begin();
  while (pp < m_vec.end())
  {
    if (*pp != NULL)
    {
      m_EventIntfObj.Attach(*pp);
      m_EventIntfObj.Error(Number, Description, Scode, Source, HelpFile, HelpContext, CancelDisplay);
      m_EventIntfObj.Attach(0);
    }
    pp++;
  }
  pT->Unlock();
}

template <class T> void
TEvents_MultimediaPlay<T>::Fire_KeyDown(short* KeyCode, short Shift)
{
  T * pT = (T*)this;
  pT->Lock();
  IUnknown ** pp = m_vec.begin();
  while (pp < m_vec.end())
  {
    if (*pp != NULL)
    {
      m_EventIntfObj.Attach(*pp);
      m_EventIntfObj.KeyDown(KeyCode, Shift);
      m_EventIntfObj.Attach(0);
    }
    pp++;
  }
  pT->Unlock();
}

template <class T> void
TEvents_MultimediaPlay<T>::Fire_KeyUp(short* KeyCode, short Shift)
{
  T * pT = (T*)this;
  pT->Lock();
  IUnknown ** pp = m_vec.begin();
  while (pp < m_vec.end())
  {
    if (*pp != NULL)
    {
      m_EventIntfObj.Attach(*pp);
      m_EventIntfObj.KeyUp(KeyCode, Shift);
      m_EventIntfObj.Attach(0);
    }
    pp++;
  }
  pT->Unlock();
}

template <class T> void
TEvents_MultimediaPlay<T>::Fire_MouseDown(short Button, short Shift, OLE_XPOS_PIXELS x, 
                                          OLE_YPOS_PIXELS y)
{
  T * pT = (T*)this;
  pT->Lock();
  IUnknown ** pp = m_vec.begin();
  while (pp < m_vec.end())
  {
    if (*pp != NULL)
    {
      m_EventIntfObj.Attach(*pp);
      m_EventIntfObj.MouseDown(Button, Shift, x, y);
      m_EventIntfObj.Attach(0);
    }
    pp++;
  }
  pT->Unlock();
}

template <class T> void
TEvents_MultimediaPlay<T>::Fire_MouseMove(short Button, short Shift, OLE_XPOS_PIXELS x, 
                                          OLE_YPOS_PIXELS y)
{
  T * pT = (T*)this;
  pT->Lock();
  IUnknown ** pp = m_vec.begin();
  while (pp < m_vec.end())
  {
    if (*pp != NULL)
    {
      m_EventIntfObj.Attach(*pp);
      m_EventIntfObj.MouseMove(Button, Shift, x, y);
      m_EventIntfObj.Attach(0);
    }
    pp++;
  }
  pT->Unlock();
}

template <class T> void
TEvents_MultimediaPlay<T>::Fire_MouseUp(short Button, short Shift, OLE_XPOS_PIXELS x, 
                                        OLE_YPOS_PIXELS y)
{
  T * pT = (T*)this;
  pT->Lock();
  IUnknown ** pp = m_vec.begin();
  while (pp < m_vec.end())
  {
    if (*pp != NULL)
    {
      m_EventIntfObj.Attach(*pp);
      m_EventIntfObj.MouseUp(Button, Shift, x, y);
      m_EventIntfObj.Attach(0);
    }
    pp++;
  }
  pT->Unlock();
}

template <class T> void
TEvents_MultimediaPlay<T>::Fire_Notify(short NotifyCode)
{
  T * pT = (T*)this;
  pT->Lock();
  IUnknown ** pp = m_vec.begin();
  while (pp < m_vec.end())
  {
    if (*pp != NULL)
    {
      m_EventIntfObj.Attach(*pp);
      m_EventIntfObj.Notify(NotifyCode);
      m_EventIntfObj.Attach(0);
    }
    pp++;
  }
  pT->Unlock();
}

#endif  //   __TLB_NO_EVENT_WRAPPERS

};     // namespace Gkmbbplylib_tlb

#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using  namespace Gkmbbplylib_tlb;
#endif

#pragma option pop

//#endif // __GKMBBPLYLib_TLB_h__

namespace Gkmbbplylib_tlb
{

// *********************************************************************//
// HelpString: GKit Multimedia Play Control Borland Edition
// Version:    2.0
// *********************************************************************//


// *********************************************************************//
// OCX PROXY CLASS DECLARATION
// Control Name     : TGKitMultimediaPlay
// Help String      : GKit Multimedia Play Control Borland Edition
// Default Interface: _DMultimediaPlay
// Def. Intf. Object: _DMultimediaPlayDisp
// Def. Intf. DISP? : Yes
// Event   Interface: _DMultimediaPlayEvents
// TypeFlags        : (38) CanCreate Licensed Control
// *********************************************************************//

// *********************************************************************//
// Definition of closures to allow VCL handlers to catch OCX events.    //
// *********************************************************************//
typedef void __fastcall (__closure * TGKitMultimediaPlayError)(System::TObject * Sender, 
                                                               short Number, 
                                                               void* Description_which_is_really_a_Ptr_to_BSTR, 
                                                               long Scode, BSTR Source, 
                                                               BSTR HelpFile, long HelpContext, 
                                                               void* CancelDisplay_which_is_really_a_Ptr_to_TOLEBOOL);
typedef void __fastcall (__closure * TGKitMultimediaPlayNotify)(System::TObject * Sender, 
                                                                short NotifyCode);
//+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
// Proxy class to host GKit Multimedia Play Control Borland Edition in CBuilder IDE/Applications.
//-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
class PACKAGE TGKitMultimediaPlay : public TOleControl
{
  OVERLOADED_PROP_METHODS;
  static TNoParam  OptParam;
  static GUID      DEF_CTL_INTF;

  // Instance of Closures to expose OCX Events as VCL ones
  //
  TNotifyEvent                   FOnReadyStateChange;
  TGKitMultimediaPlayError       FOnError;
  TGKitMultimediaPlayNotify      FOnNotify;

  // Default Interace of OCX
  //
  _DMultimediaPlayDisp m_OCXIntf;

  // VCL Property Getters/Setters which delegate to OCX
  //

  // Static variables used by all instances of OCX proxy
  //
  static int          EventDispIDs[3];
  static WCHAR        wLicenseKey[101];
  static TControlData CControlData;
  static GUID         CTL_DEF_INTF;

  // Method providing access to interface as __property 
  //
  _DMultimediaPlayDisp __fastcall GetControlInterface(void);

protected:
  void     __fastcall CreateControl  (void);
  void     __fastcall InitControlData(void);

public:
  virtual  __fastcall TGKitMultimediaPlay(TComponent* AOwner) : TOleControl(AOwner)
  {};
  virtual  __fastcall TGKitMultimediaPlay(HWND        Parent) : TOleControl(Parent)
  {};

  // OCX methods
  //
  TOLEBOOL        __fastcall Pause(void);
  TOLEBOOL        __fastcall Play(void);
  TOLEBOOL        __fastcall Stop(void);
  short           __fastcall GetErrorCode(void);
  TOLEBOOL        __fastcall SetMemHandle(OLE_HANDLE MemHandle, long MemSize);
  void            __fastcall Refresh(void);
  void            __fastcall AboutBox(void);

  // OCX properties
  //
  __property _DMultimediaPlayDisp ControlInterface={ read=GetControlInterface };

  // Published properties
  //
__published:

  // Standard/Extended properties
  //
  __property ParentColor;
  __property TabStop;
  __property Align;
  __property DragCursor;
  __property DragMode;
  __property ParentShowHint;
  __property PopupMenu;
  __property ShowHint;
  __property TabOrder;
  __property Visible;
  __property OnDragDrop;
  __property OnDragOver;
  __property OnEndDrag;
  __property OnEnter;
  __property OnExit;
  __property OnStartDrag;
  __property OnMouseUp;
  __property OnMouseMove;
  __property OnMouseDown;
  __property OnKeyUp;
  __property OnKeyDown;
  __property OnDblClick;
  __property OnClick;

  // OCX properties
  //
  __property short Appearance={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=-520 };
  __property Graphics::TColor BackColor={ read=GetTColorProp, write=SetTColorProp, stored=false, index=-501 };
  __property short BorderStyle={ read=GetSmallintProp, write=SetSmallintProp, stored=false, index=-504 };
  __property bool AutoPlay={ read=GetWordBoolProp, write=SetWordBoolProp, stored=false, index=1 };
  __property bool ControlBar={ read=GetWordBoolProp, write=SetWordBoolProp, stored=false, index=2 };
  __property bool StatusBar={ read=GetWordBoolProp, write=SetWordBoolProp, stored=false, index=3 };
  __property TOleEnum Effect={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=4 };
  __property int PlayCount={ read=GetIntegerProp, write=SetIntegerProp, stored=false, index=5 };
  __property bool ScrollBar={ read=GetWordBoolProp, write=SetWordBoolProp, stored=false, index=6 };
  __property bool TrackBar={ read=GetWordBoolProp, write=SetWordBoolProp, stored=false, index=7 };
  __property TOleEnum ViewStyle={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=8 };
  __property TOleEnum MediaType={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=9 };
  __property System::WideString FileName={ read=GetWideStringProp, write=SetWideStringProp, stored=false, index=10 };
  __property TOleEnum MediaFormat={ read=GetTOleEnumProp, write=SetTOleEnumProp, stored=false, index=11 };
  __property int ReadyState={ read=GetIntegerProp, write=SetIntegerProp, stored=false, index=-525 };

  // OCX Events
  //
  __property TNotifyEvent OnReadyStateChange={ read=FOnReadyStateChange, write=FOnReadyStateChange };
  __property TGKitMultimediaPlayError OnError={ read=FOnError, write=FOnError };
  __property TGKitMultimediaPlayNotify OnNotify={ read=FOnNotify, write=FOnNotify };
};
typedef TGKitMultimediaPlay  TGKitMultimediaPlayProxy;

};     // namespace Gkmbbplylib_tlb

#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using  namespace Gkmbbplylib_tlb;
#endif

#pragma option pop

#endif // __GKMBBPLYLib_OCX_h__
